#if !defined(GLOBL_H_INCLUDED)
#define GLOBL_H_INCLUDED

#include "../snes9x/snes9x.h"

struct OOptions {
	unsigned char JPenvFlag;
	unsigned long JoyReadRateMask;
	unsigned long MaxWinJoyButtons;
	unsigned long CpuSleep;
//screenshot
	unsigned char SaveImagefileFormat;
	unsigned char ReduceTheColorTo256;
	unsigned char ReduceTheColorTo256IfWithin;
	unsigned char ImagefileHiresStretch;
	unsigned char RLEcompression256bitmap;

//SNES emulation settings
	short VolumeLevel;
	unsigned char GFXengine2;
	unsigned char APURAMInitialValue0;
	unsigned char APURAMInitialValue;
	unsigned char SRAMInitialValue;
	unsigned char RAMInitialValue; // Snes9xpp Original

	short Adjustwindow;
	short Full_Adjustwindow;

	short AltScreenEffect;
	
	short ScanLinesEffect;

//SNES debug settings
	unsigned char DisplayScreenBufferAll;
};

struct SSNESGameFix {
	unsigned char umiharakawaseFix;
	unsigned char alienVSpredetorFix;
	unsigned char APU_OutPorts_ReturnValueFix;
	unsigned char TouhaidenControllerFix;
	unsigned char SoundEnvelopeHeightReading2;

	unsigned char LetsPachi;
	unsigned char ShinnichiFix;
	unsigned char XPP_IRQVBeamPos;
	unsigned char PPU4212_Hack;
	unsigned char VoicerKun;
	unsigned char Uniracers;
	unsigned char APU_Disable;

//	unsigned char PPU2102_ObjFix;
};

struct XXppcode {
	unsigned char CheatNum;
	unsigned char CheatNumRock;
	unsigned char CheatNumRock_Old;
	unsigned char CheatFlag;
	unsigned char CheatNumBackFlag;
};

struct XXppcdda {
	unsigned char Enable;
	unsigned char Drv;

	uint8 Soundlink_cd_track;
	uint8 Max_Soundlink_cd_track;

	uint32 Sound_ShowTimer;

	unsigned char Sound_SyncFlag1;
	unsigned char Sound_SyncFlag2;
	unsigned char Sound_SyncFlag3;

	uint32 Sound_SyncFirstSec;
	uint32 Sound_SyncNowSec;

	uint32 Sound_SyncDiffSec;
	uint32 Sound_SyncOldDiffSec;

	uint32 Sound_SyncWaitSetSec;
	uint32 Sound_SyncWaitGetSec;
	uint32 Sound_SyncWaitSec;
	unsigned char Sound_SyncWaitFlag;

	uint8 Sound_NowTime;
	uint8 Sound_OldTime;
	uint16 Sound_StartTime;

	uint8 Sound_NowSec;
	uint8 Sound_OldSec;

	unsigned char Sound_SyncSpeed;

	unsigned char VoicerCDChange;

	unsigned char Cdda_Pause;

	uint32 Time_Now;
	uint32 Time_Sync;
	uint32 Time_Diff;

	uint32 Time_Sync_Fix;

};

struct XXppbsx {
	unsigned char BsxRomCheck;
	unsigned char Bszelda_Chr;
	unsigned char Bssound_Time;
};

struct XXppsystem {
	unsigned char Speedflag;
	unsigned char SpeedEnable;
	unsigned char SpeedPercent;
	unsigned char PassWord;
	unsigned char NormalSnap;
	unsigned char DisableIRQCycleCount;
	unsigned char DisableOutputSram;
	unsigned char OldAutoFrame;
	unsigned char XppkeyPage;
	unsigned char XppkeyHelp;
	unsigned char StatePage;
	unsigned char OldFrameTimer;
	unsigned char FontType;
	unsigned char InactivateWork;
};

struct XXppMovie {
    uint8 *REPLAY_RAM;
    uint32 REPLAY_RAM_COUNT;
    uint32 REPLAY_RAM_CHECK_COUNT;
    uint32 REPLAY_RAM_CHEAT_KEY_COUNT;
    uint32 REPLAY_RAM_COUNT_MAX;
    uint8 Replay_Version;
    bool8 Replay_status;
    uint8 Replay_Recode_Mode;
    uint16 Replay_count_fix;
    uint32 Replay_frame_count;
    uint32 Replay_frame_count_check;
    uint32 Replay_frame_count_max;
    uint32 Replay_frame_count_cheat;
    uint32 Replay_count;
    uint8 replay_data [12];
    uint8 replay_data_temp [12];
    uint8 replay_cheat_data [6];
    uint8 replay_data_dummy;
    uint32 replay_data_count;
    bool8 Def_NormalSnap;
    bool8 Replay_Type;
    bool8 Replay_Slot;
    uint8 Replay_Turbo_Count;
    uint8 Replay_Turbo_Count_Old;
    const char *movie_ext_snap [10];
    const char *movie_ext_trace [10];
    const char *resume_ext_snap [10];
    const char *resume_ext_trace [10];
    uint8 time_hour;
    uint8 time_min;
    uint8 time_sec;
    uint16 emu_speed;
    uint16 emu_speed_frame;
    uint8 emu_speed_sec_temp;
    bool8 file_open_error;
};

extern struct OOptions Options;
extern struct SSNESGameFix SNESGameFix;
extern struct XXppcode Xppcode;
extern struct XXppcdda Xppcdda;
extern struct XXppbsx Xppbsx;
extern struct XXppsystem Xppsystem;
extern struct XXppMovie XppMovie;
extern void S9xSwitchGFXengine(unsigned char engine2flag);

/*****************
 default settings
*****************/
#define OPTIONS_GFXENGINE2_DEF 1  // Snes9xpp Original
#define OPTIONS_JOYREADRATEMASK_DEF 0 // Snes9xpp Original
#define OPTIONS_SAVEIMAGEFILEFORMAT_DEF 0
#define OPTIONS_REDUCETHECOLORTO256_DEF 0
#define OPTIONS_REDUCETHECOLORTO256IFWITHIN_DEF 1
#define OPTIONS_IMAGEFILEHIRESSTRETCH_DEF 1
#define OPTIONS_DISPLAYSCREENBUFFERALL_DEF 0
#define OPTIONS_RLECOMPRESSION256BITMAP_DEF 0
#define OPTIONS_SDD1PACK 0
#define OPTIONS_DISABLE_IRQ_CYCLECOUNT 1

#define OPTIONS_XPP_CDDAENABLE 0
#define OPTIONS_XPP_CDDADRV 0
#define OPTIONS_XPP_NORMALSNAP 0


#endif /* GLOBL_H_INCLUDED */
