#include "../Snes9X/MemMap.H"
#include "DirectX.h"
#include "inidataW.h"
#include "joywin.h"

static int i, c;
static long H_Max_percentage = 100;
extern char ROMFileName[];
extern char InitialROMFileDirectory[];

extern char RecentROMFileName[];

extern char ScreenShotDirectory[];
extern char SPCDumpDirectory[];
extern bool8 TransparencyFlag;
extern bool8 DoubleRendering;
extern bool8 DoubleRendering_Full;
extern int DoubleRenderingModes16;
extern RECT WindowRectSetting;
extern long DefaultWindowSizeW;
extern long DefaultWindowSizeH;
extern int FullscreenDisplayModeIndexDouble16;
extern unsigned char dRendering;
extern unsigned char ForceWindowedDirectDrawClipper;

static bool CannotCreateIniFlag = 0;
static char IniFileName[_MAX_PATH];
static char tmpCharBuf[_MAX_PATH];

//iniXVpRevID
static UINT RevID = 115;

/* SJIS֐ */
bool IsSJIS(unsigned char *cc)
{
    if((cc[0] >= 0x81 && cc[0] <= 0x9f) || (cc[0] >= 0xe0 && cc[0] <= 0xfc)) {
        if((cc[1] >= 0x40 && cc[1] <= 0x7e) || (cc[1] >= 0x80 && cc[1] <= 0xfc))
            return 1;
        return 0;
    }
    return 0;
}

void char_change(char *str, char target, char val)
{
    int count = 0;
    int len;
    len = strlen(str);
    while(count < len) {
        if(IsSJIS((unsigned char *)&str[count]))
            count += 2;
        else if(str[count] == target) {
            str[count] = val;
            ++count;
        }
        else
            ++count;
    }
}

void SlashRemove(char *PathStr)
{
	int length = lstrlen(PathStr);
	char_change(PathStr, '\\', '/');
	if(PathStr[length - 1] == '/')
		PathStr[length - 1] = 0;
	char_change(PathStr, '/', '\\');
	return;
}

void SlashAdd(char *PathStr)
{
	if(PathStr[1] == ':'  && PathStr[2] == 0) {
		PathStr[2] = '\\';
		PathStr[3] = 0;
	}
}

void RemoveFileName(char *PathStr)
{
	char *CharP;
	char_change(PathStr, '\\', '/');
	if((CharP = strrchr(PathStr, '/'))) {
		*CharP = 0;
		SlashAdd(PathStr);
	}
	char_change(PathStr, '/', '\\');
}

void ReadIniFile()
{
	FILE *fp;
	//ǂݍ݃fBNgftHgݒ
	int len = lstrlen(__argv[0]);
	GetCurrentDirectory(_MAX_PATH - 7, ROMFileName);
	lstrcpy(InitialROMFileDirectory, ROMFileName);

	//hCũ[gfBNg̏ꍇ͕Ō̃pX؂폜
	SlashRemove(ROMFileName);
	lstrcat(ROMFileName, "\\a.smc");

	//snapshotAScreenShotASPCfBNgftHgݒ
	GetCurrentDirectory(_MAX_PATH - 10, GUI.FreezeFileDir);
	SlashRemove(GUI.FreezeFileDir);
	lstrcat(GUI.FreezeFileDir, "\\snesnaps");
	lstrcpy(ScreenShotDirectory, GUI.FreezeFileDir);
	lstrcpy(SPCDumpDirectory, GUI.FreezeFileDir);

	if(len >= _MAX_PATH) {
		CannotCreateIniFlag = 1;
		return;
	}
	//init@CtpX
	lstrcpy(IniFileName, __argv[0]);
	lstrcpy(IniFileName + (len - 4), ".ini");

	//init@C݂邩ǂׂ
	if((int)GetFileAttributes(IniFileName) == -1) {
		//݂Ȃꍇ̏
		if((int)GetFileAttributes(GUI.FreezeFileDir) == -1)
			CreateDirectory(GUI.FreezeFileDir, 0);
		if(!(fp = fopen(IniFileName, "w"))) {
			CannotCreateIniFlag = 1;
			return;
		}
		fprintf(fp, Config_data);
		fclose(fp);
		return;
	}

	//[windows]ZNVݒǂݍ
	i = GetPrivateProfileInt(Inis.windows, "PriorityClass", 1, IniFileName);
	if(i == 0)
		GUI.PriorityClass = IDLE_PRIORITY_CLASS;
	else if(i == 1)
		GUI.PriorityClass = NORMAL_PRIORITY_CLASS;
	else if(i == 2)
		GUI.PriorityClass = HIGH_PRIORITY_CLASS;
	else if(i == 3)
		GUI.PriorityClass = REALTIME_PRIORITY_CLASS;

	i = GetPrivateProfileInt(Inis.windows, "ThreadPriority", 2, IniFileName);
	if(i == 0)
		GUI.ThreadPriority = THREAD_PRIORITY_LOWEST;
	else if(i == 1)
		GUI.ThreadPriority = THREAD_PRIORITY_BELOW_NORMAL;
	else if(i == 2)
		GUI.ThreadPriority = THREAD_PRIORITY_NORMAL;
	else if(i == 3)
		GUI.ThreadPriority = THREAD_PRIORITY_ABOVE_NORMAL;
	else if(i == 4)
		GUI.ThreadPriority = THREAD_PRIORITY_HIGHEST;
	else if(i == 5)
		GUI.ThreadPriority = THREAD_PRIORITY_IDLE;
	else if(i == 6)
		GUI.ThreadPriority = THREAD_PRIORITY_TIME_CRITICAL;

	//[graphics]ZNVݒǂݍ
	i = GetPrivateProfileInt(Inis.graphics, "Fullscreen", 0, IniFileName);
	GUI.FullScreen = (i ? 1 : 0);
	i = GetPrivateProfileInt(Inis.graphics, "FullscreenDisplayModeIndexDouble16", FullscreenDisplayModeIndexDouble16, IniFileName);
	FullscreenDisplayModeIndexDouble16 = ((i >= 0 && i <= 14) ? i : FullscreenDisplayModeIndexDouble16);
	i = GetPrivateProfileInt(Inis.graphics, "DoubleRenderingModes16", DoubleRenderingModes16, IniFileName);
	DoubleRenderingModes16 = ((i >= 1 && i <= 12) ? i : DoubleRenderingModes16);
	dRendering = (bool8)GetPrivateProfileInt(Inis.graphics, "DirectScreenRendering", (int)dRendering, IniFileName);
	DirectX.DisableHardwareScale = (unsigned char)GetPrivateProfileInt(Inis.graphics, "DisableHardwareScale", (int)DirectX.DisableHardwareScale, IniFileName);

	i = GetPrivateProfileInt(Inis.graphics, "DoubleBuffering", 0, IniFileName);
	GUI.DoubleBuffered = i ? 1 : 0;
	ForceWindowedDirectDrawClipper = (bool8)GetPrivateProfileInt(Inis.graphics, "ForceWindowedDirectDrawClipper", (int)ForceWindowedDirectDrawClipper, IniFileName);
	i = GetPrivateProfileInt(Inis.graphics, "OffScreenVRAM", 0, IniFileName);
	DirectX.OffScreenVRAM = i ? 1 : 0;
	i = GetPrivateProfileInt(Inis.graphics, "BackBufferVRAM", 0, IniFileName);
	DirectX.BackBufferVRAM = i ? 1 : 0;

	Options.GFXengine2 = (bool8)GetPrivateProfileInt(Inis.graphics, "GFXengine2", (int)Options.GFXengine2, IniFileName);

	TransparencyFlag = (bool8)GetPrivateProfileInt(Inis.graphics, "Transparency", (int)TransparencyFlag, IniFileName);
	Settings.BGLayering = (bool8)GetPrivateProfileInt(Inis.graphics, "BGLayering", (int)Settings.BGLayering, IniFileName);
	Settings.DisableGraphicWindows = (bool8)GetPrivateProfileInt(Inis.graphics, "DisableGraphicWindows", (int)Settings.DisableGraphicWindows, IniFileName);
	Settings.DisableHDMA = (bool8)GetPrivateProfileInt(Inis.graphics, "DisableHDMA", (int)Settings.DisableHDMA, IniFileName);
	Settings.Mode7Interpolate = (bool8)GetPrivateProfileInt(Inis.graphics, "Mode7Interpolate", (int)Settings.Mode7Interpolate, IniFileName);
	i = GetPrivateProfileInt(Inis.graphics, "wait_for_vsync", 0, IniFileName);
	DirectX.wait_for_vsync = i ? 1 : 0;
	i = GetPrivateProfileInt(Inis.graphics, "stretch",GUI.Stretch, IniFileName);
	GUI.Stretch = ((i >= 0 && i <= 2) ? i : GUI.Stretch);
	i = GetPrivateProfileInt(Inis.graphics, "full_stretch",GUI.FullScreen_Stretch, IniFileName);
	GUI.FullScreen_Stretch = ((i >= 0 && i <= 2) ? i : GUI.FullScreen_Stretch);
	i = GetPrivateProfileInt(Inis.graphics, "adjustwindow",Options.Adjustwindow, IniFileName);
	Options.Adjustwindow = ((i >= 1 && i <= 23) ? i : Options.Adjustwindow);
	i = GetPrivateProfileInt(Inis.graphics, "full_adjustwindow",Options.Full_Adjustwindow, IniFileName);
	Options.Full_Adjustwindow = ((i >= 1 && i <= 23) ? i : Options.Full_Adjustwindow);
	Options.AltScreenEffect = (bool8)GetPrivateProfileInt(Inis.graphics, "AltScreenEffect", (int)Options.AltScreenEffect, IniFileName);
	i = GetPrivateProfileInt(Inis.graphics, "ScanLinesEffect",Options.ScanLinesEffect, IniFileName);
	Options.ScanLinesEffect = ((i >= 1 && i <= 5) ? i : Options.ScanLinesEffect);

	//[sound]ZNVݒǂݍ
	Settings.NextAPUEnabled = (bool8)GetPrivateProfileInt(Inis.sound, "APUEnabled", (int)Settings.NextAPUEnabled, IniFileName);
	i = GetPrivateProfileInt(Inis.sound, "SoundMode", (int)GUI.SoundMode, IniFileName);
	GUI.SoundMode = (char)((0 <= i && i <= 23) ? i : GUI.SoundMode);
	Settings.InterpolatedSound = (bool8)GetPrivateProfileInt(Inis.sound, "InterpolatedSound", (int)Settings.InterpolatedSound, IniFileName);
	i = GetPrivateProfileInt(Inis.sound, "SoundBufferLength", 1, IniFileName);
	Settings.SoundBufferSize = ((i >= 1 && i <= 7) ? (1 << (i - 1)) : Settings.SoundBufferSize);
	i = GetPrivateProfileInt(Inis.sound, "SoundMixInterval", Settings.SoundMixInterval / 10, IniFileName);
	Settings.SoundMixInterval = ((i >= 1 && i <= 15) ? (i * 10) : Settings.SoundMixInterval);
	Settings.SoundEnvelopeHeightReading = (bool8)GetPrivateProfileInt(Inis.sound, "SoundEnvelopeHeightReading", (int)Settings.SoundEnvelopeHeightReading, IniFileName);
	Settings.DisableMasterVolume = (bool8)GetPrivateProfileInt(Inis.sound, "DisableMasterVolume", (int)Settings.DisableMasterVolume, IniFileName);
	i = GetPrivateProfileInt(Inis.sound, "VolumeLevel", (int)Options.VolumeLevel, IniFileName);
	Options.VolumeLevel = (short)((i >= 1 && i <= 5) ? i : Options.VolumeLevel);
	Settings.ShutdownMaster = (bool8)!GetPrivateProfileInt(Inis.sound, "Shutdown", (int)!Settings.ShutdownMaster, IniFileName);
	i = GetPrivateProfileInt(Inis.sound, "SoundSkipMethod", (int)Settings.SoundSkipMethod, IniFileName);
	Settings.SoundSkipMethod = (uint8)((0 <= i && i <= 3) ? i : Settings.SoundSkipMethod);
	Settings.SoundSync = (uint8)GetPrivateProfileInt(Inis.sound, "SoundSync", (int)Settings.SoundSync, IniFileName);
	Settings.ReverseStereo = (uint8)GetPrivateProfileInt(Inis.sound, "ReverseStereo", (int)Settings.ReverseStereo, IniFileName);
	
	//[cpu]ZNVݒǂݍ
//	H_Max_percentage = (long)GetPrivateProfileInt(Inis.cpu, "H_Max", (int)H_Max_percentage, IniFileName);
//	Settings.H_Max = (H_Max_percentage * SNES_CYCLES_PER_SCANLINE / 100);
	H_Max_percentage = (long)GetPrivateProfileInt(Inis.cpu, "CyclesPercentage", (int)Settings.CyclesPercentage, IniFileName);
	Settings.CyclesPercentage = ((0 < H_Max_percentage && H_Max_percentage < 200) ? H_Max_percentage : Settings.CyclesPercentage);

	//[timer]ZNVݒǂݍ
	i = GetPrivateProfileInt(Inis.timer, "SkipFrames", (int)(Settings.SkipFrames == AUTO_FRAMERATE ? AUTO_FRAMERATE : (Settings.SkipFrames - 1)), IniFileName);
	if(i != AUTO_FRAMERATE && i >= 0 && i <= 9)
		Settings.SkipFrames = (uint32)i + 1;
	i = GetPrivateProfileInt(Inis.timer, "AutoMaxSkipFrames", (int)Settings.AutoMaxSkipFrames, IniFileName);
	Settings.AutoMaxSkipFrames = (uint32)((0 <= i && i <= 10) ? i : Settings.AutoMaxSkipFrames);
	i = GetPrivateProfileInt(Inis.timer, "TurboSkipFrames", (int)Settings.TurboSkipFrames, IniFileName);
	Settings.TurboSkipFrames = (uint32)((0 <= i && i <= 15) ? i : Settings.TurboSkipFrames);
	Settings.FrameTimeNTSC = (uint32)GetPrivateProfileInt(Inis.timer, "NTSCtiming", (int)Settings.FrameTimeNTSC, IniFileName);
	Settings.FrameTimePAL = (uint32)GetPrivateProfileInt(Inis.timer, "PALtiming", (int)Settings.FrameTimePAL, IniFileName);

	//[ControllerOption]ZNVݒǂݍ
	Settings.Mouse = (uint8)GetPrivateProfileInt(Inis.ControllerOption, "SnesMouse", (int)Settings.Mouse, IniFileName);
	Settings.SuperScope = (uint8)GetPrivateProfileInt(Inis.ControllerOption, "SnesSuperScope", (int)Settings.SuperScope, IniFileName);
	Settings.MultiPlayer5 = (uint8)GetPrivateProfileInt(Inis.ControllerOption, "SnesMultiPlayer5", (int)Settings.MultiPlayer5, IniFileName);
	Settings.Justifier = (uint8)GetPrivateProfileInt(Inis.ControllerOption, "SnesJustifier", (int)Settings.Justifier, IniFileName);
	i = GetPrivateProfileInt(Inis.ControllerOption, "DefaultPlugedInputDevice", (int)Settings.ControllerOption, IniFileName);
	if(i == 0 && Settings.MultiPlayer5)
		Settings.ControllerOption = SNES_MULTIPLAYER5;
	else if(i == 1)
		Settings.ControllerOption = SNES_JOYPAD;
	else if(i == 2 && Settings.Mouse)
		Settings.ControllerOption = SNES_MOUSE_SWAPPED;
	else if(i == 3 && Settings.Mouse)
		Settings.ControllerOption = SNES_MOUSE;
	else if(i == 4 && Settings.SuperScope)
		Settings.ControllerOption = SNES_SUPERSCOPE;
	else if(i == 5 && Settings.Justifier)
		Settings.ControllerOption = SNES_JUSTIFIER;
	else
		Settings.ControllerOption = SNES_JOYPAD;

	i = GetPrivateProfileInt(Inis.ControllerOption, "JoyReadRate", (int)(Options.JoyReadRateMask + 1), IniFileName);
	Options.JoyReadRateMask = (unsigned long)((i == 1 || i == 2 || i == 4 || i == 8) ? (i - 1) : Options.JoyReadRateMask);
	DirectX.DIuse = (unsigned char)GetPrivateProfileInt(Inis.ControllerOption, "DirectInput", (int)DirectX.DIuse, IniFileName);

	i = GetPrivateProfileInt(Inis.ControllerOption, "MaxWinJoyButtons", (int)Options.MaxWinJoyButtons, IniFileName);
	Options.MaxWinJoyButtons = (uint32)((0 <= i && i <= 32) ? i : Options.MaxWinJoyButtons);

	MapFunc[0] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode0", (int)MapFunc[0], IniFileName);
	MapFunc[1] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode1", (int)MapFunc[1], IniFileName);
	MapFunc[2] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode2", (int)MapFunc[2], IniFileName);
	MapFunc[3] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode3", (int)MapFunc[3], IniFileName);

	MapFunc[4] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode4", (int)MapFunc[4], IniFileName);
	MapFunc[5] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode5", (int)MapFunc[5], IniFileName);
	MapFunc[6] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode6", (int)MapFunc[6], IniFileName);
	MapFunc[7] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode7", (int)MapFunc[7], IniFileName);
	MapFunc[8] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode8", (int)MapFunc[8], IniFileName);
	MapFunc[9] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode9", (int)MapFunc[9], IniFileName);
	MapFunc[10] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode10", (int)MapFunc[10], IniFileName);
	MapFunc[11] = (DWORD)GetPrivateProfileInt(Inis.ControllerOption, "JoyKeyMappedFunctionCode11", (int)MapFunc[11], IniFileName);

	//[joypad1 2 3 4 5]ZNVݒǂݍ
	for(i = 0; i < 5; i++) {
		Joypad[i].Enabled = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[0], (int)Joypad[i].Enabled, IniFileName) ? TRUE : FALSE);
		Joypad[i].Left = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[1], (int)Joypad[i].Left, IniFileName);
		Joypad[i].Right = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[2], (int)Joypad[i].Right, IniFileName);
		Joypad[i].Up = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[3], (int)Joypad[i].Up, IniFileName);
		Joypad[i].Down = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[4], (int)Joypad[i].Down, IniFileName);
		Joypad[i].Start = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[5], (int)Joypad[i].Start, IniFileName);
		Joypad[i].Select = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[6], (int)Joypad[i].Select, IniFileName);
		Joypad[i].A = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[7], (int)Joypad[i].A, IniFileName);
		Joypad[i].B = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[8], (int)Joypad[i].B, IniFileName);
		Joypad[i].X = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[9], (int)Joypad[i].X, IniFileName);
		Joypad[i].Y = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[10], (int)Joypad[i].Y, IniFileName);
		Joypad[i].L = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[11], (int)Joypad[i].L, IniFileName);
		Joypad[i].R = (WORD)GetPrivateProfileInt(Inis.joypad[i], Key_button_str[12], (int)Joypad[i].R, IniFileName);
		Joypad[i].Turbo_Left = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[13], (int)Joypad[i].Turbo_Left, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_Right = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[14], (int)Joypad[i].Turbo_Right, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_Up = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[15], (int)Joypad[i].Turbo_Up, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_Down = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[16], (int)Joypad[i].Turbo_Down, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_Start = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[17], (int)Joypad[i].Turbo_Start, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_Select = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[18], (int)Joypad[i].Turbo_Select, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_A = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[19], (int)Joypad[i].Turbo_A, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_B = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[20], (int)Joypad[i].Turbo_B, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_X = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[21], (int)Joypad[i].Turbo_X, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_Y = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[22], (int)Joypad[i].Turbo_Y, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_L = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[23], (int)Joypad[i].Turbo_L, IniFileName) ? TRUE : FALSE);
		Joypad[i].Turbo_R = (GetPrivateProfileInt(Inis.joypad[i], Key_button_str[24], (int)Joypad[i].Turbo_R, IniFileName) ? TRUE : FALSE);
	}

    //[gui]ZNVݒǂݍ
	lstrcpy(tmpCharBuf, ROMFileName);
	GetPrivateProfileString(Inis.gui, "LastROMFileName", tmpCharBuf, ROMFileName, _MAX_PATH, IniFileName);
	if(ROMFileName[0])
		lstrcpy(InitialROMFileDirectory, ROMFileName);
	else {
		lstrcpy(ROMFileName, tmpCharBuf);
		lstrcpy(InitialROMFileDirectory, ROMFileName);
	}
	RemoveFileName(InitialROMFileDirectory);

	tmpCharBuf[0] = 0;
	lstrcpy(&tmpCharBuf[1], "RecentROMFileName1");
	for(i = 0; i < 10; i++) {
		wsprintf(&tmpCharBuf[18], "%X", i + 1);
		GetPrivateProfileString(Inis.gui, &tmpCharBuf[1], tmpCharBuf, &RecentROMFileName[_MAX_PATH * i], _MAX_PATH, IniFileName);
	}
	GetPrivateProfileString(Inis.gui, "SnapShotDirectory", GUI.FreezeFileDir, tmpCharBuf, _MAX_PATH, IniFileName);

	if((int)GetFileAttributes(tmpCharBuf) != -1)
		lstrcpy(GUI.FreezeFileDir, tmpCharBuf);
	else if((int)GetFileAttributes(GUI.FreezeFileDir) == -1)
		CreateDirectory(GUI.FreezeFileDir, 0);
	SlashRemove(GUI.FreezeFileDir);

	GetPrivateProfileString(Inis.gui, "ScreenShotDirectory", ScreenShotDirectory, tmpCharBuf, _MAX_PATH, IniFileName);

	if((int)GetFileAttributes(tmpCharBuf) != -1)
		lstrcpy(ScreenShotDirectory, tmpCharBuf);
	else if((int)GetFileAttributes(ScreenShotDirectory) == -1)
		CreateDirectory(ScreenShotDirectory, 0);
	SlashRemove(ScreenShotDirectory);

	GetPrivateProfileString(Inis.gui, "SPCDumpDirectory", SPCDumpDirectory, tmpCharBuf, _MAX_PATH, IniFileName);

	if((int)GetFileAttributes(tmpCharBuf) != -1)
		lstrcpy(SPCDumpDirectory, tmpCharBuf);
	else if((int)GetFileAttributes(SPCDumpDirectory) == -1)
		CreateDirectory(SPCDumpDirectory, 0);
	SlashRemove(SPCDumpDirectory);

	i = GetPrivateProfileInt(Inis.gui, "Language", GUI.Language, IniFileName);
	GUI.Language = (BYTE)((i == 1 || i == 0) ? i : GUI.Language);

	WindowRectSetting.left = GetPrivateProfileInt(Inis.gui, "WindowRectLeft", -0x7fffffff, IniFileName);
	WindowRectSetting.right = GetPrivateProfileInt(Inis.gui, "WindowRectRight", -0x7fffffff, IniFileName);
	WindowRectSetting.top = GetPrivateProfileInt(Inis.gui, "WindowRectTop", -0x7fffffff, IniFileName);
	WindowRectSetting.bottom = GetPrivateProfileInt(Inis.gui, "WindowRectBottom", -0x7fffffff, IniFileName);
	if(WindowRectSetting.left == -0x7fffffff || WindowRectSetting.right == -0x7fffffff || WindowRectSetting.top == -0x7fffffff || WindowRectSetting.bottom == -0x7fffffff)
		WindowRectSetting.left = WindowRectSetting.right = WindowRectSetting.top = WindowRectSetting.bottom = -1;
	else {
		if((WindowRectSetting.right - WindowRectSetting.left) < DefaultWindowSizeW)
			WindowRectSetting.right = (WindowRectSetting.left + DefaultWindowSizeW);
		if((WindowRectSetting.bottom - WindowRectSetting.top) < DefaultWindowSizeH)
			WindowRectSetting.bottom = (WindowRectSetting.top + DefaultWindowSizeH);
	}

	//[screenshot]ZNVݒǂݍ
	i = GetPrivateProfileInt(Inis.screenshot, "SaveImagefileFormat", (int)Options.SaveImagefileFormat, IniFileName);
	Options.SaveImagefileFormat = (uint8)((0 <= i && i <= 3) ? i : Options.SaveImagefileFormat);
//	Options.ReduceTheColorTo256 = (uint8)GetPrivateProfileInt(Inis.screenshot, "ReduceTheColorTo256", (int)Options.ReduceTheColorTo256, IniFileName);
	Options.ReduceTheColorTo256IfWithin = (uint8)GetPrivateProfileInt(Inis.screenshot, "ReduceTheColorTo256IfWithin", (int)Options.ReduceTheColorTo256IfWithin, IniFileName);
	Options.ImagefileHiresStretch = (uint8)GetPrivateProfileInt(Inis.screenshot, "ImagefileHiresStretch", (int)Options.ImagefileHiresStretch, IniFileName);
	Options.RLEcompression256bitmap = (uint8)GetPrivateProfileInt(Inis.screenshot, "RLEcompression256bitmap", (int)Options.RLEcompression256bitmap, IniFileName);

	//[debug]ZNVݒǂݍ
	Options.DisplayScreenBufferAll = (uint8)GetPrivateProfileInt(Inis.debug, "DisplayScreenBufferAll", (int)Options.DisplayScreenBufferAll, IniFileName);

	//[option]ZNVݒǂݍ
	Settings.ApplyCheats = (bool8)GetPrivateProfileInt(Inis.option, "ApplyCheats", (int)Settings.ApplyCheats, IniFileName);
	Settings.DisplayFrameRate = (bool8)GetPrivateProfileInt(Inis.option, "ShowFPS", (int)Settings.DisplayFrameRate, IniFileName);
	Settings.Mute = (bool8)GetPrivateProfileInt(Inis.option, "MuteSound", (int)Settings.Mute, IniFileName);

	Settings.AutoSaveDelay = (int32)GetPrivateProfileInt(Inis.option, "AutoSaveDelay", (int)Settings.AutoSaveDelay, IniFileName);
	Xppsystem.NormalSnap = (bool8)GetPrivateProfileInt(Inis.option, "NormalSnap", (int)Xppsystem.NormalSnap, IniFileName);
	Settings.SDD1Pack = (bool8)GetPrivateProfileInt(Inis.option, "SDD1Pack", (int)Settings.SDD1Pack, IniFileName);
	Xppsystem.DisableIRQCycleCount = (bool8)GetPrivateProfileInt(Inis.option, "DisableIRQCycleCount", (int)Xppsystem.DisableIRQCycleCount, IniFileName);
	Xppsystem.OldAutoFrame = (bool8)GetPrivateProfileInt(Inis.option, "OldAutoFrame", (int)Xppsystem.OldAutoFrame, IniFileName);
	Xppsystem.DisableOutputSram = (bool8)GetPrivateProfileInt(Inis.option, "DisableOutputSram", (int)Xppsystem.DisableOutputSram, IniFileName);
	Options.CpuSleep = (bool8)GetPrivateProfileInt(Inis.option, "CpuSleep", (int)Options.CpuSleep, IniFileName);
	CPU.DisableSpinWaitLoop = (bool8)GetPrivateProfileInt(Inis.option, "DisableSpinWaitLoop", (int)CPU.DisableSpinWaitLoop, IniFileName);
	Xppsystem.OldFrameTimer = (bool8)GetPrivateProfileInt(Inis.option, "OldFrameTimer", (int)Xppsystem.OldFrameTimer, IniFileName);
	Xppsystem.InactivateWork = (bool8)GetPrivateProfileInt(Inis.option, "InactivateWork", (int)Xppsystem.InactivateWork, IniFileName);

	i = GetPrivateProfileInt(Inis.option, "FontType", (int)Xppsystem.FontType, IniFileName);
	Xppsystem.FontType = (uint8)((0 <= i && i <= 1) ? i : Xppsystem.FontType);

	i = GetPrivateProfileInt(Inis.option, "XppkeyPage", (int)Xppsystem.XppkeyPage, IniFileName);
	Xppsystem.XppkeyPage = (uint8)((0 <= i && i <= 6) ? i : Xppsystem.XppkeyPage);

	i = GetPrivateProfileInt(Inis.option, "Replay_Recode_Mode",XppMovie.Replay_Recode_Mode, IniFileName);
	XppMovie.Replay_Recode_Mode = ((i >= 0 && i <= 1) ? i : XppMovie.Replay_Recode_Mode);

	i = GetPrivateProfileInt(Inis.option, "Speedflag", (int)Xppsystem.Speedflag, IniFileName);
	Xppsystem.Speedflag = (uint32)((0 <= i && i <= 7) ? i : Xppsystem.Speedflag);

	Xppcdda.Enable = (bool8)GetPrivateProfileInt(Inis.option, "UseCDDA", (int)Xppcdda.Enable, IniFileName);
	i = GetPrivateProfileInt(Inis.option, "CDDrv", (int)Xppcdda.Drv, IniFileName);
	Xppcdda.Drv = (uint32)((0 <= i && i <= 26) ? i : Xppcdda.Drv);

	//RevID`FbN
	if(RevID != GetPrivateProfileInt(Inis.option, "RevID", 0, IniFileName)) {
		if(!(fp = fopen(IniFileName, "w"))) {
			CannotCreateIniFlag = 1;
			return;
		}
		fprintf(fp, Config_data);
		fclose(fp);
	}

	return;
}

void WriteIniFile()
{
	if(CannotCreateIniFlag)
		return;

	//[windows]ZNVݒ菑
	if(GUI.PriorityClass == IDLE_PRIORITY_CLASS)
		i = 0;
	else if(GUI.PriorityClass == NORMAL_PRIORITY_CLASS)
		i = 1;
	else if(GUI.PriorityClass == HIGH_PRIORITY_CLASS)
		i = 2;
	else if(GUI.PriorityClass == REALTIME_PRIORITY_CLASS)
		i = 3;
	else
		i = 1;
	wsprintf(tmpCharBuf, "%d", i);
	WritePrivateProfileString(Inis.windows, "PriorityClass", tmpCharBuf, IniFileName);

	if(GUI.ThreadPriority == THREAD_PRIORITY_LOWEST)
		i = 0;
	else if(GUI.ThreadPriority == THREAD_PRIORITY_BELOW_NORMAL)
		i = 1;
	else if(GUI.ThreadPriority == THREAD_PRIORITY_NORMAL)
		i = 2;
	else if(GUI.ThreadPriority == THREAD_PRIORITY_ABOVE_NORMAL)
		i = 3;
	else if(GUI.ThreadPriority == THREAD_PRIORITY_HIGHEST)
		i = 4;
	else if(GUI.ThreadPriority == THREAD_PRIORITY_IDLE)
		i = 5;
	else if(GUI.ThreadPriority == THREAD_PRIORITY_TIME_CRITICAL)
		i = 6;
	else
		i = 2;
	wsprintf(tmpCharBuf, "%d", i);
	WritePrivateProfileString(Inis.windows, "ThreadPriority", tmpCharBuf, IniFileName);

	//[graphics]ZNVݒ菑
	WritePrivateProfileString(Inis.graphics, "Fullscreen", (GUI.FullScreen ? Str1 : Str0), IniFileName);

	wsprintf(tmpCharBuf, "%d", FullscreenDisplayModeIndexDouble16);
	WritePrivateProfileString(Inis.graphics, "FullscreenDisplayModeIndexDouble16", tmpCharBuf, IniFileName);

	wsprintf(tmpCharBuf, "%d", DoubleRenderingModes16);
	WritePrivateProfileString(Inis.graphics, "DoubleRenderingModes16", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.graphics, "DirectScreenRendering", (dRendering ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "DisableHardwareScale", (DirectX.DisableHardwareScale ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "DoubleBuffering", (GUI.DoubleBuffered ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "ForceWindowedDirectDrawClipper", (ForceWindowedDirectDrawClipper ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "OffScreenVRAM", (DirectX.OffScreenVRAM ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "BackBufferVRAM", (DirectX.BackBufferVRAM ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "GFXengine2", (Options.GFXengine2 ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "Transparency", (TransparencyFlag ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "BGLayering", (Settings.BGLayering ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "DisableGraphicWindows", (Settings.DisableGraphicWindows ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "DisableHDMA", (Settings.DisableHDMA ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "Mode7Interpolate", (Settings.Mode7Interpolate ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.graphics, "wait_for_vsync", (DirectX.wait_for_vsync ? Str1 : Str0), IniFileName);
	wsprintf(tmpCharBuf, "%d", GUI.Stretch);
	WritePrivateProfileString(Inis.graphics, "stretch", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", GUI.FullScreen_Stretch);
	WritePrivateProfileString(Inis.graphics, "full_stretch", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", Options.Adjustwindow);
	WritePrivateProfileString(Inis.graphics, "adjustwindow", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", Options.Full_Adjustwindow);
	WritePrivateProfileString(Inis.graphics, "full_adjustwindow", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.graphics, "AltScreenEffect", (Options.AltScreenEffect ? Str1 : Str0), IniFileName);
	wsprintf(tmpCharBuf, "%d", Options.ScanLinesEffect);
	WritePrivateProfileString(Inis.graphics, "ScanLinesEffect", tmpCharBuf, IniFileName);

	//[sound]ZNVݒ菑
	WritePrivateProfileString(Inis.sound, "APUEnabled", (Settings.NextAPUEnabled ? Str1 : Str0), IniFileName);
	wsprintf(tmpCharBuf, "%d", GUI.SoundMode);
	WritePrivateProfileString(Inis.sound, "SoundMode", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.sound, "InterpolatedSound", (Settings.InterpolatedSound ? Str1 : Str0), IniFileName);
	for(c = i = 1; i != Settings.SoundBufferSize && i < 64; c++, i <<= 1);
	wsprintf(tmpCharBuf, "%d", c);
	WritePrivateProfileString(Inis.sound, "SoundBufferLength", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", Settings.SoundMixInterval / 10);
	WritePrivateProfileString(Inis.sound, "SoundMixInterval", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.sound, "SoundEnvelopeHeightReading", (Settings.SoundEnvelopeHeightReading ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.sound, "DisableMasterVolume", (Settings.DisableMasterVolume ? Str1 : Str0), IniFileName);
	wsprintf(tmpCharBuf, "%d", Options.VolumeLevel);
	WritePrivateProfileString(Inis.sound, "VolumeLevel", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.sound, "Shutdown", (Settings.ShutdownMaster ? Str0 : Str1), IniFileName);
	wsprintf(tmpCharBuf, "%d", Settings.SoundSkipMethod);
	WritePrivateProfileString(Inis.sound, "SoundSkipMethod", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.sound, "SoundSync", (Settings.SoundSync ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.sound, "ReverseStereo", (Settings.ReverseStereo ? Str1 : Str0), IniFileName);

	//[cpu]ZNVݒ菑
/*
	if (Settings.H_Max != H_Max_percentage * SNES_CYCLES_PER_SCANLINE / 100)
		H_Max_percentage = 1;
	for(; Settings.H_Max != H_Max_percentage * SNES_CYCLES_PER_SCANLINE / 100; H_Max_percentage++);
	wsprintf(tmpCharBuf, "%d", H_Max_percentage);
	WritePrivateProfileString(Inis.cpu, "H_Max", tmpCharBuf, IniFileName);
*/
	wsprintf(tmpCharBuf, "%d", Settings.CyclesPercentage);
	WritePrivateProfileString(Inis.cpu, "CyclesPercentage", tmpCharBuf, IniFileName);

	//[timer]ZNVݒ菑
	if (Settings.SkipFrames != AUTO_FRAMERATE) {
		wsprintf(tmpCharBuf, "%d", Settings.SkipFrames - 1);
		WritePrivateProfileString(Inis.timer, "SkipFrames", tmpCharBuf, IniFileName);
	}
       else 
       {
		wsprintf(tmpCharBuf, "");
		WritePrivateProfileString(Inis.timer, "SkipFrames", tmpCharBuf, IniFileName);
	}

	wsprintf(tmpCharBuf, "%d", Settings.AutoMaxSkipFrames);
	WritePrivateProfileString(Inis.timer, "AutoMaxSkipFrames", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", Settings.TurboSkipFrames);
	WritePrivateProfileString(Inis.timer, "TurboSkipFrames", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", Settings.FrameTimeNTSC);
	WritePrivateProfileString(Inis.timer, "NTSCtiming", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", Settings.FrameTimePAL);
	WritePrivateProfileString(Inis.timer, "PALtiming", tmpCharBuf, IniFileName);
	
	//[ControllerOption]ZNVݒ菑
	WritePrivateProfileString(Inis.ControllerOption, "SnesMouse", (Settings.Mouse ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.ControllerOption, "SnesSuperScope", (Settings.SuperScope ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.ControllerOption, "SnesMultiPlayer5", (Settings.MultiPlayer5 ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.ControllerOption, "SnesJustifier", (Settings.Justifier ? Str1 : Str0), IniFileName);
	if(Settings.ControllerOption == SNES_MULTIPLAYER5)
		wsprintf(tmpCharBuf, "%d", 0);
	else if(Settings.ControllerOption == SNES_JOYPAD)
		wsprintf(tmpCharBuf, "%d", 1);
	else if(Settings.ControllerOption == SNES_MOUSE_SWAPPED)
		wsprintf(tmpCharBuf, "%d", 2);
	else if(Settings.ControllerOption == SNES_MOUSE)
		wsprintf(tmpCharBuf, "%d", 3);
	else if(Settings.ControllerOption == SNES_SUPERSCOPE)
		wsprintf(tmpCharBuf, "%d", 4);
	else if(Settings.ControllerOption == SNES_JUSTIFIER)
		wsprintf(tmpCharBuf, "%d", 5);
	else
		wsprintf(tmpCharBuf, "%d", 1);
	WritePrivateProfileString(Inis.ControllerOption, "DefaultPlugedInputDevice", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", (Options.JoyReadRateMask + 1));
	WritePrivateProfileString(Inis.ControllerOption, "JoyReadRate", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.ControllerOption, "DirectInput", (DirectX.DIuse ? Str1 : Str0), IniFileName);

	wsprintf(tmpCharBuf, "%d", (Options.MaxWinJoyButtons));
	WritePrivateProfileString(Inis.ControllerOption, "MaxWinJoyButtons", tmpCharBuf, IniFileName);

	wsprintf(tmpCharBuf, "%d", MapFunc[0]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode0", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[1]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode1", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[2]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode2", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[3]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode3", tmpCharBuf, IniFileName);

	wsprintf(tmpCharBuf, "%d", MapFunc[4]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode4", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[5]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode5", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[6]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode6", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[7]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode7", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[8]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode8", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[9]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode9", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[10]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode10", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", MapFunc[11]);
	WritePrivateProfileString(Inis.ControllerOption, "JoyKeyMappedFunctionCode11", tmpCharBuf, IniFileName);

	//[joypad1 2 3 4 5]ZNVݒ菑
	for(i = 0; i < 5; i++) {
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[0], (Joypad[i].Enabled ? Str1 : Str0), IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Left);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[1], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Right);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[2], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Up);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[3], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Down);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[4], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Start);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[5], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Select);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[6], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].A);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[7], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].B);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[8], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].X);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[9], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].Y);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[10], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].L);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[11], tmpCharBuf, IniFileName);
		wsprintf(tmpCharBuf, "%d", Joypad[i].R);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[12], tmpCharBuf, IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[13], (Joypad[i].Turbo_Left ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[14], (Joypad[i].Turbo_Right ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[15], (Joypad[i].Turbo_Up ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[16], (Joypad[i].Turbo_Down ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[17], (Joypad[i].Turbo_Start ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[18], (Joypad[i].Turbo_Select ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[19], (Joypad[i].Turbo_A ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[20], (Joypad[i].Turbo_B ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[21], (Joypad[i].Turbo_X ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[22], (Joypad[i].Turbo_Y ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[23], (Joypad[i].Turbo_L ? Str1 : Str0), IniFileName);
		WritePrivateProfileString(Inis.joypad[i], Key_button_str[24], (Joypad[i].Turbo_R ? Str1 : Str0), IniFileName);
	}

	//[gui]ZNVݒ菑
	WritePrivateProfileString(Inis.gui, "LastROMFileName", ROMFileName, IniFileName);

	tmpCharBuf[0] = 0;
	lstrcpy(&tmpCharBuf[1], "RecentROMFileName1");
	for(i = 0; i < 10; i++) {
		wsprintf(&tmpCharBuf[18], "%X", i + 1);
		WritePrivateProfileString(Inis.gui, &tmpCharBuf[1], &RecentROMFileName[_MAX_PATH * i], IniFileName);
	}

	SlashAdd(GUI.FreezeFileDir);
	WritePrivateProfileString(Inis.gui, "SnapShotDirectory", GUI.FreezeFileDir, IniFileName);
	SlashAdd(ScreenShotDirectory);
	WritePrivateProfileString(Inis.gui, "ScreenShotDirectory", ScreenShotDirectory, IniFileName);
	SlashAdd(SPCDumpDirectory);
	WritePrivateProfileString(Inis.gui, "SPCDumpDirectory", SPCDumpDirectory, IniFileName);
	WritePrivateProfileString(Inis.gui, "Language", (GUI.Language ? Str1 : Str0), IniFileName);

	wsprintf(tmpCharBuf, "%d", WindowRectSetting.left);
	WritePrivateProfileString(Inis.gui, "WindowRectLeft", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", WindowRectSetting.right);
	WritePrivateProfileString(Inis.gui, "WindowRectRight", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", WindowRectSetting.top);
	WritePrivateProfileString(Inis.gui, "WindowRectTop", tmpCharBuf, IniFileName);
	wsprintf(tmpCharBuf, "%d", WindowRectSetting.bottom);
	WritePrivateProfileString(Inis.gui, "WindowRectBottom", tmpCharBuf, IniFileName);

	//[screenshot]ZNVݒ菑
	wsprintf(tmpCharBuf, "%d", Options.SaveImagefileFormat);
	WritePrivateProfileString(Inis.screenshot, "SaveImagefileFormat", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.screenshot, "ReduceTheColorTo256", (Options.ReduceTheColorTo256 ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.screenshot, "ReduceTheColorTo256IfWithin", (Options.ReduceTheColorTo256IfWithin ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.screenshot, "ImagefileHiresStretch", (Options.ImagefileHiresStretch ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.screenshot, "RLEcompression256bitmap", (Options.RLEcompression256bitmap ? Str1 : Str0), IniFileName);

	//[debug]ZNVݒ菑
	WritePrivateProfileString(Inis.debug, "DisplayScreenBufferAll", (Options.DisplayScreenBufferAll ? Str1 : Str0), IniFileName);

	//[option]ZNVݒ菑
	WritePrivateProfileString(Inis.option, "ApplyCheats", (Settings.ApplyCheats ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "ShowFPS", (Settings.DisplayFrameRate ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "MuteSound", (Settings.Mute ? Str1 : Str0), IniFileName);

	wsprintf(tmpCharBuf, "%d", Settings.AutoSaveDelay);
	WritePrivateProfileString(Inis.option, "AutoSaveDelay", tmpCharBuf, IniFileName);
	WritePrivateProfileString(Inis.option, "NormalSnap", (Xppsystem.NormalSnap ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "DisableOutputSram", (Xppsystem.DisableOutputSram ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "SDD1Pack", (Settings.SDD1Pack ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "DisableIRQCycleCount", (Xppsystem.DisableIRQCycleCount ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "OldAutoFrame", (Xppsystem.OldAutoFrame ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "CpuSleep", (Options.CpuSleep ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "DisableSpinWaitLoop", (CPU.DisableSpinWaitLoop ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "OldFrameTimer", (Xppsystem.OldFrameTimer ? Str1 : Str0), IniFileName);
	WritePrivateProfileString(Inis.option, "InactivateWork", (Xppsystem.InactivateWork ? Str1 : Str0), IniFileName);

	wsprintf(tmpCharBuf, "%d", Xppsystem.FontType);
	WritePrivateProfileString(Inis.option, "FontType", tmpCharBuf, IniFileName);

	wsprintf(tmpCharBuf, "%d", Xppsystem.XppkeyPage);
	WritePrivateProfileString(Inis.option, "XppkeyPage", tmpCharBuf, IniFileName);

	wsprintf(tmpCharBuf, "%d", XppMovie.Replay_Recode_Mode);
	WritePrivateProfileString(Inis.option, "Replay_Recode_Mode", tmpCharBuf, IniFileName);

	wsprintf(tmpCharBuf, "%d", Xppsystem.Speedflag);
	WritePrivateProfileString(Inis.option, "Speedflag", tmpCharBuf, IniFileName);

	WritePrivateProfileString(Inis.option, "UseCDDA", (Xppcdda.Enable ? Str1 : Str0), IniFileName);
	wsprintf(tmpCharBuf, "%d", Xppcdda.Drv);
	WritePrivateProfileString(Inis.option, "CDDrv", tmpCharBuf, IniFileName);

	//RevID 
	wsprintf(tmpCharBuf, "%d", RevID);
	WritePrivateProfileString(Inis.option, "RevID", tmpCharBuf, IniFileName);

	return;
}
