#include <windows.h>
#include <mmsystem.h>
#include "mmjoyfix.h"
#include "DirectX.h"

struct SDirectX DirectX;

/*****************
 default settings
*****************/
bool DirectX_OffScreenVRAM_def = FALSE;
bool DirectX_BackBufferVRAM_def = FALSE;
bool DirectX_wait_for_vsync_def = FALSE;
unsigned char DirectX_DIuse_def = FALSE;
unsigned char DirectX_DisableHardwareScale_def = FALSE;

void DirectX_Initialize0()
{
//set default value
	DirectX.hWnd = NULL;
	DirectX.lpDD = NULL;
	DirectX.lpDDClipper = NULL;
	DirectX.lpDDPalette = NULL;

	DirectX.lpDDSPrimary = NULL;
	DirectX.lpDDSBack = NULL;
	DirectX.lpDDSOffScreen = NULL;

	DirectX.lpDDSPrimary2 = NULL;
	DirectX.lpDDSBack2 = NULL;
	DirectX.lpDDSOffScreen2 = NULL;
	DirectX.lpDI = NULL;

	DirectX.Width = DirectX.Height = -1;
	DirectX.Depth = -1;
	DirectX.Windowed = TRUE;
	DirectX.NeedClipper = TRUE;
	DirectX.ForceClipper = FALSE;
	DirectX.ForceWindowedDirectDrawClipper = FALSE;
	DirectX.DoubleBuffered = FALSE;
	DirectX.OffScreenVRAM = DirectX_OffScreenVRAM_def;
	DirectX.BackBufferVRAM = DirectX_BackBufferVRAM_def;
	DirectX.wait_for_vsync = DirectX_wait_for_vsync_def;

	DirectX.lpDS = NULL;
	DirectX.lpDSB = NULL;
	DirectX.lpDSBPrimary = NULL;
	
	DirectX.DSAvailable = FALSE;
	DirectX.DIuse = DirectX_DIuse_def;
	DirectX.DisableHardwareScale = DirectX_DisableHardwareScale_def;
}

bool DirectX_Initialize(HWND hwnd, DWORD dwStyleW, DWORD dwStyleF)
{
//DirectX_Initialize
	DirectX.hWnd = hwnd;
	DirectX.dwStyleWindowed = dwStyleW;
	DirectX.dwStyleFullScreen = dwStyleF;

	DirectX.dErr = DirectDrawCreate(NULL, &DirectX.lpDD, NULL);
	if(DirectX.dErr != DD_OK)
		return FALSE;

	DirectX.dErr = DirectX.lpDD -> CreateClipper(0, &DirectX.lpDDClipper, NULL);
	if(DirectX.dErr != DD_OK) {
		DirectX.lpDD -> Release();
		DirectX.lpDD = NULL;
		return FALSE;
	}
	DirectX.dErr = DirectX.lpDDClipper -> SetHWnd(0, DirectX.hWnd);
	if(DirectX.dErr != DD_OK) {
		DirectX.lpDDClipper -> Release();
		DirectX.lpDDClipper = NULL;
		DirectX.lpDD -> Release();
		DirectX.lpDD = NULL;
		return FALSE;
	}
	DirectX.dErr = DirectSoundCreate(NULL, &DirectX.lpDS, NULL);
	if(DirectX.dErr != DS_OK)
	{	DirectX.DSAvailable = FALSE;	}
	else
	{
		DirectX.dErr = DirectX.lpDS -> SetCooperativeLevel(DirectX.hWnd, DSSCL_EXCLUSIVE);
		if(DirectX.dErr != DS_OK)
		{
			DirectX.lpDS -> Release();
			DirectX.lpDS = NULL;

			DirectX.DSAvailable = FALSE;
		}
		else
		{	DirectX.DSAvailable = TRUE;	}
	}
	return TRUE;
}

#if 0
void DirectX_DeInitialize()
{
	if(DirectX.lpDD != NULL)
	{
		if(!DirectX.Windowed)
			DirectX.lpDD -> RestoreDisplayMode();

		if(DirectX.lpDDSPrimary != NULL)
		{
			DirectX.lpDDSPrimary -> Release();
			DirectX.lpDDSPrimary = NULL;
		}
		if(DirectX.lpDDSOffScreen != NULL)
		{
			DirectX.lpDDSOffScreen -> Release();
			DirectX.lpDDSOffScreen = NULL;
		}
		if(DirectX.lpDDSPrimary2 != NULL)
		{
			DirectX.lpDDSPrimary2 -> Release();
			DirectX.lpDDSPrimary2 = NULL;
		}
		if(DirectX.lpDDSOffScreen2 != NULL)
		{
			DirectX.lpDDSOffScreen2 -> PageUnlock(0);
			DirectX.lpDDSOffScreen2 -> Release();
			DirectX.lpDDSOffScreen2 = NULL;
		}
		if(DirectX.lpDDClipper != NULL)
		{
			DirectX.lpDDClipper -> Release();
			DirectX.lpDDClipper = NULL;
		}
		if(DirectX.lpDDPalette != NULL)
		{
			DirectX.lpDDPalette -> Release();
			DirectX.lpDDPalette = NULL;
		}
		DirectX.lpDD -> Release();
		DirectX.lpDD = NULL;
	}

	if(DirectX.lpDS != NULL)
	{
		if(DirectX.lpDSB != NULL)
		{
			DirectX.lpDSB -> Release();
			DirectX.lpDSB = NULL;
		}
		if(DirectX.lpDSBPrimary != NULL)
		{
			DirectX.lpDSBPrimary -> Release();
			DirectX.lpDSBPrimary = NULL;
		}
	}
	DirectX_DirectInputDeInitialize();
}
#else
void DirectX_DeInitialize()
{
	if(DirectX.lpDD != NULL)
	{
		if(!DirectX.Windowed)
			DirectX.lpDD -> RestoreDisplayMode();

		if(DirectX.lpDDSPrimary != NULL)
		{
			DirectX.lpDDSPrimary -> Release();
			DirectX.lpDDSPrimary = NULL;
		}
		if(DirectX.lpDDSOffScreen != NULL)
		{
			DirectX.lpDDSOffScreen -> Release();
			DirectX.lpDDSOffScreen = NULL;
		}
		if(DirectX.lpDDSPrimary2 != NULL)
		{
			DirectX.lpDDSPrimary2 -> Release();
			DirectX.lpDDSPrimary2 = NULL;
		}
		if(DirectX.lpDDSOffScreen2 != NULL)
		{
			DirectX.lpDDSOffScreen2 -> PageUnlock(0);
			DirectX.lpDDSOffScreen2 -> Release();
			DirectX.lpDDSOffScreen2 = NULL;
		}
		if(DirectX.lpDDClipper != NULL)
		{
			DirectX.lpDDClipper -> Release();
			DirectX.lpDDClipper = NULL;
		}
		if(DirectX.lpDDPalette != NULL)
		{
			DirectX.lpDDPalette -> Release();
			DirectX.lpDDPalette = NULL;
		}
		DirectX.lpDD -> Release();
		DirectX.lpDD = NULL;
	}

	if(DirectX.lpDS != NULL)
	{
		if(DirectX.lpDSB != NULL)
		{
	        DirectX.lpDSB->Stop();
			DirectX.lpDSB -> Release();
			DirectX.lpDSB = NULL;
		}
		if(DirectX.lpDSBPrimary != NULL)
		{
	        DirectX.lpDSBPrimary->Stop();
			DirectX.lpDSBPrimary -> Release();
			DirectX.lpDSBPrimary = NULL;
		}
		DirectX.lpDS -> Release();
		DirectX.lpDS = NULL;
		DirectX.DSAvailable = FALSE;
	}
	DirectX_DirectInputDeInitialize();
}
#endif

bool DirectX_SetDisplayMode( 
		int pWidth, int pHeight, 
		char pDepth, unsigned char pWindowed, bool pDoubleBuffered)
{
	DDSURFACEDESC ddsd;
	DDSCAPS ddscaps;
	PALETTEENTRY PaletteEntries[256];
#if 0
	if( pWidth == DirectX.Width && pHeight == DirectX.Height &&
		(pDepth == DirectX.Depth || pDepth == 0) && pWindowed == DirectX.Windowed && 
		pDoubleBuffered == DirectX.DoubleBuffered)
		return TRUE;
#endif

	if(pDepth == 0)
		pDepth = DirectX.Depth;

	if(DirectX.lpDDSPrimary != NULL)
	{
		DirectX.lpDDSPrimary -> Release();
		DirectX.lpDDSPrimary = NULL;
	}
	if(DirectX.lpDDSOffScreen != NULL)
	{
		DirectX.lpDDSOffScreen -> Release();
		DirectX.lpDDSOffScreen = NULL;
	}
	if(DirectX.lpDDSPrimary2 != NULL)
	{
		DirectX.lpDDSPrimary2 -> Release();
		DirectX.lpDDSPrimary2 = NULL;
	}
	if(DirectX.lpDDSOffScreen2 != NULL)
	{
		DirectX.lpDDSOffScreen2 -> PageUnlock(0);
		DirectX.lpDDSOffScreen2 -> Release();
		DirectX.lpDDSOffScreen2 = NULL;
	}
	if(DirectX.lpDDPalette != NULL)
	{
		DirectX.lpDDPalette -> Release();
		DirectX.lpDDPalette = NULL;
	}

	DirectX.lpDD -> FlipToGDISurface();

	/* EChE[hł݂̌̏Ԏ擾DirectX샂[hAfBXv[[hݒ */
	if(pWindowed)
	{	
		pDoubleBuffered = FALSE;
		if(!DirectX.Windowed) {
			DirectX.lpDD -> RestoreDisplayMode();
			SetWindowLong(DirectX.hWnd, GWL_STYLE, DirectX.dwStyleWindowed);
		}
		FillMemory((PVOID)&ddsd, sizeof(ddsd), 0);
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_PIXELFORMAT;
		DirectX.dErr = DirectX.lpDD -> GetDisplayMode(&ddsd);
		if(DirectX.dErr != DD_OK)
		{	pDepth = 8;	}
		else
		{
			if(ddsd.ddpfPixelFormat.dwFlags&DDPF_RGB)
			{	pDepth = (char)ddsd.ddpfPixelFormat.dwRGBBitCount;	}
			else
			{	pDepth = 8;	}
		}
		DirectX.dErr = DirectX.lpDD -> SetCooperativeLevel(DirectX.hWnd, DDSCL_NORMAL|DDSCL_ALLOWREBOOT);
	} 

	/* tXN[[hłDirectX샂[hAfBXvC[hݒ */
	else 
	{
		SetWindowLong(DirectX.hWnd, GWL_STYLE, DirectX.dwStyleFullScreen);
		SetWindowPos(DirectX.hWnd, HWND_TOP, 0, 0, 0, 0, SWP_DRAWFRAME|SWP_FRAMECHANGED|SWP_NOMOVE|SWP_NOSIZE);

		if(DirectX.Windowed || pWidth != DirectX.Width || pHeight != DirectX.Height || pDepth != DirectX.Depth)
		{	
			DirectX.dErr = DirectX.lpDD -> SetCooperativeLevel(DirectX.hWnd, DDSCL_ALLOWMODEX|DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN|DDSCL_ALLOWREBOOT);

			if(DirectX.dErr == DD_OK)
				DirectX.dErr = DirectX.lpDD -> SetDisplayMode(pWidth, pHeight, pDepth);
#if 0
			//[h؂芷s̑̃fBXvC[h֐؂芷s
			if(DirectX.dErr != DD_OK && pWidth == 320 && pHeight == 240) {
				pWidth = 640;
				pHeight = 480;
				DirectX.dErr = DirectX.lpDD -> SetDisplayMode(pWidth, pHeight, pDepth);
			}
			if(DirectX.dErr != DD_OK && pWidth == 640 && pHeight == 480) {
				pWidth = 800;
				pHeight = 600;
				DirectX.dErr = DirectX.lpDD -> SetDisplayMode(pWidth, pHeight, pDepth);
			}
			if(DirectX.dErr != DD_OK && pWidth == 800 && pHeight == 600) {
				pWidth = 1024;
				pHeight = 768;
				DirectX.dErr = DirectX.lpDD -> SetDisplayMode(pWidth, pHeight, pDepth);
			}
#endif
		}
	}
	if(DirectX.dErr != DD_OK)
		return FALSE;

	FillMemory((PVOID)&ddsd, sizeof(ddsd), 0);

	/* tXN[[hAobNobt@ */
	if(!pWindowed && pDoubleBuffered)
	{
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_COMPLEX | DDSCAPS_FLIP;
		ddsd.dwBackBufferCount = 1;
	}
	/* tXN[[hAobNobt@Ȃ */
	else if(!pWindowed && !pDoubleBuffered)
	{
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	}
	/* EChE[h */
	else
	{
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	}
	

	/* vC}T[tFX쐬 */
	DirectX.dErr = DirectX.lpDD -> CreateSurface(&ddsd, &DirectX.lpDDSPrimary, NULL);

	/* T[tFX쐬s̏ꍇ̏ */
	if(DirectX.dErr != DD_OK)
	{
		/* obNobt@Ȃ[hs */
		if(pDoubleBuffered)
		{
			FillMemory((PVOID)&ddsd, sizeof(ddsd), 0);
			ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags = DDSD_CAPS;
			ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
			pDoubleBuffered = FALSE;
			DirectX.dErr = DirectX.lpDD -> CreateSurface(&ddsd, &DirectX.lpDDSPrimary, NULL);
		}
		if(DirectX.dErr != DD_OK)
			return FALSE;
	}

	/* vC}T[tFX̃sNZtH[}bg擾 */
	FillMemory((PVOID)&DirectX.DDPixelFormat, sizeof(DirectX.DDPixelFormat), 0);
	DirectX.DDPixelFormat.dwSize = sizeof(DirectX.DDPixelFormat);
	DirectX.lpDDSPrimary -> GetPixelFormat(&DirectX.DDPixelFormat);

//#if 0
	if(pWindowed && DirectX.lpDDClipper)
	{	DirectX.lpDDSPrimary -> SetClipper(DirectX.lpDDClipper);	}
//#endif
	if(!pWindowed && DirectX.lpDDClipper) {
		if(DirectX.lpDDSPrimary) {
			DirectX.lpDDSPrimary -> SetClipper(NULL);
		}
		else if(DirectX.lpDDSPrimary2) {
			DirectX.lpDDSPrimary2 -> SetClipper(NULL);
		}
		DirectX.lpDDClipper -> Release();
		DirectX.lpDDClipper = NULL;
	}

	if(FAILED(DirectX.lpDDSPrimary -> QueryInterface(IID_IDirectDrawSurface2, (void **)&DirectX.lpDDSPrimary2)))
	{   DirectX.lpDDSPrimary2 = NULL;  }
	else
	{
		DirectX.lpDDSPrimary -> Release();
		DirectX.lpDDSPrimary = NULL;
	}

	if(!pWindowed && pDoubleBuffered)
	{
	RECT Src;
		if(!DirectX.BackBufferVRAM)
			ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
		else
			ddscaps.dwCaps = DDSCAPS_BACKBUFFER | DDSCAPS_VIDEOMEMORY;
		if(DirectX.lpDDSPrimary2 != NULL)
		{	DirectX.dErr = DirectX.lpDDSPrimary2 -> GetAttachedSurface(&ddscaps, &DirectX.lpDDSBack2);	}
		else
		{	DirectX.dErr = DirectX.lpDDSPrimary -> GetAttachedSurface(&ddscaps, &DirectX.lpDDSBack);	}
		if(DirectX.dErr != DD_OK)
			return FALSE;

		Src.left = 0; Src.right = pWidth;
		Src.top = 0; Src.bottom = pHeight;
		if(DirectX.lpDDSPrimary2 != NULL)
		{	DirectX.lpDDSBack2 -> BltFast(0, 0, DirectX.lpDDSPrimary2, &Src, DDBLTFAST_WAIT);	}
		else
		{	DirectX.lpDDSBack -> BltFast(0, 0, DirectX.lpDDSPrimary, &Src, DDBLTFAST_WAIT);	}
	}
	else
	{	
//		DirectX.lpDDSBack = DirectX.lpDDSPrimary;	
//		DirectX.lpDDSBack2 = DirectX.lpDDSPrimary2;
		DirectX.lpDDSBack = NULL;	
		DirectX.lpDDSBack2 = NULL;
	}

	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	if(!DirectX.OffScreenVRAM)
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
	else
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;
	ddsd.dwWidth = 256 * 2;
	ddsd.dwHeight = 239 * 2;
	
	DirectX.dErr = DirectX.lpDD -> CreateSurface(&ddsd, &DirectX.lpDDSOffScreen, NULL);
	if(DirectX.dErr != DD_OK)
		return FALSE;

	if(DirectX.lpDDSPrimary2 != NULL)
	if(FAILED(DirectX.lpDDSOffScreen -> QueryInterface(IID_IDirectDrawSurface2, (void **)&DirectX.lpDDSOffScreen2)))
	{    DirectX.lpDDSOffScreen2 = NULL;    }
	else
	{
		DirectX.lpDDSOffScreen2 -> PageLock(0);
		DirectX.lpDDSOffScreen -> Release();
		DirectX.lpDDSOffScreen = NULL;
	}

	DirectX_ClearOffscreenSurface();

	if(pDepth == 8)
	{
		for(int i = 0; i < 256; i++) {
			PaletteEntries[i].peRed = 0;
			PaletteEntries[i].peGreen = 0;
			PaletteEntries[i].peBlue = 0;
			PaletteEntries[i].peFlags = PC_NOCOLLAPSE;
		}
		DirectX.dErr = DirectX.lpDD -> CreatePalette(DDPCAPS_8BIT|DDPCAPS_ALLOW256 , PaletteEntries, &DirectX.lpDDPalette, NULL);
		if(DirectX.dErr != DD_OK)
		{
			DirectX.lpDDPalette = NULL;
			return FALSE;
		}
	}

	/* fBXvC[h擾 */
	FillMemory((PVOID)&ddsd, sizeof(ddsd), 0);
	ddsd.dwSize = sizeof( ddsd);
	ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH;
	DirectX.lpDD -> GetDisplayMode(&ddsd);

	//fBXvC[h؂芷̏ꍇ͎~߂
	if(DirectX.Windowed != pWindowed || DirectX.Width != (int)ddsd.dwWidth || DirectX.Height != (int)ddsd.dwHeight || DirectX.Depth != pDepth) {
		Sleep(500);
	}
	DirectX.Windowed = pWindowed;
	DirectX.Depth = pDepth;
	DirectX.Height = ddsd.dwHeight;
	DirectX.Width = ddsd.dwWidth;
	DirectX.DoubleBuffered = pDoubleBuffered;
	return TRUE;
}

//Zero clear Surface
void DirectX_ClearSurface(LPDIRECTDRAWSURFACE lpDDS)
{
	DDSURFACEDESC ddsd;
	HRESULT dErr;
	int retry = 0;

	FillMemory((PVOID)&ddsd, sizeof(ddsd), 0);
	ddsd.dwSize = sizeof(ddsd);
	while(TRUE)
	{
		dErr = lpDDS -> Lock( NULL, &ddsd, DDLOCK_WAIT, NULL);
		
		if( dErr == DD_OK)
		{
			FillMemory ((PVOID)ddsd.lpSurface, ddsd.lPitch * ddsd.dwHeight, 0);
			lpDDS -> Unlock( NULL);
		}

		if( dErr == DDERR_SURFACELOST)
		{
			retry++;
			if( retry > 5)
			{	break;	}

			dErr = lpDDS -> Restore();
		
			if( dErr != DD_OK)
			{	break;	}

			continue;
		}

		if( dErr != DDERR_WASSTILLDRAWING)
		{	break;	}
	}
}

//Zero clear Surface2
void DirectX_ClearSurface2(LPDIRECTDRAWSURFACE2 lpDDS2)
{
	DDSURFACEDESC ddsd;
	HRESULT dErr;
	int retry = 0;

	FillMemory((PVOID)&ddsd, sizeof(ddsd), 0);
	ddsd.dwSize = sizeof(ddsd);
	while(TRUE)
	{
		dErr = lpDDS2 -> Lock( NULL, &ddsd, DDLOCK_WAIT, NULL);
		
		if( dErr == DD_OK)
		{
			FillMemory ((PVOID)ddsd.lpSurface, ddsd.lPitch * ddsd.dwHeight, 0);
			lpDDS2 -> Unlock( NULL);
		}

		if( dErr == DDERR_SURFACELOST)
		{
			retry++;
			if( retry > 5)
			{	break;	}

			dErr = lpDDS2 -> Restore();
		
			if( dErr != DD_OK)
			{	break;	}

			continue;
		}

		if( dErr != DDERR_WASSTILLDRAWING)
		{	break;	}
	}
}

//Zero clear OffscreenSurface
void DirectX_ClearOffscreenSurface()
{
	if(DirectX.lpDDSOffScreen)
		DirectX_ClearSurface(DirectX.lpDDSOffScreen);
	else if(DirectX.lpDDSOffScreen2)
		DirectX_ClearSurface2(DirectX.lpDDSOffScreen2);
}

//Zero clear PrimarySurface
void DirectX_ClearPrimarySurface()
{
	if(DirectX.Windowed)
		return;
	else if(DirectX.lpDDSPrimary)
		DirectX_ClearSurface(DirectX.lpDDSPrimary);
	else if(DirectX.lpDDSPrimary2)
		DirectX_ClearSurface2(DirectX.lpDDSPrimary2);
}

//Zero clear BackbufferSurface
void DirectX_ClearBackbufferSurface()
{
	if(DirectX.Windowed)
		return;
	else if(DirectX.lpDDSBack)
		DirectX_ClearSurface(DirectX.lpDDSBack);
	else if(DirectX.lpDDSBack2)
		DirectX_ClearSurface2(DirectX.lpDDSBack2);
}

extern long _buffernos;
extern long _buffersize;
extern long _blocksize;
extern long pending_rate;
extern unsigned char pending_16bit;
extern unsigned char pending_stereo;

#if 0
bool DirectX_SetSoundMode( void)
{
    DSBUFFERDESC dsbd;

    if(DirectX.lpDSB != NULL)
    {
        DirectX.lpDSB->Stop();
        DirectX.lpDSB -> Release();
        DirectX.lpDSB = NULL;
    }
    if(DirectX.lpDSBPrimary != NULL)
    {
        DirectX.lpDSBPrimary->Stop();
        DirectX.lpDSBPrimary -> Release();
        DirectX.lpDSBPrimary = NULL;
    }

    if(pending_rate == 0)
        return FALSE;

    if(!DirectX.DSAvailable)
        return FALSE;

	FillMemory((PVOID)&DirectX.wfx, sizeof(DirectX.wfx), 0);

    DirectX.wfx.wFormatTag = WAVE_FORMAT_PCM;
    DirectX.wfx.nChannels = pending_stereo ? 2 : 1;
    DirectX.wfx.nSamplesPerSec = pending_rate;
    DirectX.wfx.nBlockAlign = (pending_16bit ? 2 : 1) * (pending_stereo ? 2 : 1);
    DirectX.wfx.wBitsPerSample = pending_16bit ? 16 : 8;
    DirectX.wfx.nAvgBytesPerSec = DirectX.wfx.nSamplesPerSec * DirectX.wfx.nBlockAlign;
    DirectX.wfx.cbSize = 0;

	FillMemory((PVOID)&dsbd, sizeof(dsbd), 0);
    dsbd.dwSize = sizeof(dsbd);
    dsbd.dwFlags = DSBCAPS_PRIMARYBUFFER;

    DirectX.dErr = DirectX.lpDS -> CreateSoundBuffer(&dsbd, &DirectX.lpDSBPrimary, NULL);
    if(DirectX.dErr != DS_OK)
    {
        DirectX.lpDSB = NULL;
        return FALSE;
    }

    DirectX.lpDSBPrimary -> SetFormat( &DirectX.wfx);
    DirectX.lpDSBPrimary -> Play (0, 0, DSBPLAY_LOOPING);

    DirectX.lpDSBPrimary -> Release();
    DirectX.lpDSBPrimary = NULL;

	FillMemory((PVOID)&dsbd, sizeof(dsbd), 0);
    dsbd.dwSize = sizeof( dsbd);
//    dsbd.dwFlags = DSBCAPS_CTRLDEFAULT | DSBCAPS_GETCURRENTPOSITION2;
    dsbd.dwFlags = DSBCAPS_CTRLDEFAULT | DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_GLOBALFOCUS;
    dsbd.dwBufferBytes = _blocksize * _buffernos;
    dsbd.lpwfxFormat = &DirectX.wfx;

    DirectX.dErr = DirectX.lpDS -> CreateSoundBuffer(&dsbd, &DirectX.lpDSB, NULL);
    if(DirectX.dErr != DS_OK)
    {
        DirectX.lpDSBPrimary -> Release ();
        return FALSE;
    }
    return TRUE;
}
#else
bool DirectX_SetSoundMode( void)
{
    DSBUFFERDESC dsbd;

    if(DirectX.lpDSB != NULL)
    {
        DirectX.lpDSB->Stop();
        DirectX.lpDSB -> Release();
        DirectX.lpDSB = NULL;
    }
    if(DirectX.lpDSBPrimary != NULL)
    {
        DirectX.lpDSBPrimary->Stop();
        DirectX.lpDSBPrimary -> Release();
        DirectX.lpDSBPrimary = NULL;
    }

    if(pending_rate == 0)
        return FALSE;

    if(!DirectX.DSAvailable)
        return FALSE;

	FillMemory((PVOID)&DirectX.wfx, sizeof(DirectX.wfx), 0);

    DirectX.wfx.wFormatTag = WAVE_FORMAT_PCM;
    DirectX.wfx.nChannels = pending_stereo ? 2 : 1;
    DirectX.wfx.nSamplesPerSec = pending_rate;
    DirectX.wfx.nBlockAlign = (pending_16bit ? 2 : 1) * (pending_stereo ? 2 : 1);
    DirectX.wfx.wBitsPerSample = pending_16bit ? 16 : 8;
    DirectX.wfx.nAvgBytesPerSec = DirectX.wfx.nSamplesPerSec * DirectX.wfx.nBlockAlign;
    DirectX.wfx.cbSize = 0;

	FillMemory((PVOID)&dsbd, sizeof(dsbd), 0);
    dsbd.dwSize = sizeof(dsbd);
    dsbd.dwFlags = DSBCAPS_PRIMARYBUFFER;

    DirectX.dErr = DirectX.lpDS -> CreateSoundBuffer(&dsbd, &DirectX.lpDSBPrimary, NULL);
    if(DirectX.dErr != DS_OK)
    {
        DirectX.lpDSB = NULL;
        return FALSE;
    }

    DirectX.lpDSBPrimary -> SetFormat( &DirectX.wfx);
    DirectX.lpDSBPrimary -> Play (0, 0, DSBPLAY_LOOPING);

//    DirectX.lpDSBPrimary -> Release();
//    DirectX.lpDSBPrimary = NULL;

	FillMemory((PVOID)&dsbd, sizeof(dsbd), 0);
    dsbd.dwSize = sizeof( dsbd);
//    dsbd.dwFlags = DSBCAPS_CTRLDEFAULT | DSBCAPS_GETCURRENTPOSITION2;
//    dsbd.dwFlags = DSBCAPS_CTRLDEFAULT | DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_GLOBALFOCUS;
    dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_GLOBALFOCUS;
    dsbd.dwBufferBytes = _blocksize * _buffernos;
    dsbd.lpwfxFormat = &DirectX.wfx;

    DirectX.dErr = DirectX.lpDS -> CreateSoundBuffer(&dsbd, &DirectX.lpDSB, NULL);
    if(DirectX.dErr != DS_OK)
    {
        DirectX.lpDSBPrimary->Stop();
        DirectX.lpDSBPrimary -> Release();
        DirectX.lpDSBPrimary = NULL;
        return FALSE;
    }
    return TRUE;
}
#endif

bool DirectX_DirectInputInitialize()
{
	if(!DirectX.hWnd)
		return FALSE;
	if(DirectX.lpDI != NULL)
		return TRUE;
	if(DI_OK != DirectInputCreate((HINSTANCE)GetWindowLong(DirectX.hWnd, GWL_HINSTANCE), DIRECTINPUT_VERSION, &DirectX.lpDI, NULL) &&
		DI_OK != DirectInputCreate((HINSTANCE)GetWindowLong(DirectX.hWnd, GWL_HINSTANCE), 0x0300, &DirectX.lpDI, NULL)) {
		DirectX.lpDI = NULL;
		return FALSE;
	}
	return TRUE;
}

void DirectX_DirectInputDeInitialize()
{
	if(DirectX.lpDI) {
		DirectX.lpDI->Release();
		DirectX.lpDI = NULL;
	}
}

void DirectX_SetClipper(unsigned char clipflag, long dWidth, long dHeight)
{
	if(!DirectX.hWnd || !DirectX.Windowed)
		return;
	RECT cRect;
	
	DirectX.NeedClipper = FALSE;
	GetClientRect(DirectX.hWnd, &cRect);
	if((cRect.right - cRect.left) < dWidth || (cRect.bottom - cRect.top) < dHeight)
		DirectX.NeedClipper = TRUE;
	if(!DirectX.NeedClipper) {
		POINT pt;
		RECT wRect, dRect;
		int dwidth = (int)dWidth;
		int dheight = (int)dHeight;
		pt.x = ((cRect.right - cRect.left) - dwidth) / 2;
		pt.y = ((cRect.bottom - cRect.top) - dheight) / 2;
		ClientToScreen (DirectX.hWnd, &pt);
		dRect.top = pt.y;
		dRect.left = pt.x;
		dRect.bottom = dRect.top + dheight;
		dRect.right  = dRect.left + dwidth;
		SystemParametersInfo(SPI_GETWORKAREA, 0, &wRect, 0);
		if(wRect.top > dRect.top || wRect.left > dRect.left || wRect.right < dRect.right || wRect.bottom < dRect.bottom)
			DirectX.NeedClipper = TRUE;
	}
/*
	if(DirectX.lpDDSPrimary) {
		DirectX.lpDDSPrimary -> SetClipper((clipflag || DirectX.NeedClipper || DirectX.ForceWindowedDirectDrawClipper) ? DirectX.lpDDClipper : NULL);
	}
	else if(DirectX.lpDDSPrimary2) {
		DirectX.lpDDSPrimary2 -> SetClipper((clipflag || DirectX.NeedClipper || DirectX.ForceWindowedDirectDrawClipper) ? DirectX.lpDDClipper : NULL);
	}
*/

	if(clipflag || DirectX.NeedClipper || DirectX.ForceWindowedDirectDrawClipper || DirectX.ForceClipper) {
		if(DirectX.lpDD && DirectX.lpDDClipper == NULL)
		{
			DirectX.dErr = DirectX.lpDD -> CreateClipper(0, &DirectX.lpDDClipper, NULL);
			if(DirectX.dErr == DD_OK)
				DirectX.dErr = DirectX.lpDDClipper -> SetHWnd(0, DirectX.hWnd);
			else {
				DirectX.lpDDClipper = NULL;
				return;
			}
			if(DirectX.dErr != DD_OK)
				return;
		}
		if(DirectX.lpDDSPrimary) {
			DirectX.lpDDSPrimary -> SetClipper(DirectX.lpDDClipper);
		}
		else if(DirectX.lpDDSPrimary2) {
			DirectX.lpDDSPrimary2 -> SetClipper(DirectX.lpDDClipper);
		}
	}
	else {
		if(DirectX.lpDDSPrimary) {
			DirectX.lpDDSPrimary -> SetClipper(NULL);
		}
		else if(DirectX.lpDDSPrimary2) {
			DirectX.lpDDSPrimary2 -> SetClipper(NULL);
		}
		if(DirectX.lpDDClipper != NULL)
		{
			DirectX.lpDDClipper -> Release();
			DirectX.lpDDClipper = NULL;
		}
	}
}
