#define SCREEN_BUFFER         (512*478*2 + (512*3*2))
#define SUB_SCREEN_BUFFER     (512*478*2)
#define Z_BUFFER              (512*478)
#define SUB_Z_BUFFER          (512*478)

//***************************************************************
// DEFAULT_SCREEN_SIZE_SET_MACRO
//***************************************************************

#define DEFAULT_SCREEN_SIZE_SET(num,x,y,yex) \
	SetRect(&rc, 0, 0, x, yex); \
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE); \
	DefaultWindowSizeWW[num] = rc.right - rc.left; \
	DefaultWindowSizeHH[num] = rc.bottom - rc.top; \
	GUI.Res_X[num] = x; \
	GUI.Res_Y[num] = y; \
	GUI.Res_Y_EX[num] = yex;


//***************************************************************
// SOFT_SCREEN_EFFECT_MACRO & RENDER_MACRO
//***************************************************************


#define SOFT_SCREEN_EFFECT_EXTRA \
(GUI.Scale == 3 || GUI.Scale == 4 || GUI.Scale == 5 || GUI.Scale == 6 || GUI.Scale == 8 || GUI.Scale == 9 || GUI.Scale == 10 || GUI.Scale == 11 || GUI.Scale == 12)

#define SOFT_SCREEN_EFFECT_EXTRA_TYPE_01 \
unsigned char *lpSrc, *lpDst; \
unsigned int wSrcHeight; \
 \
	if(DoubleHeight) \
	{	 \
		HiresModeDetectedFlag_Now = RES_512_478; \
		HiresModeDetectedFlag_Old = HiresModeDetectedFlag_Now; \
		wSrcHeight = Src.Height; \
	} \
	else \
	if(DoubleWidth) \
	{ \
		HiresModeDetectedFlag = TRUE; \
		HiresModeDetectedFlag_Now = RES_512_239; \
		wSrcHeight = Src.Height  << 1; \
	} \
	else \
	{ \
		HiresModeDetectedFlag_Now = RES_256_239; \
		wSrcHeight = Src.Height << 1; \
	} \
 \
		if( OldRenderMethod != RenderMethod || HiresModeDetectedFlag_Now != HiresModeDetectedFlag_Old || ExtendHeight_bak != ExtendHeight) \
			_2xSaIBufferInit(Dst); \
 \
		HiresModeDetectedFlag_Old = HiresModeDetectedFlag_Now; \
 \
		lpSrc = Src.Surface; \
 \
		srcRect->top    = (Dst.Height - wSrcHeight) / 2; \
		srcRect->left   = (Dst.Width - 512) / 2; \
		srcRect->bottom = srcRect->top  + wSrcHeight; \
		srcRect->right  = srcRect->left + 512; \
 \
		lpDst = Dst.Surface; \
		lpDst += ((Dst.Height - wSrcHeight) / 2) * Dst.Pitch; \
		lpDst += Dst.Width - 512; \
 \


#define SOFT_RENDER_SET \
	switch( GUI.Scale) \
	{ \
		case 0:  \
			RenderMethod = Render16to16; \
			break; \
		case 1:  \
			RenderMethod = Render16to16; \
			break; \
		case 2:  \
			RenderMethod = RenderDouble16to16; \
			break; \
		case 3:  \
			RenderMethod = RenderFakeTV16to16; \
			break; \
		case 4:  \
			RenderMethod = RenderSuperEagle16to16; \
			break; \
		case 5: \
			RenderMethod = Render2xSaI16to16; \
			break; \
		case 6: \
			RenderMethod = RenderSuper2xSaI16to16; \
			break; \
		case 7: \
			RenderMethod = RenderScale_2xSaI16to16; \
			break; \
		case 8:  \
			RenderMethod = RenderTV16to16; \
			break; \
		case 9:  \
			RenderMethod = RenderHQ2X16to16; \
			break; \
		case 10:  \
			RenderMethod = RenderLQ2X16to16; \
			break; \
		case 11:  \
			RenderMethod = RenderInterlaceScanLines16to16; \
			break; \
		case 12:  \
			RenderMethod = RenderInterlace16to16; \
			break; \
		default: \
			RenderMethod = RenderDouble16to16; \
			break; \
	}

//***************************************************************
// S9XW_KEY_MACRO
//***************************************************************

#define S9XW_KEY_OPTION_CONFIG \
			if(GUI.PauseEmulation) \
				break; \
			S9xwKillMessageTimer(); \
			S9xwPauseEmulation(TRUE); \
			S9xwPauseLock = TRUE; \
			if(GUI.FullScreen && !DirectX.Windowed) \
			{ \
			     S9xwSwitchScreenMode(FALSE); \
			     extern BYTE ScreenBuffer[]; \
			     FillMemory ((PVOID)ScreenBuffer, SCREEN_BUFFER, 0); \
			     Draw1frame(); \
			     if(Xppsystem.InactivateWork) UpdateBackBuffer(); \
			} \
			S9xwPauseLock = FALSE; \
			ConfigDlgProp(hWnd); \
			Draw1FrameFlag = TRUE; \
			if(errConfigSwitch) \
				break; \
			UIExit(); \
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) \
				S9xMessage2 ("EraseMouseCursor", 1000);

#define S9XW_KEY_OPTION_FPS \
			if(Settings.DisplayFrameRate) \
				Settings.DisplayFrameRate = 0; \
			else \
				Settings.DisplayFrameRate = 1;        

#define S9XW_KEY_OPTION_SETTINGS_KEY_APPLYCHEATS \
			Settings.ApplyCheats = !Settings.ApplyCheats; \
			if(Settings.ApplyCheats) \
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "`[gR[hL" : "Cheat code on", 2000); \
			else \
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "`[gR[h" : "Cheat code off", 2000);        

#define S9XW_KEY_OPTION_STRETCH \
			S9xwPauseEmulation(TRUE); \
			if((!GUI.FullScreen && !GUI.Stretch) || (GUI.FullScreen && !GUI.FullScreen_Stretch)) \
			{ \
			    if(!GUI.FullScreen) \
			    { \
			       GUI.Stretch = 1; \
			       Options.Adjustwindow = STRETCH_ADJUSTWINDOW; \
			    } \
			    else \
			    { \
			       GUI.FullScreen_Stretch = 1; \
			       Options.Full_Adjustwindow = STRETCH_ADJUSTWINDOW; \
			    } \
\
			} \
			else \
			{ \
			    if(!GUI.FullScreen) \
			    { \
			       GUI.Stretch = false; \
			       Options.Adjustwindow = 1; \
			    } \
			    else \
			    { \
			       GUI.FullScreen_Stretch = false; \
			       Options.Full_Adjustwindow = 1; \
			    } \
\
			} \
			if(DirectX.Windowed) { \
				GetClientRect(GUI.hWnd, &rc); \
				hdc = GetDC(GUI.hWnd); \
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH)); \
				ReleaseDC(GUI.hWnd, hdc); \
			} \
			else \
				UpdateBackBuffer(); \
			S9xwPauseEmulation(FALSE);

#define S9XW_KEY_OPTION_MUTE \
			Settings.Mute = !Settings.Mute; \
			if(Settings.Mute) \
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "TEhobt@vC It" : "Mute Sound", 2000); \
			else \
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "TEhobt@vC I" : "Dis Mute Sound", 2000);        

#define S9XW_KEY_FILE_OPEN \
			if(GUI.PauseEmulation || !UIEnter()) \
				break; \
			S9xwPauseEmulation(TRUE); \
			S9xwPauseLock = TRUE; \
			if (OpenFile(hWnd, ROMFileName, FileTitle, InitialROMFileDirectory)) { \
				UpdateBackBuffer(); \
				ROMLoadProc(ROMFileName); \
				if(!GUI.StopEmulation) \
					SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority); \
				else \
					SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL); \
			} \
			S9xwPauseLock = FALSE; \
			UIExit(); \
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) \
				S9xMessage2 ("EraseMouseCursor", 1000);        

#define S9XW_KEY_FILE_OPEN_XPP_KEY \
			if(GUI.PauseEmulation) \
				break; \
			S9xwKillMessageTimer(); \
			if(GUI.FullScreen && !DirectX.Windowed) \
			{ \
			     S9xwPauseEmulation(TRUE); \
			     S9xwPauseLock = TRUE; \
			     S9xwSwitchScreenMode(FALSE); \
			     extern BYTE ScreenBuffer[]; \
			     FillMemory ((PVOID)ScreenBuffer, SCREEN_BUFFER, 0); \
			     Draw1frame(); \
			     S9xwPauseLock = FALSE; \
			} \
			S9xwPauseEmulation(TRUE); \
			S9xwPauseLock = TRUE; \
			if (OpenFile(hWnd, ROMFileName, FileTitle, InitialROMFileDirectory)) { \
				UpdateBackBuffer(); \
				ROMLoadProc(ROMFileName); \
				if(!GUI.StopEmulation) \
					SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority); \
				else \
					SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL); \
			} \
			S9xwPauseLock = FALSE; \
			UIExit(); \
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) \
				S9xMessage2 ("EraseMouseCursor", 1000);        

#define S9XW_KEY_FILE_RESET_FULL \
		 if(XppMovie.Replay_status == MOVIE_NONE) \
		 { \
			if(GUI.StopEmulation || GUI.PauseEmulation) \
				break; \
			S9xwPauseEmulation(TRUE); \
			S9xReset(); \
if(Xppcdda.Enable) cdda_stop(); \
 \
if(Xppbsx.BsxRomCheck) \
{ \
BSX_CLEAR (); \
BSX_TIMESET ();  \
} \
			ScreenBufferClear(); \
			if(GUI.FullScreen && DirectX.Windowed) \
			{ \
				if(!S9xwSwitchScreenMode(FALSE)) \
					break; \
			} \
			else \
				UpdateBackBuffer(); \
			S9xwPauseEmulation(FALSE); \
		 }        

#define S9XW_KEY_FILE_SOFTRESET_FULL \
		 if(XppMovie.Replay_status == MOVIE_NONE) \
		 { \
			if(GUI.StopEmulation || GUI.PauseEmulation) \
				break; \
			S9xwPauseEmulation(TRUE); \
			S9xSoftReset(); \
if(Xppcdda.Enable) cdda_stop(); \
 \
if(Xppbsx.BsxRomCheck) \
{ \
BSX_CLEAR (); \
BSX_TIMESET ();  \
} \
			ScreenBufferClear(); \
			if(GUI.FullScreen && DirectX.Windowed) \
			{ \
				if(!S9xwSwitchScreenMode(FALSE)) \
					break; \
			} \
			else \
				UpdateBackBuffer(); \
			S9xwPauseEmulation(FALSE); \
		 }         

#define S9XW_KEY_FILE_RESET \
		 if(XppMovie.Replay_status == MOVIE_NONE) \
		 { \
			if(GUI.StopEmulation || GUI.PauseEmulation) \
				break; \
			S9xwPauseEmulation(TRUE); \
			S9xReset(); \
			ScreenBufferClear(); \
			if(GUI.FullScreen && DirectX.Windowed) \
			{ \
				if(!S9xwSwitchScreenMode(FALSE)) \
					break; \
			} \
			else \
				UpdateBackBuffer(); \
			S9xwPauseEmulation(FALSE); \
		 }        

#define S9XW_KEY_FILE_SOFTRESET \
		 if(XppMovie.Replay_status == MOVIE_NONE) \
		 { \
			if(GUI.StopEmulation || GUI.PauseEmulation) \
				break; \
			S9xwPauseEmulation(TRUE); \
			S9xSoftReset(); \
			ScreenBufferClear(); \
			if(GUI.FullScreen && DirectX.Windowed) \
			{ \
				if(!S9xwSwitchScreenMode(FALSE)) \
					break; \
			} \
			else \
				UpdateBackBuffer(); \
			S9xwPauseEmulation(FALSE); \
		 }         

#define S9XW_KEY_OPTION_JP \
			if(!Options.JPenvFlag) \
				break; \
			S9xwPauseEmulation(TRUE); \
			S9xwPauseLock = TRUE; \
			GUI.Language = !GUI.Language; \
			if(DirectX.Windowed && GetMenu( GUI.hWnd) != NULL) { \
				SetMenu( GUI.hWnd, NULL); \
				GUI.AppMenuConnect = FALSE; \
				if(GUI.hRecentGamesMenu) \
					DestroyMenu(GUI.hRecentGamesMenu); \
				GUI.hRecentGamesMenu = 0; \
				DestroyMenu(GUI.hMenu); \
				GUI.hMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE( Languages[ GUI.Language].idMenu)); \
				InsertMenu(GetSubMenu(GUI.hMenu, 3), 2, MF_BYPOSITION, ID_OPTION_JP, GUI.Language ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U"); \
				SetMenu( GUI.hWnd, GUI.hMenu); \
				GUI.AppMenuConnect = TRUE; \
				DrawMenuBar( GUI.hWnd); \
			} \
			else { \
				if(GUI.hRecentGamesMenu) \
					DestroyMenu(GUI.hRecentGamesMenu); \
				GUI.hRecentGamesMenu = 0; \
				DestroyMenu(GUI.hMenu); \
				GUI.AppMenuConnect = FALSE; \
				GUI.hMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE( Languages[ GUI.Language].idMenu)); \
				InsertMenu(GetSubMenu(GUI.hMenu, 3), 2, MF_BYPOSITION, ID_OPTION_JP, GUI.Language ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U"); \
			} \
			/*VXej[̃{[xj[ǉ*/ \
				DeleteMenu(GUI.hSysMenu, 0, MF_BYPOSITION); \
				DeleteMenu(GUI.hSysMenu, 0, MF_BYPOSITION); \
				GUI.hVolMenu = LoadMenu((HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), MAKEINTRESOURCE(IDR_VOLMENU)); \
				InsertMenu(GUI.hSysMenu, 0, MF_BYPOSITION | MF_POPUP, (UINT)GetSubMenu(GUI.hVolMenu, 0), (GUI.Language ? "{[x(&V)" : "&Volume Level")); \
				InsertMenu(GUI.hSysMenu, 1, MF_BYPOSITION | MFT_SEPARATOR, 0, 0); \
			S9xwPauseLock = FALSE; \
			S9xwPauseEmulation(FALSE);        

#define S9XW_KEY_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC \
			if(Settings.TurboSkipFrames > 1) \
				Settings.TurboSkipFrames--; \
			else \
				Settings.TurboSkipFrames = 1; \
			lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{XLbvt[ " : "TurboSkipFrames "); \
			wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d", Settings.TurboSkipFrames); \
			S9xMessage2 (OnScreenMessageStr, 2000);        

#define S9XW_KEY_OPTION_VLDOWN \
			if(Options.VolumeLevel > 1) \
				--Options.VolumeLevel; \
			lstrcpy(OnScreenMessageStr, "Level "); \
			wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Options.VolumeLevel); \
			lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "{[Down" : "Volume Down"); \
			S9xMessage2 (OnScreenMessageStr, 2000);        

#define S9XW_KEY_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC \
			if(Settings.TurboSkipFrames < 15) \
				Settings.TurboSkipFrames++; \
			else \
				Settings.TurboSkipFrames = 15; \
			lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{XLbvt[ " : "TurboSkipFrames "); \
			wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d", Settings.TurboSkipFrames); \
			S9xMessage2 (OnScreenMessageStr, 2000);        

#define S9XW_KEY_OPTION_VLUP \
			if(Options.VolumeLevel < 5) \
				++Options.VolumeLevel; \
			lstrcpy(OnScreenMessageStr, "Level "); \
			wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Options.VolumeLevel); \
			lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "{[Up" : "Volume Up"); \
			S9xMessage2 (OnScreenMessageStr, 2000);        


#define S9XW_KEY_FILE_ZSTSAVE \
 			if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen)) \
				break; \
			{ \
				uint8 zstsaveerr; \
				S9xwPauseEmulation(TRUE); \
				extern bool8 S9xFreezeZSNES (const char *filename); \
				zstsaveerr = S9xFreezeZSNES(S9xGetFilename(".zst")); \
				if(GUI.PauseEmulation) \
					S9xSetSoundMute (TRUE); \
				else \
					S9xwPauseEmulation(FALSE); \
				if(zstsaveerr) \
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? ".zst Z[u" : ".zst saved", 2000); \
				else \
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "G[!" : "Error!", 2000); \
			}

#define S9XW_KEY_FILE_ZSTLOAD \
		   if(XppMovie.Replay_status == MOVIE_NONE) \
		   { \
				bool8 loaderr; \
				S9xwPauseEmulation(TRUE); \
				loaderr = S9xUnfreezeGame(S9xGetFilename(".zst")); \
				if(GUI.PauseEmulation) \
					S9xSetSoundMute (TRUE); \
				else \
					S9xwPauseEmulation(FALSE); \
				if(loaderr) \
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? ".ZST (Loaded)" : ".ZST (Loaded)", 2000); \
				else \
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000); \
		   }

#define S9XW_KEY_OPTION_FULLSCREEN \
				if((DirectX.Windowed && DirectX.Depth == 8)) \
					break; \
				S9xwPauseEmulation(TRUE); \
				/*tXN[[hŃEChEԂŃj[쒆cAǂݍłȂEChE[h*/ \
				if(GUI.FullScreen && DirectX.Windowed || (!GUI.FullScreen && DirectX.Windowed && GUI.StopEmulation)) \
					GUI.FullScreen = !GUI.FullScreen; \
				/*tXN[*/ \
				else if(!GUI.FullScreen && DirectX.Windowed && !GUI.StopEmulation) { \
				Hires_Full = true; \
				ScreenBufferClear(); \
				UpdateBackBuffer(); \
					if(!S9xwSwitchScreenMode(FALSE)) \
						break; \
				} \
				/*EChE*/ \
				else if(GUI.FullScreen && !DirectX.Windowed && !GUI.StopEmulation) { \
				Hires_Normal = true; \
				ScreenBufferClear(); \
				UpdateBackBuffer(); \
					if(!S9xwSwitchScreenMode(TRUE)) \
						break; \
				} \
				S9xwPauseEmulation(FALSE);

#define S9XW_KEY_FILE_SCREENSHOT \
				S9xwPauseEmulation(TRUE); \
				S9xwPauseLock = TRUE; \
				/*Select image file format.*/ \
				if(Options.SaveImagefileFormat == 0) \
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".BMP")); \
				else if(Options.SaveImagefileFormat == 1) \
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".PCX")); \
				else if(Options.SaveImagefileFormat == 2) \
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".GIF")); \
				else if(Options.SaveImagefileFormat == 3) \
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".PNG")); \
				else \
					ErrResult = S9xSaveScreenImage(S9xwGetScreenImageFilename(".BMP")); \
				if(ErrResult) { \
					lstrcpy(OnScreenMessageStr, S9xwGetSavedScreenImageNumberAndTypeStr()); \
					lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? " Z[u" : " saved"); \
				} \
				else \
					lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "G[!" : "Error!"); \
				S9xwPauseLock = FALSE; \
				S9xwPauseEmulation(FALSE); \
				S9xMessage2 (OnScreenMessageStr, 2000);

#define S9XW_KEY_FILE_SPCDUMP \
			ErrResult = S9xwSPCDump(S9xwGetSPCFilename(), (GUI.PauseEmulation || (GUI.FullScreen && DirectX.Windowed)) ? TRUE : FALSE); \
			if(ErrResult) { \
				lstrcpy(OnScreenMessageStr, S9xwGetSavedSPCNumberAndExtStr()); \
				lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? " Z[u" : " saved"); \
			} \
			else \
				lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "G[!" : "Error!"); \
			S9xMessage2 (OnScreenMessageStr, 2000);

#define S9XW_DISPLAY_SETTING_CHANGE_PROCESSING \
			if(dRendering) \
				DirectX.ForceWindowedDirectDrawClipper = FALSE; \
			else \
				DirectX.ForceWindowedDirectDrawClipper = ForceWindowedDirectDrawClipper; \
 \
			if(GUI.FullScreen) \
			{ \
				if(!(errConfigSwitch = !S9xwSwitchScreenMode(TRUE))) \
				GUI.FullScreen = TRUE; \
				break; \
			} \
			else \
			{ \
				if(!(errConfigSwitch = !S9xwSwitchScreenMode(TRUE))) \
				GUI.FullScreen = FALSE; \
			} \
 \
			Draw1FrameFlag = TRUE; \
			if(errConfigSwitch) \
				break; \
			UIExit(); \
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) \
				S9xMessage2 ("EraseMouseCursor", 1000);


#define S9XW_ESC_KEY \
			/*EChE[h*/ \
			if(DirectX.Windowed && !GUI.FullScreen) { \
				if(GetMenu( GUI.hWnd) == NULL) { \
					SetMenu( GUI.hWnd, GUI.hMenu); \
					GUI.AppMenuConnect = TRUE; \
					DrawMenuBar( GUI.hWnd); \
				} \
				else { \
					SetMenu( GUI.hWnd, NULL); \
					GUI.AppMenuConnect = FALSE; \
				} \
				GetClientRect(GUI.hWnd, &rc); \
				hdc = GetDC(GUI.hWnd); \
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH)); \
				ReleaseDC(GUI.hWnd, hdc); \
				S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu); \
				if(GUI.StopEmulation) \
					ScreenRedraw(hWnd); \
			} \
			/*tXN[[h*/ \
			else if(!DirectX.Windowed && GUI.FullScreen) { \
				ScreenBufferClear(); \
				UpdateBackBuffer(); \
				S9xwPauseEmulation(TRUE); \
				S9xwPauseLock = TRUE; \
				if(S9xwSwitchScreenMode(TRUE)) { \
					GUI.FullScreen = TRUE; \
					S9xwSetClipper(TRUE); \
					S9xwPauseLock = FALSE; \
				} \
				else \
					break; \
			} \
			else if(DirectX.Windowed && GUI.FullScreen && !GUI.StopEmulation) { \
				ScreenBufferClear(); \
				UpdateBackBuffer(); \
				if(S9xwSwitchScreenMode(FALSE)) \
					S9xwPauseEmulation(FALSE); \
				else \
					break; \
			} \

#define S9XW_TURBO_MODE_KEY \
			/*^[{[h*/ \
			Settings.TurboMode = !Settings.TurboMode; \
			if(Settings.TurboMode) { \
				lstrcpy(WindowTitleTextNormal, WindowTitleTextTurbo); \
				if(!GUI.PauseEmulation) \
					lstrcpy(WindowTitleText, WindowTitleTextTurbo); \
				lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{[h I (XLbv " : "Turbo Mode on (Skip "); \
				wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d)", Settings.TurboSkipFrames); \
				S9xMessage2 (OnScreenMessageStr, 2000); \
			} \
			else { \
				lstrcpy(WindowTitleTextNormal, WindowTitleTextNormal_bak); \
				if(!GUI.PauseEmulation) \
					lstrcpy(WindowTitleText, WindowTitleTextNormal_bak); \
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "^[{[h It" : "Turbo Mode off", 2000); \
			} \

#define S9XW_XPP_REPLAY_RECODE \
		if(!Xppcode.CheatNumRock) \
		{ \
			                  IPPU.RenderThisFrame = TRUE; \
			                  IPPU.SkippedFrames = 0; \
			                  XppMovie.Replay_Type = 0; \
			                  XppMovie.Replay_status = MOVIE_RECODE; \
			                  XppMovie.Replay_count = 0; \
			                  S9xwStateSaveReplay(XppMovie.movie_ext_snap[XppMovie.Replay_Slot]); \
			                  XppMovie.Def_NormalSnap = Settings.Normalsnap; \
			                  Settings.Normalsnap = TRUE; \
			                  S9xwStateLoadReplay(XppMovie.movie_ext_snap[XppMovie.Replay_Slot]); \
			                  Settings.Normalsnap = XppMovie.Def_NormalSnap; \
			                  XPP_REPLAY_START(); \
		}

#define S9XW_XPP_REPLAY_PLAY \
		if(!Xppcode.CheatNumRock) \
		{ \
			                  IPPU.RenderThisFrame = TRUE; \
			                  IPPU.SkippedFrames = 0; \
			                  XppMovie.Replay_Type = 0; \
			                  XppMovie.Replay_status = MOVIE_PLAY; \
			                  XppMovie.Def_NormalSnap = Settings.Normalsnap; \
			                  Settings.Normalsnap = TRUE; \
			                  S9xwStateLoadReplay(XppMovie.movie_ext_snap[XppMovie.Replay_Slot]); \
			                  if(!XppMovie.file_open_error) \
			                  { \
			                      XPP_REPLAY_LOAD (XppMovie.movie_ext_trace[XppMovie.Replay_Slot]); \
			                  } \
			                  Settings.Normalsnap = XppMovie.Def_NormalSnap; \
			                  XPP_REPLAY_START(); \
		}

#define S9XW_XPP_REPLAY_STOP \
		if(XppMovie.Replay_status == MOVIE_RECODE || XppMovie.Replay_status == MOVIE_PLAY || !Xppcode.CheatNumRock) \
		{ \
			      if(XppMovie.Replay_status == MOVIE_RECODE) \
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Stop" : "Movie Rec Stop", 2000); \
 \
			      if(XppMovie.Replay_status == MOVIE_PLAY) \
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Stop" : "Movie Play Stop", 2000); \
 \
			      XPP_REPLAY_END (); \
		}

#define S9XW_XPP_REPLAY_RESUME_LOAD \
		if(XppMovie.Replay_status == MOVIE_RECODE || XppMovie.Replay_status == MOVIE_PLAY || !Xppcode.CheatNumRock) \
		{ \
			                  IPPU.RenderThisFrame = TRUE; \
			                  IPPU.SkippedFrames = 0; \
			                  XppMovie.Def_NormalSnap = Settings.Normalsnap; \
			                  Settings.Normalsnap = TRUE; \
			                  S9xwStateLoadReplay(XppMovie.resume_ext_snap[XppMovie.Replay_Slot]); \
			                  if(!XppMovie.file_open_error) \
			                  { \
			                      XPP_REPLAY_LOAD (XppMovie.resume_ext_trace[XppMovie.Replay_Slot]); \
			                      XPP_REPLAY_RESUME (REPLAY_LOAD); \
			                      XPP_REPLAY_RESUME (REPLAY_CLEAR); \
                              } \
			                  Settings.Normalsnap = XppMovie.Def_NormalSnap; \
			                  IPPU.RenderThisFrame = TRUE; \
 \
			      if(XppMovie.Replay_status == MOVIE_RECODE) \
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Resume Load" : "Movie Rec Resume Load", 2000); \
 \
			      if(XppMovie.Replay_status == MOVIE_PLAY) \
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Resume Load" : "Movie Play Resume Load", 2000); \
		}


#define S9XW_XPP_REPLAY_RESUME_SAVE \
		if(XppMovie.Replay_status == MOVIE_RECODE || XppMovie.Replay_status == MOVIE_PLAY || !Xppcode.CheatNumRock) \
		{ \
			                  IPPU.RenderThisFrame = TRUE; \
			                  IPPU.SkippedFrames = 0; \
			                  S9xwStateSaveReplay(XppMovie.resume_ext_snap[XppMovie.Replay_Slot]); \
			                  XPP_REPLAY_RESUME (REPLAY_SAVE); \
			                  XPP_REPLAY_SAVE (XppMovie.resume_ext_trace[XppMovie.Replay_Slot]); \
                              XppMovie.Def_NormalSnap = Settings.Normalsnap; \
			                  Settings.Normalsnap = TRUE; \
			                  S9xwStateLoadReplay(XppMovie.resume_ext_snap[XppMovie.Replay_Slot]); \
			                  if(!XppMovie.file_open_error) \
			                  { \
			                      XPP_REPLAY_LOAD (XppMovie.resume_ext_trace[XppMovie.Replay_Slot]); \
			                      XPP_REPLAY_RESUME (REPLAY_LOAD); \
			                      XPP_REPLAY_RESUME (REPLAY_CLEAR); \
			                  } \
			                  Settings.Normalsnap = XppMovie.Def_NormalSnap; \
			                  IPPU.RenderThisFrame = TRUE; \
 \
			      if(XppMovie.Replay_status == MOVIE_RECODE) \
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Resume Save" : "Movie Rec Resume Save", 2000); \
 \
			      if(XppMovie.Replay_status == MOVIE_PLAY) \
			                  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Resume Save" : "Movie Play Resume Save", 2000); \
		}

#define S9XW_XPP_REPLAY_RESUME_RELOAD \
		if(XppMovie.Replay_status == MOVIE_RECODE || XppMovie.Replay_status == MOVIE_PLAY || !Xppcode.CheatNumRock) \
		{ \
			   			   XPP_REPLAY_END (); \
			               IPPU.RenderThisFrame = TRUE; \
                           IPPU.SkippedFrames = 0; \
			               XppMovie.Def_NormalSnap = Settings.Normalsnap; \
			               Settings.Normalsnap = TRUE; \
			               S9xwStateLoadReplay(XppMovie.resume_ext_snap[XppMovie.Replay_Slot]); \
			               if(!XppMovie.file_open_error) \
			               { \
			                   XPP_REPLAY_LOAD (XppMovie.resume_ext_trace[XppMovie.Replay_Slot]); \
                               XPP_REPLAY_RESUME (REPLAY_LOAD); \
                               XPP_REPLAY_RESUME (REPLAY_CLEAR); \
                           } \
			               Settings.Normalsnap = XppMovie.Def_NormalSnap; \
			               IPPU.RenderThisFrame = TRUE; \
 \
			      if(XppMovie.Replay_status == MOVIE_RECODE) \
			               S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Resume Load" : "Movie Rec Resume Load", 2000); \
 \
			      if(XppMovie.Replay_status == MOVIE_PLAY) \
			               S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Resume Load" : "Movie Play Resume Load", 2000); \
		}

#define S9XW_XPP_KEY_05 \
			    if(Settings.FrameTimeNTSC == 16 && Settings.FrameTimePAL == 20) \
			    { \
			         int Game_Speed = 0; \
			         Xppsystem.SpeedEnable ^= 1; \
			               if(!Xppsystem.SpeedEnable) \
			               { \
			                  ResetFrameTimer (); \
			                  Game_Speed = 100; \
			               } \
 			               else if(Xppsystem.Speedflag == 0) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 75; \
			                  else \
			                  PCFrameTime = (__int64)((float)PCBase / 62.5f); \
			                  Game_Speed = 125; \
			               } \
 			               else if(Xppsystem.Speedflag == 1) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 90; \
			                  else \
			                  PCFrameTime = PCBase / 75; \
			                  Game_Speed = 150; \
			               } \
 			               else if(Xppsystem.Speedflag == 2) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 120; \
			                  else \
			                  PCFrameTime = PCBase / 100; \
			                  Game_Speed = 200; \
			               } \
 			               else if(Xppsystem.Speedflag == 3) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 180; \
			                  else \
			                  PCFrameTime = PCBase / 150; \
			                  Game_Speed = 300; \
			               } \
 			               else if(Xppsystem.Speedflag == 4) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 45; \
			                  else \
			                  PCFrameTime = (__int64)((float)PCBase / 37.5f); \
			                  Game_Speed = 75; \
			               } \
 			               else if(Xppsystem.Speedflag == 5) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 30; \
			                  else \
			                  PCFrameTime = PCBase / 25; \
			                  Game_Speed = 50; \
			               } \
 			               else if(Xppsystem.Speedflag == 6) \
			               { \
			                  if(!Settings.PAL) \
			                  PCFrameTime = PCBase / 15; \
			                  else \
			                  PCFrameTime = (__int64)((float)PCBase / 12.5f); \
			                  Game_Speed = 25; \
			               } \
 \
 			               lstrcpy(OnScreenMessageStr, "Change Game Speed "); \
 			               wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Game_Speed); \
 			               lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "%" : "%"); \
 			               S9xMessage2 (OnScreenMessageStr, 2000); \
 \
			    }

#define S9XW_XPP_KEY_06 \
			    if(Settings.FrameTimeNTSC == 16 && Settings.FrameTimePAL == 20) \
			    { \
			        int Game_Speed = 0; \
			               if(Xppsystem.Speedflag < 6)  \
			                  Xppsystem.Speedflag++; \
			               else \
			                  Xppsystem.Speedflag=0; \
 \
			               if(Xppsystem.Speedflag == 0) \
			               Game_Speed = 125; \
			               else if(Xppsystem.Speedflag == 1) \
			               Game_Speed = 150; \
			               else if(Xppsystem.Speedflag == 2) \
			               Game_Speed = 200; \
			               else if(Xppsystem.Speedflag == 3) \
			               Game_Speed = 300; \
			               else if(Xppsystem.Speedflag == 4) \
			               Game_Speed = 75; \
			               else if(Xppsystem.Speedflag == 5) \
			               Game_Speed = 50; \
			               else if(Xppsystem.Speedflag == 6) \
			               Game_Speed = 25; \
 \
 			               lstrcpy(OnScreenMessageStr, "XPP KEY 5 - Change Game Speed "); \
 			               wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Game_Speed); \
 			               lstrcat(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "%" : "%"); \
 			               S9xMessage2 (OnScreenMessageStr, 2000); \
			    }


