#include "../Snes9x/Snes9x.h"

static char *CBMemtypeStr_JP[] ={"F", "LoROM", "HiROM"};
static char *CBFormatStr_JP[] ={"F", "C^[[u", "C^[[u", "C^[[uQ"};
static char *CBVideoSystemStr_JP[] ={"F", "PALw", "NTSCw"};
static char *CBHeaderStr_JP[] ={"F", "wb_", "wb_L苭"};
static char *CBAPURAMInitialValueStr_JP[] ={"0xFF NA (ftHg)", "0x00 NA"};

static char *CBMemtypeStr_US[] ={"Auto detect", "Force HiROM", "Force LoROM"};
static char *CBFormatStr_US[] ={"Auto detect", "Force not interleaved", "Force interleaved", "Force InterleavedMode2"};
static char *CBVideoSystemStr_US[] ={"Auto detect", "Force PAL", "Force NTSC"};
static char *CBHeaderStr_US[] ={"Auto detect", "Force no header", "Force header"};
static char *CBAPURAMInitialValueStr_US[] ={"0xFF Clear (default)", "0x00 Clear"};

LRESULT CALLBACK GetOpenFileNameHook(HWND hWnd, UINT uMsg,WPARAM wParam, LPARAM lParam)
{
//	static DWORD Style;
	static int i;
	switch (uMsg) {
		case WM_INITDIALOG:
			//OFN_EXPLOREȐꍇ͐eEChEnh擾
//			Style = GetWindowLong(GetParent(hWnd), GWL_EXSTYLE );
//			Style &= ~(WS_EX_CONTEXTHELP);
//			SetWindowLong(GetParent(hWnd), GWL_EXSTYLE, Style);
			for(i = 0; i < 3; i++)
				SendMessage(GetDlgItem(hWnd, IDC_COMBO_MEMTYPE), CB_INSERTSTRING, (WPARAM)i, (LPARAM)(GUI.Language ? CBMemtypeStr_JP[i] : CBMemtypeStr_US[i]));
			SendMessage(GetDlgItem(hWnd, IDC_COMBO_MEMTYPE), CB_SETCURSEL, 0, 0);
			for(i = 0; i < 4; i++)
				SendMessage(GetDlgItem(hWnd, IDC_COMBO_FORMAT), CB_INSERTSTRING, (WPARAM)i, (LPARAM)(GUI.Language ? CBFormatStr_JP[i] : CBFormatStr_US[i]));
			SendMessage(GetDlgItem(hWnd, IDC_COMBO_FORMAT), CB_SETCURSEL, 0, 0);
			for(i = 0; i < 3; i++)
				SendMessage(GetDlgItem(hWnd, IDC_COMBO_VIDEOSYSTEM), CB_INSERTSTRING, (WPARAM)i, (LPARAM)(GUI.Language ? CBVideoSystemStr_JP[i] : CBVideoSystemStr_US[i]));
			SendMessage(GetDlgItem(hWnd, IDC_COMBO_VIDEOSYSTEM), CB_SETCURSEL, 0, 0);
			for(i = 0; i < 3; i++)
				SendMessage(GetDlgItem(hWnd, IDC_COMBO_HEADER), CB_INSERTSTRING, (WPARAM)i, (LPARAM)(GUI.Language ? CBHeaderStr_JP[i] : CBHeaderStr_US[i]));
			SendMessage(GetDlgItem(hWnd, IDC_COMBO_HEADER), CB_SETCURSEL, 0, 0);
			for(i = 0; i < 2; i++)
				SendMessage(GetDlgItem(hWnd, IDC_COMBO_APURAMINITIALVALUE), CB_INSERTSTRING, (WPARAM)i, (LPARAM)(GUI.Language ? CBAPURAMInitialValueStr_JP[i] : CBAPURAMInitialValueStr_US[i]));
			SendMessage(GetDlgItem(hWnd, IDC_COMBO_APURAMINITIALVALUE), CB_SETCURSEL, 0, 0);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_COMBO_MEMTYPE:
				case IDC_COMBO_FORMAT:
				case IDC_COMBO_VIDEOSYSTEM:
				case IDC_COMBO_HEADER:
				case IDC_COMBO_APURAMINITIALVALUE:
					if(HIWORD(wParam) == CBN_SELENDOK) {
						i = (int)SendMessage(GetDlgItem(hWnd, (int)LOWORD(wParam)), CB_GETCURSEL, 0, 0);
						if(LOWORD(wParam) == IDC_COMBO_MEMTYPE) {
							if(i == 0) {
								Settings.ForceLoROM = Settings.ForceHiROM = 0;
							}
							else if(i == 1) {
								Settings.ForceLoROM = 1;
								Settings.ForceHiROM = 0;
							}
							else if(i == 2) {
								Settings.ForceLoROM = 0;
								Settings.ForceHiROM = 1;
							}
							else {
								Settings.ForceLoROM = Settings.ForceHiROM = 0;
							}
						}
						else if(LOWORD(wParam) == IDC_COMBO_FORMAT) {
							if(i == 0) {
								Settings.ForceInterleaved = Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
							}
							else if(i == 1) {
								Settings.ForceInterleaved = Settings.ForceInterleaved2 = 0;
								Settings.ForceNotInterleaved = 1;
							}
							else if(i == 2) {
								Settings.ForceInterleaved = 1;
								Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
							}
							else if(i == 3) {
								Settings.ForceInterleaved = Settings.ForceNotInterleaved = 0;
								Settings.ForceInterleaved2 = 1;
							}
							else {
								Settings.ForceInterleaved = Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
							}
						}
						else if(LOWORD(wParam) == IDC_COMBO_VIDEOSYSTEM) {
							if(i == 0) {
								Settings.ForcePAL = Settings.ForceNTSC = 0;
							}
							else if(i == 1) {
								Settings.ForcePAL = 1;
								Settings.ForceNTSC = 0;
							}
							else if(i == 2) {
								Settings.ForcePAL = 0;
								Settings.ForceNTSC = 1;
							}
							else {
								Settings.ForcePAL = Settings.ForceNTSC = 0;
							}
						}
						else if(LOWORD(wParam) == IDC_COMBO_HEADER) {
							if(i == 0) {
								Settings.ForceHeader = Settings.ForceNoHeader = 0;
							}
							else if(i == 1) {
								Settings.ForceNoHeader = 1;
								Settings.ForceHeader = 0;
							}
							else if(i == 2) {
								Settings.ForceNoHeader = 0;
								Settings.ForceHeader = 1;
							}
							else {
								Settings.ForceHeader = Settings.ForceNoHeader = 0;
							}
						}
						else if(LOWORD(wParam) == IDC_COMBO_APURAMINITIALVALUE) {
							if(i == 0) {
								Options.APURAMInitialValue0 = 0xff;
							}
							else if(i == 1) {
								Options.APURAMInitialValue0 = 0x00;
							}
							else {
								Options.APURAMInitialValue0 = 0xff;
							}
						}
					}
					break;
			}
			break;

		default:
			break;
	}
	return FALSE;
}

//#define OFN_ENABLESIZING             0x00800000

BOOL OpenFile(HWND hWnd, char *FileName, char *FileTitle, char *InitialROMFileDirectory)
{
	OPENFILENAME ofn;
	BOOL ret;
	FillMemory((PVOID)&ofn, sizeof(ofn), 0);

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hWnd;
	ofn.hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	ofn.lpstrFilter = "All Supported Types\0*.smc;*.sfc;*.swc;*.fig;*.078;*.zip;*.lzh;*.cab;*.1\0All files(*.*)\0*.*\0\0";
	ofn.lpstrFile = FileName;
	ofn.nMaxFile = _MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NONETWORKBUTTON | OFN_EXPLORER |
	0x00800000 | OFN_ENABLEHOOK | OFN_ENABLETEMPLATE;
	ofn.lpstrDefExt = "smc";
	ofn.nMaxFileTitle = _MAX_PATH;
	ofn.lpstrFileTitle = FileTitle;
	ofn.lpstrTitle = (GUI.Language ? "ǂݍ" : "Open ROM");
	ofn.lpfnHook = (LPOFNHOOKPROC)GetOpenFileNameHook;
	ofn.lpstrInitialDir = InitialROMFileDirectory;
	ofn.lpTemplateName = MAKEINTRESOURCE(GUI.Language ? IDD_GETOPENFILENAMECUSTDIALOG_JP : IDD_GETOPENFILENAMECUSTDIALOG_US);
	ret = GetOpenFileName(&ofn);

	//[W^CvwNA
	if(!ret) {
		Settings.ForceLoROM = Settings.ForceHiROM = 0;
		Settings.ForceInterleaved = Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
		Settings.ForcePAL = Settings.ForceNTSC = 0;
		Settings.ForceHeader = Settings.ForceNoHeader = 0;
		Options.APURAMInitialValue0 = 0xff;
	}
	return ret;
}
