#include "../snes9x/snes9x.h"
#include "../snes9x/ppu.h"
#include "DirectX.h"
#include "Render.h"
#include "g_macro.h"

// Contains the pointer to the now active render method
TRenderMethod OldRenderMethod;
TRenderMethod RenderMethod;
TRenderMethodd OldRenderMethodd;
TRenderMethodd RenderMethodd;
extern "C" {
unsigned char ExtendHeight = FALSE;
unsigned char ExtendHeight_bak = FALSE;
unsigned char DoubleHeight = FALSE;
unsigned char DoubleWidth = FALSE;
unsigned char HiresModeDetectedFlag = FALSE;
unsigned char HiresModeDetectedFlag_Now = FALSE;
unsigned char HiresModeDetectedFlag_Old = FALSE;
}

#define RES_512_478  0x10
#define RES_512_239  0x20
#define RES_256_239  0x30

void SelectRenderMethodNormal();
void SelectRenderMethoddNormal();
unsigned char ConvertDepthNormal (SSurface *src, SSurface *dst, RECT *srect, RECT *drect);

void (*SelectRenderMethod)() = SelectRenderMethodNormal;
void (*SelectRenderMethodd)() = SelectRenderMethoddNormal;
TRenderMethodd ConvertDepth = ConvertDepthNormal;

void SelectRenderingCodes()
{
		SelectRenderMethod = SelectRenderMethodNormal;
		SelectRenderMethodd = SelectRenderMethoddNormal;
		ConvertDepth = ConvertDepthNormal;
}

// C Rendering codes
extern "C" void RenderNothing( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void Render16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderDouble16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderFakeTV16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderTV16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderSuperEagle16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void Render2xSaI16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderScale_2xSaI16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderSuper2xSaI16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderHQ2X16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderLQ2X16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderInterlaceScanLines16to16( SSurface Src, SSurface Dst, RECT *srcRect);
extern "C" void RenderInterlace16to16( SSurface Src, SSurface Dst, RECT *srcRect);

void SelectRenderMethodNormal()
{
	OldRenderMethod = RenderMethod;
	RenderMethod = RenderNothing;

	if(GUI.ScreenDepth == 8)
	{
		SOFT_RENDER_SET
	}
	else if(GUI.ScreenDepth == 16)
	{
		SOFT_RENDER_SET
	}
	else if(GUI.ScreenDepth == 24)
	{
		SOFT_RENDER_SET
	}
	else if(GUI.ScreenDepth == 32)
	{
		SOFT_RENDER_SET
	}
	else
		RenderMethod = RenderNothing;
}

extern "C" void RenderNothing( SSurface Src, SSurface Dst, RECT *srcRect)
{ // Just an empty procedure, so that it never happens that something 'bad' is rendered =)
}

extern "C" unsigned char dRenderNothing( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{ // Just an empty procedure, so that it never happens that something 'bad' is rendered =)
	return FALSE;
}

void ResetRenderMethod()
{
	RenderMethod = RenderNothing;
	RenderMethodd = dRenderNothing;
}

// Needed by Render2xSaI16to16 and other
//void SuperEagle( uint8 *srcPtr, uint32 srcPitch, uint8 *dstPtr, uint32 dstPitch, uint32 height, uint32 width);
void SuperEagle(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void _2xSaI(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void Super2xSaI(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void Scale_2xSaI (uint8 *srcPtr, uint32 srcPitch, uint8 * /* deltaPtr */,
		  uint8 *dstPtr, uint32 dstPitch, 
		  uint32 dstWidth, uint32 dstHeight, int width, int height);
void SuperEagleAsmMMX(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void _2xSaIAsmMMX(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void Super2xSaIAsmMMX(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void Scale_2xSaIAsmMMX (uint8 *srcPtr, uint32 srcPitch, uint8 * /* deltaPtr */,
		  uint8 *dstPtr, uint32 dstPitch, 
		  uint32 dstWidth, uint32 dstHeight, int width, int height);
void TVMode(uint8 *srcPtr, uint32 srcPitch,
	     uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height);

void FakeTV(uint8 *srcPtr, uint32 srcPitch,
	     uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height);

void hq2x(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);
void lq2x(uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr, uint8 *dstPtr, uint32 dstPitch, int width, int height);

void InterlaceScanLines(uint8 *srcPtr, uint32 srcPitch,
	     uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height);

void Interlace(uint8 *srcPtr, uint32 srcPitch,
	     uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height);

// Needed by RenderDouble16to16, stretches a single line
inline void DoubleLine16( unsigned long *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	for( unsigned int W = 0; W != Width; W ++, lpDst++, lpSrc++)
	{
		*lpDst = ((*lpSrc << 16) | *lpSrc);
	}
}

// Used as change log
unsigned char _2xSaI_Buffer[512*478*4];
// Needed when double buffering or when switching from another mode
unsigned char _2xSaI_TripleBuffer[512*478*4];

void _2xSaIBufferInit(SSurface Dst)
{
	memset(_2xSaI_Buffer, 0, 512*478*4);
	memset(_2xSaI_TripleBuffer, 0, 512*478*4);
//	if(!DirectX.DoubleBuffered)
		memset( Dst.Surface, 0, Dst.Pitch * Dst.Height);
	HiresModeDetectedFlag = FALSE;
	OldRenderMethod = RenderNothing;
}


extern "C" void Render16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	unsigned char *lpSrc, *lpDst;
	lpSrc = Src.Surface;

	srcRect->top    = (Dst.Height - Src.Height) / 2;
	srcRect->left   = (Dst.Width - Src.Width) / 2;
	srcRect->bottom = srcRect->top  + Src.Height;
	srcRect->right  = srcRect->left + Src.Width;

	lpDst = Dst.Surface;
	lpDst += ((Dst.Height - Src.Height) / 2) * Dst.Pitch;
	lpDst += Dst.Width - Src.Width;
	
	unsigned long SrcByteWidth = Src.Width<<1;

	for( unsigned int H = 0; H != Src.Height; H ++, lpDst += Dst.Pitch, lpSrc += Src.Pitch)
	{	
	memcpy( lpDst, lpSrc, SrcByteWidth);
	}
}

extern "C" void Render16to16Hires( SSurface Src, SSurface Dst, RECT *srcRect)
{
	unsigned char *lpSrc, *lpDst;
	lpSrc = Src.Surface;

	srcRect->top    = (Dst.Height - Src.Height) / 2;
	srcRect->left   = (Dst.Width - Src.Width) / 2;
	srcRect->bottom = srcRect->top  + Src.Height;
	srcRect->right  = srcRect->left + Src.Width;

	lpDst = Dst.Surface;
	lpDst += ((Dst.Height - Src.Height) / 2) * Dst.Pitch;
	lpDst += Dst.Width - Src.Width;
	
	unsigned long SrcByteWidth = Src.Width<<1;

	for( unsigned int H = 0; H != Src.Height; H ++, lpDst += Dst.Pitch, lpSrc += Src.Pitch)
	{
		memcpy( lpDst, lpSrc, SrcByteWidth);
	}
	HiresModeDetectedFlag = TRUE;
}

extern "C" void RenderDouble16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	 unsigned char *lpSrc, *lpDst;

	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight || DoubleWidth)
	{
		Render16to16Hires( Src, Dst, srcRect);
		return;
	}

	lpSrc = Src.Surface;

	unsigned int wSrcHeight = Src.Height << 1;

	srcRect->top    = (Dst.Height - wSrcHeight) / 2;
	srcRect->left   = (Dst.Width - 512) / 2;
	srcRect->bottom = srcRect->top  + wSrcHeight;
	srcRect->right  = srcRect->left + 512;

	lpDst = Dst.Surface;
	lpDst += ((Dst.Height - wSrcHeight) / 2) * Dst.Pitch;
	lpDst += Dst.Width - 512;

	for(unsigned int H = 0; H != Src.Height; H++, lpSrc += Src.Pitch, lpDst += Dst.Pitch)
	{
		DoubleLine16( (unsigned long *)lpDst, (unsigned short *)lpSrc, Src.Width);
		lpDst += Dst.Pitch;
		DoubleLine16( (unsigned long *)lpDst, (unsigned short *)lpSrc, Src.Width);
	}
}

// Scanline
extern "C" void RenderFakeTV16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

	//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		FakeTV( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		FakeTV( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);
}

extern "C" void RenderTV16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		TVMode( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		TVMode( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);
}

extern "C" void RenderSuperEagle16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		SuperEagle( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		SuperEagle( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);

	// S~ôłŎB
	extern BYTE ScreenBuffer[];
	FillMemory ((PVOID)ScreenBuffer, SCREEN_BUFFER, 0);
}

extern "C" void Render2xSaI16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		_2xSaI( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		_2xSaI( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);

	// S~ôłŎB
	extern BYTE ScreenBuffer[];
	FillMemory ((PVOID)ScreenBuffer, SCREEN_BUFFER, 0);
}

extern "C" void RenderScale_2xSaI16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
unsigned char *lpSrc, *lpDst;

	// If Snes9x is rendering anything in HiRes, then just copy, don't interpolate
	if( DoubleHeight || DoubleWidth)
	{	
		Render16to16Hires( Src, Dst, srcRect);
		return;
	}

	// Make sure the whole screen is redrawn when a rendermethod is switched
	if( OldRenderMethod != RenderMethod || HiresModeDetectedFlag || ExtendHeight_bak != ExtendHeight)
		_2xSaIBufferInit(Dst);

	lpSrc = Src.Surface;

	unsigned int wSrcHeight = Src.Height << 1;

	srcRect->top    = (Dst.Height - wSrcHeight) / 2;
	srcRect->left   = (Dst.Width - 512) / 2;
	srcRect->bottom = srcRect->top  + wSrcHeight;
	srcRect->right  = srcRect->left + 512;

	lpDst = Dst.Surface;
	lpDst += ((Dst.Height - wSrcHeight) / 2) * Dst.Pitch;
	lpDst += Dst.Width - 512;

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		Scale_2xSaI( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, 512, wSrcHeight, Src.Width, Src.Height);
		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		Scale_2xSaI( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, 512, wSrcHeight, Src.Width, Src.Height);
}

extern "C" void RenderSuper2xSaI16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		Super2xSaI( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		Super2xSaI( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);

	// S~ôłŎB
	extern BYTE ScreenBuffer[];
	FillMemory ((PVOID)ScreenBuffer, SCREEN_BUFFER, 0);
}

extern "C" void RenderHQ2X16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		hq2x( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		hq2x( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);
}

extern "C" void RenderLQ2X16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		lq2x( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		lq2x( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);
}

// Scanline
extern "C" void RenderInterlaceScanLines16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		InterlaceScanLines( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		InterlaceScanLines( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);
}

extern "C" void RenderInterlace16to16( SSurface Src, SSurface Dst, RECT *srcRect)
{
	SOFT_SCREEN_EFFECT_EXTRA_TYPE_01

//	if( DirectX.DoubleBuffered || OldRenderMethod != RenderMethod)
	if(OldRenderMethod != RenderMethod)
	{
		Interlace( lpSrc, Src.Pitch, _2xSaI_Buffer, _2xSaI_TripleBuffer, 1024, Src.Width, Src.Height);

		unsigned char *S = _2xSaI_TripleBuffer;
		for( unsigned int H = 0; H != wSrcHeight; H ++, S += 1024, lpDst += Dst.Pitch)
		{
			memcpy( lpDst, S, 1024);
		}
	} 
	else
		Interlace( lpSrc, Src.Pitch, _2xSaI_Buffer, lpDst, Dst.Pitch, Src.Width, Src.Height);
}

/*****************************************************************************/
/* Directly Render to screen code                                            */
/*****************************************************************************/

// C Rendering codes
extern "C" unsigned char dRender16to16( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderDouble16to16( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderFakeTV16to16( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRender16to8( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderDouble16to8( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderFakeTV16to8( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRender16to24( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderDouble16to24( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderFakeTV16to24( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRender16to32( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderDouble16to32( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);
extern "C" unsigned char dRenderFakeTV16to32( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect);

void SelectRenderMethoddNormal()
{
	OldRenderMethodd = RenderMethodd;
	RenderMethodd = dRenderNothing;

	if(DoubleHeight || DoubleWidth)
		HiresModeDetectedFlag = TRUE;

	//4-8 Hires software scale
	if(GUI.ScreenDepth == 8)
	switch( GUI.Scale)
	{
		case 0: 
			RenderMethodd = dRender16to8;
			break;
		case 1: 
			RenderMethodd = dRenderNothing;
			break;
		case 2: 
			RenderMethodd = dRenderDouble16to8;
			break;
		case 3: 
			RenderMethodd = dRenderFakeTV16to8;
			break;
		case 4: 
			RenderMethodd = dRenderDouble16to8;
			break;
		case 5:
			RenderMethodd = dRenderDouble16to8;
			break;
		case 6:
			RenderMethodd = dRenderDouble16to8;
			break;
		case 7:
			RenderMethodd = dRenderDouble16to8;
			break;
		case 8: 
			RenderMethodd = dRenderDouble16to8;
			break;
		case 9: 
			RenderMethodd = dRenderDouble16to8;
			break;
		case 10: 
			RenderMethodd = dRenderDouble16to8;
			break;
		case 11: 
			RenderMethodd = dRenderDouble16to8;
			break;
		case 12: 
			RenderMethodd = dRenderDouble16to8;
			break;
		default:
			RenderMethodd = dRenderNothing;
			break;
	}

	//4-8 Hires software scale
	else if(GUI.ScreenDepth == 16)
	switch( GUI.Scale)
	{
		case 0: 
			RenderMethodd = dRender16to16;
			break;
		case 1: 
			RenderMethodd = dRenderNothing;
			break;
		case 2: 
			RenderMethodd = dRenderDouble16to16;
			break;
		case 3: 
			RenderMethodd = dRenderFakeTV16to16;
			break;
		case 4: 
			RenderMethodd = dRenderDouble16to16;
			break;
		case 5:
			RenderMethodd = dRenderDouble16to16;
			break;
		case 6:
			RenderMethodd = dRenderDouble16to16;
			break;
		case 7:
			RenderMethodd = dRenderDouble16to16;
			break;
		case 8: 
			RenderMethodd = dRenderDouble16to16;
			break;
		case 9: 
			RenderMethodd = dRenderDouble16to16;
			break;
		case 10: 
			RenderMethodd = dRenderDouble16to16;
			break;
		case 11: 
			RenderMethodd = dRenderDouble16to16;
			break;
		case 12: 
			RenderMethodd = dRenderDouble16to16;
			break;
		default:
			RenderMethodd = dRenderNothing;
			break;
	}

	//4-8 Hires software scale
	else if(GUI.ScreenDepth == 24)
	switch( GUI.Scale)
	{
		case 0: 
			RenderMethodd = dRender16to24;
			break;
		case 1: 
			RenderMethodd = dRenderNothing;
			break;
		case 2: 
			RenderMethodd = dRenderDouble16to24;
			break;
		case 3: 
			RenderMethodd = dRenderFakeTV16to24;
			break;
		case 4: 
			RenderMethodd = dRenderDouble16to24;
			break;
		case 5:
			RenderMethodd = dRenderDouble16to24;
			break;
		case 6:
			RenderMethodd = dRenderDouble16to24;
			break;
		case 7:
			RenderMethodd = dRenderDouble16to24;
			break;
		case 8: 
			RenderMethodd = dRenderDouble16to24;
			break;
		case 9: 
			RenderMethodd = dRenderDouble16to24;
			break;
		case 10: 
			RenderMethodd = dRenderDouble16to24;
			break;
		case 11: 
			RenderMethodd = dRenderDouble16to24;
			break;
		case 12: 
			RenderMethodd = dRenderDouble16to24;
			break;
		default:
			RenderMethodd = dRenderNothing;
			break;
	}

	//4-8 Hires software scale
	else if(GUI.ScreenDepth == 32)
	switch( GUI.Scale)
	{
		case 0: 
			RenderMethodd = dRender16to32;
			break;
		case 1: 
			RenderMethodd = dRenderNothing;
			break;
		case 2: 
			RenderMethodd = dRenderDouble16to32;
			break;
		case 3: 
			RenderMethodd = dRenderFakeTV16to32;
			break;
		case 4: 
			RenderMethodd = dRenderDouble16to32;
			break;
		case 5:
			RenderMethodd = dRenderDouble16to32;
			break;
		case 6:
			RenderMethodd = dRenderDouble16to32;
			break;
		case 7:
			RenderMethodd = dRenderDouble16to32;
			break;
		case 8: 
			RenderMethodd = dRenderDouble16to32;
			break;
		case 9: 
			RenderMethodd = dRenderDouble16to32;
			break;
		case 10: 
			RenderMethodd = dRenderDouble16to32;
			break;
		case 11: 
			RenderMethodd = dRenderDouble16to32;
			break;
		case 12: 
			RenderMethodd = dRenderDouble16to32;
			break;
		default:
			RenderMethodd = dRenderNothing;
			break;
	}
	else
		RenderMethodd = dRenderNothing;
}

extern "C" uint8 S9xwPalette[];

inline void DoubleLine16to8( unsigned short *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	for (unsigned int W = 0; W != Width; W++, lpDst++, lpSrc++)
	{
		*lpDst = (S9xwPalette [*lpSrc] | S9xwPalette [*lpSrc] << 8);
	}
}

inline void Line16to8( unsigned char *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	for (unsigned int W = 0; W != Width; W++, lpDst++, lpSrc++)
	{
		*lpDst = S9xwPalette [*lpSrc];
	}
}

inline void DoubleLine16to24( unsigned char *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	uint32 pixel;
#ifdef LSB_FIRST
	if (GUI.RedShift < GUI.BlueShift)
#else	    
	if (GUI.RedShift > GUI.BlueShift)
#endif
		// Order is RGB
		for( unsigned int W = 0; W != Width; W++, lpDst += 6, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel & 0x1f) << 3;
			*(lpDst + 3) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 4) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 5) = (pixel & 0x1f) << 3;
		}
	else
		// Order is BGR
		for( unsigned int W = 0; W != Width; W++, lpDst += 6, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel & 0x1f) << 3;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 3) = (pixel & 0x1f) << 3;
			*(lpDst + 4) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 5) = (pixel >> (11 - 3)) & 0xf8;
		}
}

inline void Line16to24( unsigned char *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	uint32 pixel;
#ifdef LSB_FIRST
	if (GUI.RedShift < GUI.BlueShift)
#else	    
	if (GUI.RedShift > GUI.BlueShift)
#endif
		// Order is RGB
		for( unsigned int W = 0; W != Width; W++, lpDst += 3, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel & 0x1f) << 3;
		}
	else
		// Order is BGR
		for( unsigned int W = 0; W != Width; W++, lpDst += 3, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel & 0x1f) << 3;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel >> (11 - 3)) & 0xf8;
		}
}

inline void DoubleLine16to32( unsigned char *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	uint32 pixel;
#ifdef LSB_FIRST
	if (GUI.RedShift < GUI.BlueShift)
#else	    
	if (GUI.RedShift > GUI.BlueShift)
#endif
		// Order is RGB
		for( unsigned int W = 0; W != Width; W++, lpDst += 8, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel & 0x1f) << 3;
			*(lpDst + 4) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 5) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 6) = (pixel & 0x1f) << 3;
		}
	else
		// Order is BGR
		for( unsigned int W = 0; W != Width; W++, lpDst += 8, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel & 0x1f) << 3;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 4) = (pixel & 0x1f) << 3;
			*(lpDst + 5) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 6) = (pixel >> (11 - 3)) & 0xf8;
		}
}

inline void Line16to32( unsigned char *lpDst, unsigned short *lpSrc, unsigned int Width)
{
	uint32 pixel;
#ifdef LSB_FIRST
	if (GUI.RedShift < GUI.BlueShift)
#else	    
	if (GUI.RedShift > GUI.BlueShift)
#endif
		// Order is RGB
		for( unsigned int W = 0; W != Width; W++, lpDst += 4, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel >> (11 - 3)) & 0xf8;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel & 0x1f) << 3;
		}
	else
		// Order is BGR
		for( unsigned int W = 0; W != Width; W++, lpDst += 4, lpSrc++) {
			pixel = (uint32)(*lpSrc);
			*(lpDst) = (pixel & 0x1f) << 3;
			*(lpDst + 1) = (pixel >> (6 - 3)) & 0xf8;
			*(lpDst + 2) = (pixel >> (11 - 3)) & 0xf8;
		}
}

extern "C" unsigned char dRender16to16( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width2 = (srcRect->right - srcRect->left) << 1;
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 1));
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		memcpy( lpDst, lpSrc, (size_t)width2);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to16Hireshw( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width2 = (srcRect->right - srcRect->left) << 1;
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 1));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		memcpy( lpDst, lpSrc, (size_t)width2);
		lpDst += dPitch;
		memcpy( lpDst, lpSrc, (size_t)width2);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to16Hiresww( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 1));
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		DoubleLine16( (unsigned long *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderDouble16to16( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to16( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to16Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to16Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 1));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16( (unsigned long *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		DoubleLine16( (unsigned long *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

// Scanline
extern "C" unsigned char dRenderFakeTV16to16( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to16( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to16Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to16Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int width4 = width << 2;
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 1));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16( (unsigned long *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		memset( lpDst, 0, (size_t)width4);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to8( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + dstRect->left);
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		Line16to8(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to8Hireshw( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + dstRect->left);
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		Line16to8(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		Line16to8(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to8Hiresww( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + dstRect->left);
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to8((unsigned short *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderDouble16to8( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to8( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to8Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to8Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + dstRect->left);

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to8((unsigned short *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		DoubleLine16to8((unsigned short *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderFakeTV16to8( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to8( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to8Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to8Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int width2 = width << 1;
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + dstRect->left);

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to8((unsigned short *)lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		memset( lpDst, 0, (size_t)width2);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to24( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left * 3));
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		Line16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to24Hireshw( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left * 3));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		Line16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		Line16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to24Hiresww( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left * 3));
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		DoubleLine16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderDouble16to24( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to24( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to24Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to24Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left * 3));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		DoubleLine16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderFakeTV16to24( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to24( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to24Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to24Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int width6 = width * 6;
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left * 3));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to24(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		memset( lpDst, 0, (size_t)width6);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to32( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 2));
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		Line16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to32Hireshw( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 2));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		Line16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		Line16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRender16to32Hiresww( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 2));
	
	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{	
		DoubleLine16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderDouble16to32( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to32( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to32Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to32Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 2));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		DoubleLine16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
	}
	return TRUE;
}

extern "C" unsigned char dRenderFakeTV16to32( SSurface *Src, SSurface *Dst, RECT *srcRect, RECT *dstRect)
{
	// If Snes9x is rendering anything in HiRes, then just copy, don't stretch
	if( DoubleHeight && DoubleWidth)
	{
		dRender16to32( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( !DoubleHeight && DoubleWidth)
	{
		dRender16to32Hireshw( Src, Dst, srcRect, dstRect);
		return TRUE;
	}
	else if( DoubleHeight && !DoubleWidth)
	{
		dRender16to32Hiresww( Src, Dst, srcRect, dstRect);
		return TRUE;
	}

	int width = (srcRect->right - srcRect->left);
	int width8 = width << 3;
	int height = (srcRect->bottom - srcRect->top);

	unsigned int sPitch = Src->Pitch;
	unsigned int dPitch = Dst->Pitch;

	unsigned char *lpSrc = (Src->Surface + srcRect->top * sPitch + (srcRect->left << 1));
	unsigned char *lpDst = (Dst->Surface + dstRect->top * dPitch + (dstRect->left << 2));

	for(; height; height--, lpDst += dPitch, lpSrc += sPitch)
	{
		DoubleLine16to32(lpDst, (unsigned short *)lpSrc, (unsigned int)width);
		lpDst += dPitch;
		memset( lpDst, 0, (size_t)width8);
	}
	return TRUE;
}

unsigned char ConvertDepthNormal (SSurface *src, SSurface *dst, RECT *srect, RECT *drect)
{
	{
		// SNES image has been rendered in 16-bit, RGB565 format
		switch (GUI.ScreenDepth)
		{
			case 8:
				return dRender16to8 (src, dst, srect, drect);
			case 15:
			case 16:
				return FALSE;
			case 24:
				return dRender16to24 (src, dst, srect, drect);
			case 32:
				return dRender16to32 (src, dst, srect, drect);
			default:
				return FALSE;
		}
	}
	return FALSE;
}

