/*****************************************************************************/
/*  Snes9X: Win32                                                            */
/*****************************************************************************/
#include "../Snes9X/MemMap.H"
#include "../Snes9X/cheats.h"
#include "DirectX.h"
#include "Render.h"
#include "../Snes9X/apu.h"
#include "../Snes9X/cpuexec.h"
#include "s9xwproc.h"
#include "winutil.h"
#include "../Snes9xpp/s9xutil.h"
#include "../common/commutil.h"
#include "joywin.h"
#include "g_macro.h"

#include <windows.h>

__int64 PCBase, PCFrameTime, PCFrameTimeNTSC, PCFrameTimePAL, PCStart, PCEnd;
void ResetFrameTimer ();

/*****************************************************************************/
/* Snes9x proc extern                                                        */
/*****************************************************************************/
extern "C" void S9xMainLoop(void);
extern "C" void S9xSpinWaitLoop(void);
extern "C" void S9xSetInfoString (const char *string);
extern bool8 S9xSetSoundMute (bool8 mute);
extern bool8 S9xGraphicsInit ();
extern void S9xGraphicsDeinit (void);
extern "C" const char *S9xGetSRAMFilename ();
extern "C" const char *S9xBasename (const char *f);
extern "C" const char *S9xGetFilename (const char *e);
extern "C" void S9xNextController ();
extern void MakeTurboStatus();
extern void Change_Turbo_Key(int joy);
extern int Simultaneous_Key(int joy);
extern int superscope_turbo;
extern int superscope_pause;

/*****************************************************************************/
/* Snes9XW proc extern                                                        */
/*****************************************************************************/
extern void S9xSetWinPixelFormat ();

/*****************************************************************************/
/* Xpp proc extern                                                       */
/*****************************************************************************/
extern void S9xSoftReset (void);

/*****************************************************************************/
/* Snes9xpp proc extern                                                     */
/*****************************************************************************/
extern char *S9xwGetSPCFilename ();
extern char *S9xwGetSavedSPCNumberAndExtStr();
extern char *S9xwGetScreenImageFilename(char *ImageTypeExt);
extern char *S9xwGetSavedScreenImageNumberAndTypeStr();
extern bool InitSnes9X( void);
extern void DeinitSnes9X(void);
extern void ConfigDlgProp(HWND hWnd);
extern BOOL OpenFile(HWND hWnd, char *FileName, char *FileTitle, char *InitialROMFileDirectory);

/*****************************************************************************/
/* Snes9XppW proc define                                                     */
/*****************************************************************************/
static bool ROMLoadProc(char *FileName);
void ScreenRedraw(HWND hWnd);
void Draw1frame();
void S9xwSetClipper(bool clip);
void S9xwInactivateDraw();
void S9xMessage2 (const char *str, int TimeOut);
void SetPriorityClassAndThreadPriority(DWORD priocl, int threadprio);

/*****************************************************************************/
/* Variables extern                                                          */
/*****************************************************************************/
extern bool8 locked_surface;
extern bool8 errConfigSwitch;

/*****************************************************************************/
/* Variables define                                                          */
/*****************************************************************************/
static void (*EmuExecLoop)(void);

/*****************************************************************************/
/* Global variables                                                          */
/*****************************************************************************/
extern "C" {
struct sGUI GUI;
};

#ifdef SNES9XPP_FULL
char WindowTitleTextNormal_bak[] = "Snes9xpp XE for Windows";
char WindowTitleTextNormal[] = "Snes9xpp XE for Windows";
char WindowTitleTextPaused[] = "Snes9xpp XE for Windows - Paused";
char WindowTitleTextTurbo[] = "Snes9xpp XE for Windows - Turbo";
char WindowTitleText[256] = "Snes9xpp XE for Windows";
#else

char WindowTitleTextNormal_bak[] = "Snes9xpp SE for Windows";
char WindowTitleTextNormal[] = "Snes9xpp SE for Windows";
char WindowTitleTextPaused[] = "Snes9xpp SE for Windows - Paused";
char WindowTitleTextTurbo[] = "Snes9xpp SE for Windows - Turbo";
char WindowTitleText[256] = "Snes9xpp SE for Windows Windows";

#endif

bool Draw1FrameFlag = TRUE;

static bool S9xwPauseLock = FALSE;
static bool S9xExitFlag = 0;

struct SSoundRates SoundRates[24] = {
	{  8000, false, false},
	{ 11025, false, false},
	{ 22050, false, false},
	{ 32000, false, false},
	{ 44100, false, false},
	{ 48000, false, false},
	{  8000, false, true },
	{ 11025, false, true },
	{ 22050, false, true },
	{ 32000, false, true },
	{ 44100, false, true },
	{ 48000, false, true },
	{  8000,  true, false},
	{ 11025,  true, false},
	{ 22050,  true, false},
	{ 32000,  true, false},
	{ 44100,  true, false},
	{ 48000,  true, false},
	{  8000,  true, true },
	{ 11025,  true, true },
	{ 22050,  true, true },
	{ 32000,  true, true },
	{ 44100,  true, true },
	{ 48000,  true, true }};

struct sLanguages Languages[] = {
	{ IDR_MENU_US, 
	  "DirectX failed to initialize!", 
	  "DirectDraw failed to set the selected display mode!", 
	  "DirectSound failed to initialize, no sound will be played.",
	  "These settings won't take effect until you restart the emulator.",
	  "The frame timer failed to initialize, please do NOT select the automatic framerate option or Snes9X will crash!",
	  "Anything error occured! Snes9XW shutdown.",
	  "Memory allocation error! Snes9XW shutdown.",
	  "Display Graphic mode settings failed! Snes9XW shutdown.",
	  "DirectInput failed to initialize, WinAPI will be used."},
	{ IDR_MENU_JP, 
	  "DirectX Ɏs܂", 
	  "DirectDraw fBXvC[hݒɎs܂", 
	  "DirectSound Ɏs܂",
	  "These settings won't take effect until you restart the emulator.",
	  "^C}[Ɏs܂Aframerate(ftHg)̐ݒősꍇ̓NbV܂",
	  "̃G[NSnes9XWI܂",
	  "mۂɎs܂AI܂",
	  "fBXvCAOtBbN[h؂芷Ɏs܂AI܂",
	  "DirectInputɎs܂AWinAPIgp܂"}
	};

static struct DDisplayMode DisplayMode [15] = {
	{ 640, 480,16},
	{ 800, 600,16},
	{1024, 768,16},
	{1280, 1024,16},
	{1600, 1200,16},
	{ 320, 240,16},
	{1024, 600,16},
	{1152, 864,16},
	{1280, 768,16},
	{1280, 800,16},
	{1400, 1050,16},
	{1440, 900,16},
	{1680, 1050,16},
	{1900, 1200,16},
	{2048, 1536,16}};

/*****************************************************************************/
/* Snes9xppW Settings                                                        */
/*****************************************************************************/
bool8 TransparencyFlag;

bool8 Hires_Normal = true;
bool8 Hires_Full = true;

int DoubleRenderingModes16;
int FullscreenDisplayModeIndexDouble16 = 0;
int CurFullscreenDisplayModeIndex;
RECT WindowRectSetting = {-1, -1, -1, -1};

long DefaultWindowSizeW = 264 + 2;
long DefaultWindowSizeH = 286 + 1;

#define WinSizeWW (264+256 + 2)
#define WinSizeHH (286+239 + 1)
static long DefaultWindowSizeWW[23] = {WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW,WinSizeWW};
static long DefaultWindowSizeHH[23] = {WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH,WinSizeHH};

static long WindowSizeW = 264 + 2;
static long WindowSizeH = 286 + 1;

#define STRETCH_ADJUSTWINDOW 23

unsigned char dRendering;
unsigned char ForceWindowedDirectDrawClipper;

/*****************************************************************************/
/* Work variables                                                            */
/*****************************************************************************/
static HDC hdc;
static RECT rc;
static PAINTSTRUCT ps;
static HMENU hMenu;
static char tmpcharbuf[256];
static char OnScreenMessageStr[256] = {0};

/*****************************************************************************/
/* WinProc                                                                   */
/*****************************************************************************/

void ScreenBufferClear()
{
	extern BYTE ScreenBuffer[];
	extern BYTE SubScreenBuffer[];
	extern BYTE ZBuffer[];
	extern BYTE SubZBuffer[];
	extern unsigned char _2xSaI_Buffer[];
	extern unsigned char _2xSaI_TripleBuffer[];
	extern BYTE DepthConvertBuf[];

	FillMemory ((PVOID)ScreenBuffer, SCREEN_BUFFER, 0);
	FillMemory ((PVOID)SubScreenBuffer, SUB_SCREEN_BUFFER, 0);
	FillMemory ((PVOID)ZBuffer, Z_BUFFER, 0);
	FillMemory ((PVOID)SubZBuffer, SUB_Z_BUFFER, 0);

	ZeroMemory( _2xSaI_Buffer, 512*478*2);
	ZeroMemory( _2xSaI_TripleBuffer, 512*478*2);
	ZeroMemory(DepthConvertBuf, 512*478*2);
	DirectX_ClearOffscreenSurface();

	//2xSaIATV[ĥ߂̃obt@NA΍
	ResetRenderMethod();
}

void CurFullscreenDisplayModeIndexChange()
{
	CurFullscreenDisplayModeIndex = FullscreenDisplayModeIndexDouble16;
	GUI.FullScreen_X = DisplayMode[CurFullscreenDisplayModeIndex].Width;
	GUI.FullScreen_Y = DisplayMode[CurFullscreenDisplayModeIndex].Height;
}

char ROMFileName[_MAX_PATH] = {0};
static char FileTitle[_MAX_PATH] = {0};
char InitialROMFileDirectory[_MAX_PATH] = {0};
char RecentROMFileName[_MAX_PATH * 11] = {0};

unsigned char S9xwSwitchScreenMode(unsigned char Windowed)
{
	S9xwPauseLock = TRUE;
CurFullscreenDisplayModeIndexChange();
	if(!Windowed && DirectX.Windowed)
		SetWindowText(GUI.hWnd, WindowTitleText);
	if(!Windowed && GetMenu( GUI.hWnd) != NULL) {
		SetMenu( GUI.hWnd, NULL);
		GUI.AppMenuConnect = FALSE;
	}
	else if(Windowed && GetMenu( GUI.hWnd) == NULL) {
		SetMenu( GUI.hWnd, GUI.hMenu);
		GUI.AppMenuConnect = TRUE;
	}
	S9xGraphicsDeinit();

	if(!DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, Windowed, GUI.DoubleBuffered) && !Windowed) {
		DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, TRUE, GUI.DoubleBuffered);
		GUI.ScreenDepth = (DWORD)DirectX.Depth;
		GUI.FullScreen = !DirectX.Windowed;
		S9xSetWindowPos();
		SetWindowText(GUI.hWnd, WindowTitleText);
		MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
		S9xwPauseLock = FALSE;
		return FALSE;
	}
	GUI.ScreenDepth = (DWORD)DirectX.Depth;

	S9xSetWinPixelFormat ();

	//؂芷s̃G[
	if(!S9xGraphicsInit())
	{
		S9xGraphicsDeinit();
		DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, TRUE, GUI.DoubleBuffered);
		GUI.ScreenDepth = (DWORD)DirectX.Depth;
		GUI.FullScreen = !DirectX.Windowed;
		S9xSetWindowPos();
		SetWindowText(GUI.hWnd, WindowTitleText);
		MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
		S9xwPauseLock = FALSE;
		return FALSE;
	}

	S9xInitUpdate ();

	if(!GUI.StopEmulation) {
		for (int c = 0; c < 256; c++)
		{
			IPPU.ScreenColors [c] = c;
		}
		S9xFixColourBrightness ();
		IPPU.ColorsChanged = TRUE;
		IPPU.RenderThisFrame = TRUE;
//		IPPU.RenderThisFrame = FALSE;
	}

	GUI.FullScreen = !DirectX.Windowed;

	//2xSaI[hXN[obt@NA΍
	ResetRenderMethod();

	if(DirectX.Windowed) {
		S9xSetInfoString ("");
		S9xSetWindowPos();
		SetWindowText(GUI.hWnd, WindowTitleText);
	}
	S9xwPauseLock = FALSE;
	//Erase mouse cursor.
	if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation)
		S9xMessage2 ("EraseMouseCursor", 1000);
	return TRUE;
}

bool8 SetupSound( long rate, bool8 sixteen_bit, bool8 stereo);
#include "../snes9x/ppu.h"
#include "../snes9x/snapshot.h"

void SwitchToGDI()
{
	IPPU.ColorsChanged = true;
	if( DirectX.lpDDSPrimary != NULL)
	{
		DirectX.lpDD -> FlipToGDISurface();
		DirectX.lpDDSPrimary -> SetPalette( NULL);
	}
	else
	{
		DirectX.lpDD -> FlipToGDISurface();
		DirectX.lpDDSPrimary2 -> SetPalette( NULL);
	}
}

void UpdateBackBuffer()
{
	if(DirectX.Windowed) {
		DirectX_ClearOffscreenSurface();
		ScreenRedraw(GUI.hWnd);
		return;
	}
	SwitchToGDI();
	DirectX_ClearPrimarySurface();
	DirectX_ClearBackbufferSurface();
}

//XN[bZ[W
static char S9xInfoString[256] = {0};
static char OnScreenMessage[256] = {0};
static char ExitMenuMessage[256] = {0};
static char MouseEraseMessage[256] = {0};
static DWORD OnScreenMessageTimeOut = 0;
static DWORD ExitMenuTimeOut = 0;
static DWORD MouseEraseTimeOut = 0;
static bool OnScreenMessageTimerActiveFlag = FALSE;
static bool8 MinimizedFlag = 0;
static bool ncbuttondown_flag = 0;
static bool WindowActiveFlag = 0;
static bool SizingFlag = 0;
void S9xwPauseEmulation(bool pause);
void S9xwCDDAPauseEmulation(bool pause);

void S9xMessage2 (const char *str, int TimeOut)
{
	//ExitMenuMessageZbg
	if(!lstrcmp(str, "S9xwExitMenu")) {
		lstrcpy(ExitMenuMessage, str);
		ExitMenuTimeOut = timeGetTime() + TimeOut;
	}
	//MouseEraseMessageZbg
	else if(!lstrcmp(str, "EraseMouseCursor")) {
		lstrcpy(MouseEraseMessage, str);
		MouseEraseTimeOut = timeGetTime() + TimeOut;
	}
	//OnScreenMessageZbg
	else {
		lstrcpy(OnScreenMessage, str);
		OnScreenMessageTimeOut = timeGetTime() + TimeOut;
		if(DirectX.Windowed)
		{
			SetWindowText(GUI.hWnd, OnScreenMessage);
		}
	}
	//^C}[Zbg
	if(!OnScreenMessageTimerActiveFlag) {
		SetTimer(GUI.hWnd, 101, 100, NULL);
		OnScreenMessageTimerActiveFlag = TRUE;
	}
}

void OnScreenMessageUpdate()
{
	//ExitMenuMessage
	if(!lstrcmp(ExitMenuMessage, "S9xwExitMenu") && timeGetTime() > ExitMenuTimeOut) {
		if((!MinimizedFlag) && !GUI.FullScreen && DirectX.Windowed && !GUI.PauseEmulation && WindowActiveFlag && !SizingFlag && !ncbuttondown_flag)
			S9xwPauseEmulation(FALSE);
		ExitMenuMessage[0] = 0;
		ExitMenuTimeOut = 0;
	}
	//MouseEraseMessage
	if(!lstrcmp(MouseEraseMessage, "EraseMouseCursor") && timeGetTime() > MouseEraseTimeOut) {
		if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation)
			SetCursor(NULL);
		MouseEraseMessage[0] = 0;
		MouseEraseTimeOut = 0;
	}
	//OnScreenMessage
	if(OnScreenMessage[0] && timeGetTime() > OnScreenMessageTimeOut) {
		if(DirectX.Windowed)
		{
			SetWindowText(GUI.hWnd, WindowTitleText);
		}
		OnScreenMessage[0] = 0;
		OnScreenMessageTimeOut = 0;
	}
	if(!ExitMenuMessage[0] && !MouseEraseMessage[0] && !OnScreenMessage[0] && OnScreenMessageTimerActiveFlag) {
		KillTimer(GUI.hWnd, 101);
		OnScreenMessageTimerActiveFlag = FALSE;
	}
}

void S9xwKillMessageTimer()
{
	if(OnScreenMessageTimerActiveFlag) {
		KillTimer(GUI.hWnd, 101);
		OnScreenMessageTimerActiveFlag = FALSE;
	}
	if(DirectX.Windowed)
	{
		SetWindowText(GUI.hWnd, WindowTitleText);
	}
	ExitMenuMessage[0] = MouseEraseMessage[0] = OnScreenMessage[0] = 0;
	ExitMenuTimeOut = MouseEraseTimeOut = OnScreenMessageTimeOut = 0;
}

void S9xwSetClipper(bool clip)
{
	if((!GUI.FullScreen && GUI.Stretch) || (GUI.FullScreen && GUI.FullScreen_Stretch)) {
		GetClientRect(GUI.hWnd, &rc);
		DirectX_SetClipper(clip, rc.right - rc.left, rc.bottom - rc.top);
		ResetRenderMethod();
		if(Draw1FrameFlag && clip)
			Draw1frame();
	}
	else {
		long dWidth, dHeight;
		dHeight = 239;
		dWidth = 256;
		if(GUI.Scale > 0)
			dHeight <<= 1;
		if(GUI.Scale > 0)
			dWidth <<= 1;
		DirectX_SetClipper(clip, dWidth, dHeight);
		ResetRenderMethod();
		if(Draw1FrameFlag && clip)
			Draw1frame();
	}
	ResetRenderMethod();
}

void S9xwInactivateDraw()
{
	if(!WindowActiveFlag && (!GUI.FullScreen && DirectX.Windowed) && !GUI.PauseEmulation && !GUI.StopEmulation)
	{
		ScreenRedraw(GUI.hWnd);
	
		if((!GUI.FullScreen && GUI.Stretch) || (GUI.FullScreen && GUI.FullScreen_Stretch))
		{
			GetClientRect(GUI.hWnd, &rc);
			DirectX_SetClipper(TRUE, rc.right - rc.left, rc.bottom - rc.top);
		}
		else {
			long dWidth, dHeight;
			dHeight = 239;
			dWidth = 256;
			if(GUI.Scale > 0)
				dHeight <<= 1;
		if(GUI.Scale > 0)
				dWidth <<= 1;
			DirectX_SetClipper(TRUE, dWidth, dHeight);
		}
	}
}

void S9xwCDDAPauseEmulation(bool pause)
{

	if(Xppcdda.Enable && Xppcdda.Max_Soundlink_cd_track && Xppcdda.Soundlink_cd_track && Xppcdda.Cdda_Pause && !pause) cdda_replay();
	if(Xppcdda.Enable && Xppcdda.Max_Soundlink_cd_track && Xppcdda.Soundlink_cd_track && !Xppcdda.Cdda_Pause && pause) cdda_pause();

}

void S9xwPauseEmulation(bool pause)
{

	if(pause)
		S9xwKillMessageTimer();
	if((GUI.FullScreen && DirectX.Windowed) || GUI.PauseEmulation || S9xwPauseLock) {
		S9xSetSoundMute (TRUE);
		return;
	}
	GUI.ForcedPauseEmulation = pause;
	S9xSetSoundMute ((bool8)pause);

	S9xwSetClipper(pause);
	if(!pause && IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation)
		S9xMessage2 ("EraseMouseCursor", 1000);

	S9xwCDDAPauseEmulation(pause);

}

bool UIEnter()
{
	S9xwPauseEmulation(TRUE);
	S9xwKillMessageTimer();
	if(GUI.FullScreen && !DirectX.Windowed) {
		S9xwPauseEmulation(TRUE);
		S9xwPauseLock = TRUE;
		if(S9xwSwitchScreenMode(TRUE)) {
			GUI.FullScreen = TRUE;
			S9xwSetClipper(TRUE);
			S9xwPauseLock = FALSE;
		}
		else
			return FALSE;
	}
	return TRUE;
}

void UIExit()
{
	if((DirectX.Windowed && !GUI.FullScreen) || (!DirectX.Windowed && GUI.FullScreen))
		S9xwPauseEmulation(FALSE);
}

void S9xwStateSave(char SaveSlotNum)
{
	if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
		return;
	char saveext [_MAX_EXT];
	char savemesj[] = "Slot #1 saved";
	char savemese[] = "Slot #1 saved";
	bool8 saveerr;

	lstrcpy(saveext, ".000");

	saveext[3] = (0x30 + SaveSlotNum - 1);
	savemesj[6] = savemese[6] = (0x30 + SaveSlotNum);
	S9xwPauseEmulation(TRUE);
	saveerr = S9xFreezeGame(S9xGetFilename(saveext));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);
	if(saveerr)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? savemesj : savemese, 2000);
	else
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
}

void S9xwStateLoad(int SaveSlotNum)
{
	if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
		return;
	char loadext [_MAX_EXT];
	char loadmesj[] = "Slot #1 loaded";
	char loadmese[] = "Slot #1 loaded";
	bool8 loaderr;

	lstrcpy(loadext, ".000");

	loadext[3] = (0x30 + SaveSlotNum - 1);
	loadmesj[6] = loadmese[6] = (0x30 + SaveSlotNum);

	S9xwPauseEmulation(TRUE);
	loaderr = S9xUnfreezeGame(S9xGetFilename(loadext));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);
	if(loaderr)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? loadmesj : loadmese, 2000);
	else
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
}

void S9xwStateSaveReplay(const char *Xpp_ext)
{
	if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
		return;
	bool8 saveerr;
	
	S9xwPauseEmulation(TRUE);
	saveerr = S9xFreezeGame(S9xGetFilename(Xpp_ext));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);

	if(saveerr && strcmp (Xpp_ext,XppMovie.movie_ext_snap[XppMovie.Replay_Slot]) == 0)
        {
                if(XppMovie.Replay_status == MOVIE_RECODE)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Start" : "Movie Rec Start", 2000);
                else
                if(XppMovie.Replay_status == MOVIE_PLAY)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Start" : "Movie Play Start", 2000);
                
        }
	else
	if(saveerr && strcmp (Xpp_ext,XppMovie.resume_ext_snap[XppMovie.Replay_Slot]) == 0)
        {
//                if(XppMovie.Replay_status == MOVIE_RECODE)
//		  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Start" : "Movie Rec Start", 2000);
//                else
//                if(XppMovie.Replay_status == MOVIE_PLAY)
//		  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Start" : "Movie Play Start", 2000);
        }
	else
        {
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);

	        XppMovie.Replay_status = MOVIE_NONE;
	        XppMovie.file_open_error = TRUE;
        }
}

void S9xwStateLoadReplay(const char *Xpp_ext)
{
	if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
		return;

	bool8 loaderr;
	
	XppMovie.file_open_error = FALSE;
	
	S9xwPauseEmulation(TRUE);
	loaderr = S9xUnfreezeGame(S9xGetFilename(Xpp_ext));
	if(GUI.PauseEmulation)
		S9xSetSoundMute (TRUE);
	else
		S9xwPauseEmulation(FALSE);
	if(loaderr && strcmp (Xpp_ext, XppMovie.movie_ext_snap[XppMovie.Replay_Slot]) == 0)
        {
                if(XppMovie.Replay_status == MOVIE_RECODE)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Start" : "Movie Rec Start", 2000);
                else
                if(XppMovie.Replay_status == MOVIE_PLAY)
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Start" : "Movie Play Start", 2000);
        }
	else
	if(loaderr && strcmp (Xpp_ext,XppMovie.resume_ext_snap[XppMovie.Replay_Slot]) == 0)
        {
//                if(XppMovie.Replay_status == MOVIE_RECODE)
//		  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Rec Start" : "Movie Rec Start", 2000);
//                else
//                if(XppMovie.Replay_status == MOVIE_PLAY)
//  		  S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Movie Play Start" : "Movie Play Start", 2000);
        }
	else
        {
		S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Error!" : "Error!", 2000);
	        XppMovie.Replay_status = MOVIE_NONE;
	        XppMovie.file_open_error = TRUE;
        }
}

//***************************************************************
//
//***************************************************************

LRESULT CALLBACK WinProc(
	HWND hWnd,
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam)
{
static bool CmdLineROMLoadFlag = 0;
static bool NeedScreenImage = 1;
static bool NeedJoystickInit = 1;
static HDROP hDrop;
//static RECT SizingClip;
static HRGN hRgn1, hRgn2, hRgn3;
static long RedrawDstW, RedrawDstH;
static uint8 ErrResult;

	switch( uMsg)
	{
	case WM_CREATE:
		//inactivate IME
		ImeEnable(hWnd, FALSE);
		InitCommonControls();
		{
			GUI.Scale = (DoubleRenderingModes16);
		}
		DragAcceptFiles(hWnd, TRUE); //hbOhbvݒ
		WindowActiveFlag = 1;
		if(!S9xExitFlag && __argc > 1) {
			//V[gt@COt@Cɕϊ
			if(GetLongFileName(__argv[1], ROMFileName, _MAX_PATH))
				CmdLineROMLoadFlag = 1;
		}
		if(S9xExitFlag) {
			MessageBox(GUI.hWnd, Languages[GUI.Language].errMemoryInit, "Snes9X - Memory Init", MB_OK | MB_ICONSTOP);
			PostMessage( hWnd, WM_CLOSE, 0, 0);
		}
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		break;

	//SNES}EXAX[p[XR[vpԎ擾
	case WM_LBUTTONDOWN:
		if((IPPU.Controller == SNES_MOUSE || IPPU.Controller == SNES_MOUSE_SWAPPED) && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation)
			SetCursor(NULL);
		else {
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) {
				S9xMessage2 ("EraseMouseCursor", 1000);
			}
		}
		GUI.MouseButtons |= 1;
		break;

	case WM_LBUTTONUP:
		GUI.MouseButtons &= 0xfffffffe;
		break;

	case WM_RBUTTONDOWN:
		if((IPPU.Controller == SNES_MOUSE || IPPU.Controller == SNES_MOUSE_SWAPPED) && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation)
			SetCursor(NULL);
		else {
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) {
				S9xMessage2 ("EraseMouseCursor", 1000);
			}
		}
		GUI.MouseButtons |= 2;
		break;

	case WM_RBUTTONUP:
		GUI.MouseButtons &= 0xfffffffd;
		break;

	case WM_MBUTTONDOWN:
		if((IPPU.Controller == SNES_MOUSE || IPPU.Controller == SNES_MOUSE_SWAPPED) && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation)
			SetCursor(NULL);
		else {
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation) {
				S9xMessage2 ("EraseMouseCursor", 1000);
			}
		}
		GUI.MouseButtons |= 4;
		break;

	case WM_MBUTTONUP:
		GUI.MouseButtons &= 0xfffffffb;
		break;

	case WM_MOUSEMOVE:
            if (!GUI.IgnoreNextMouseMove)
            {
                POINT p;
                p.x = (int16) (lParam & 0xffff);
                p.y = (int16) ((lParam >> 16) & 0xffff);
                ClientToScreen (GUI.hWnd, &p);
                if ((!Settings.ForcedPause && !Settings.StopEmulation && 
                     !Settings.Paused) &&
                    (IPPU.Controller == SNES_MOUSE ||
                     IPPU.Controller == SNES_MOUSE_SWAPPED))
                {
                    POINT middle;
                    RECT size;
                    
                    GetClientRect (GUI.hWnd, &size);
                    middle.x = (size.right - size.left) >> 1;
                    middle.y = (size.bottom - size.top) >> 1;
                    ClientToScreen (GUI.hWnd, &middle);
                    GUI.MouseX += p.x - middle.x;
                    GUI.MouseY += p.y - middle.y;
                    SetCursorPos (middle.x, middle.y);
                    GUI.IgnoreNextMouseMove = TRUE;
                }
                else
                {
                    GUI.MouseX = p.x;
                    GUI.MouseY = p.y;
                }
            }
            else
                GUI.IgnoreNextMouseMove = FALSE;
		break;

	case WM_SETCURSOR:
		break;

	case WM_NCMOUSEMOVE:
		GUI.MouseButtons = 0;
		break;

	case WM_TIMER:
		if(!DirectX.Windowed && OnScreenMessage[0]) {
			lstrcpy(S9xInfoString, OnScreenMessage);
			S9xSetInfoString (S9xInfoString);
			OnScreenMessage[0] = 0;
			OnScreenMessageTimeOut = 0;
		}
		else if(OnScreenMessage[0] || ExitMenuMessage[0] || MouseEraseMessage[0])
			OnScreenMessageUpdate();
		break;

	case WM_EXITMENULOOP:
		S9xMessage2("S9xwExitMenu", 200);
		break;

	case WM_MOVE:
		break;

	case WM_MOVING:
		break;

	case WM_ACTIVATE:
		switch(LOWORD(wParam))
		{
			case WA_ACTIVE: case WA_CLICKACTIVE:
				WindowActiveFlag = 1;
				if(!GUI.StopEmulation)
					SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
				else
					SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
				if(!GUI.FullScreen && DirectX.Windowed && !ncbuttondown_flag && !MinimizedFlag) {
					S9xwPauseEmulation(FALSE);
				}
				break;
			
			case WA_INACTIVE:
					WindowActiveFlag = 0;
				
					if(!Xppsystem.InactivateWork)
					{
					    S9xwPauseEmulation(TRUE);
					    SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
					}
				break;

			default:
				break;
		}
		break;

/*
	case WM_ACTIVATEAPP:
		if(wParam && !GUI.FullScreen && DirectX.Windowed && !ncbuttondown_flag && !MinimizedFlag) {
			WindowActiveFlag = 1;
			S9xwPauseEmulation(FALSE);
		}
		else if(!wParam) {
			WindowActiveFlag = 0;
			S9xwPauseEmulation(TRUE);
		}
		break;
*/

	case WM_DROPFILES:
		/* hbOAhhbv */
		if(GUI.PauseEmulation)
			break;
		SetForegroundWindow(hWnd);
		hDrop=(HDROP)wParam;
		DragQueryFile(hDrop, 0, ROMFileName, _MAX_PATH);
		DragFinish(hDrop);
		S9xwPauseEmulation(TRUE);
		UpdateBackBuffer();
		ROMLoadProc(ROMFileName);
		if(!GUI.StopEmulation)
			SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
		else
			SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
		S9xwPauseEmulation(FALSE);
		if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation)
			S9xMessage2 ("EraseMouseCursor", 1000);
		break;

	case WM_KEYDOWN:
		switch( wParam)
		{

#if 1 // Snes9xpp Original Start
			case 'C': // ID_OPTION_CONFIG
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {        
			S9XW_KEY_OPTION_CONFIG
        }
			break;

			case 'F': // ID_OPTION_FPS
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_FPS
        }
			break;

			case 'H': // ID_OPTION_CHEATCODE ID_OPTION_SETTINGS_KEY_APPLYCHEATS
		if (GetKeyState (VK_SHIFT) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_SETTINGS_KEY_APPLYCHEATS
        }
        else
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {        
        }
			break;

			case 'I': // ID_OPTION_STRETCH 
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        { 
			S9XW_KEY_OPTION_STRETCH
        }
			break;

			case 'M': // ID_OPTION_MUTE
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_MUTE
        }
			break;

			case 'O': // ID_FILE_OPEN
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			/*S9XW_KEY_FILE_OPEN*/
			S9XW_KEY_FILE_OPEN_XPP_KEY
        }
			break;

			case 'R': // ID_FILE_RESET ID_FILE_SOFTRESET
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
        #ifdef SNES9XPP_FULL
			S9XW_KEY_FILE_RESET_FULL
		#else
			S9XW_KEY_FILE_RESET
		#endif
        }
        else
		if (GetKeyState (VK_SHIFT) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
        #ifdef SNES9XPP_FULL
			S9XW_KEY_FILE_SOFTRESET_FULL
		#else
			S9XW_KEY_FILE_SOFTRESET
		#endif
        }
			break;

			case 'U': // ID_OPTION_JP
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_JP
        }
			break;

			case VK_DOWN: // ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC ID_OPTION_VLDOWN
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC
        }
        else
		if (GetKeyState (VK_SHIFT) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_VLDOWN
        }
			break;

			case VK_UP: // ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC ID_OPTION_VLUP
		if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC
        }
        else
		if (GetKeyState (VK_SHIFT) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_OPTION_VLUP
        }
			break;

			case 'Z': // ID_FILE_ZSTSAVE
		if (GetKeyState (VK_SHIFT) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
#if 0        
			S9XW_KEY_FILE_ZSTSAVE
#endif
        }
        else
        if (GetKeyState (VK_CONTROL) & 0x8000 && XppMovie.Replay_status == MOVIE_NONE)
        {
			S9XW_KEY_FILE_ZSTLOAD
        }
			break;

#endif // Snes9xpp Original End
		
		case VK_ESCAPE:
			S9XW_ESC_KEY
			break;

		//State save load
		case VK_F1:
		case VK_F2:
		case VK_F3:
		case VK_F4:
		case VK_F5:
		case VK_F6:
		case VK_F7:
		case VK_F8:
		case VK_F9:
		 if(XppMovie.Replay_status == MOVIE_NONE)
		 {
			if(GUI.StopEmulation)
				break;
			//load
			if((GetKeyState(VK_SHIFT) & 0x8000) == 0) {
				wsprintf(tmpcharbuf, ".%03d", wParam - VK_F1);
				if(GetFileAttributes(S9xGetFilename(tmpcharbuf)) == 0xffffffff)
					break;
				S9xwStateLoad(wParam - VK_F1 + 1);
			}
			//save
			else {
				S9xwStateSave(wParam - VK_F1 + 1);
			}
		 }
			break;

		default:
			break;
		}
		break;

	case WM_SYSKEYUP:
		switch(wParam)
		{
			case VK_RETURN:
			if (XppMovie.Replay_status == MOVIE_NONE)
            {
				S9XW_KEY_OPTION_FULLSCREEN
			}
				break;

			default:
				break;
		}
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam))
		{
		case ID_FILE_OPEN:
			S9XW_KEY_FILE_OPEN
			break;

		case ID_FILE_RECENT1:
		case ID_FILE_RECENT2:
		case ID_FILE_RECENT3:
		case ID_FILE_RECENT4:
		case ID_FILE_RECENT5:
		case ID_FILE_RECENT6:
		case ID_FILE_RECENT7:
		case ID_FILE_RECENT8:
		case ID_FILE_RECENT9:
		case ID_FILE_RECENTA:
			if(GUI.PauseEmulation)
				break;
			UpdateBackBuffer();
			S9xwPauseEmulation(TRUE);
			ROMLoadProc(&RecentROMFileName[_MAX_PATH * (LOWORD(wParam) - ID_FILE_RECENT1)]);
			if(!GUI.StopEmulation)
				SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
			else
				SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
			S9xwPauseEmulation(FALSE);
			break;

		case ID_FILE_RESET:
        #ifdef SNES9XPP_FULL
			S9XW_KEY_FILE_RESET_FULL
		#else
			S9XW_KEY_FILE_RESET
		#endif
			break;

		case ID_FILE_SOFTRESET:
        #ifdef SNES9XPP_FULL
			S9XW_KEY_FILE_SOFTRESET_FULL
		#else
			S9XW_KEY_FILE_SOFTRESET
		#endif
			break;

// Snes9xpp Original start
		case ID_FILE_DISABLEOUTPUTSRAM:
			if(Xppsystem.DisableOutputSram)
				Xppsystem.DisableOutputSram = 0;
			else
				Xppsystem.DisableOutputSram = 1;
			break;
// Snes9xpp Original end

		case ID_FILE_SPCDUMP:
			if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
				break;
			S9XW_KEY_FILE_SPCDUMP
			break;

		case ID_FILE_ZSTSAVE:
#if 0        
			S9XW_KEY_FILE_ZSTSAVE
#endif
			break;

		case ID_FILE_SCREENSHOT:
			if(GUI.StopEmulation || (GUI.PauseEmulation && GUI.FullScreen))
				break;
			S9XW_KEY_FILE_SCREENSHOT
			break;

		case ID_FILE_EXIT:
			PostMessage( hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_OPTION_ADJUSTWINDOW_0:
		case ID_OPTION_ADJUSTWINDOW_1:
		case ID_OPTION_ADJUSTWINDOW_2:
		case ID_OPTION_ADJUSTWINDOW_3:
		case ID_OPTION_ADJUSTWINDOW_4:
		case ID_OPTION_ADJUSTWINDOW_5:
		case ID_OPTION_ADJUSTWINDOW_6:
		case ID_OPTION_ADJUSTWINDOW_7:
		case ID_OPTION_ADJUSTWINDOW_8:
		case ID_OPTION_ADJUSTWINDOW_9:
		case ID_OPTION_ADJUSTWINDOW_10:
		case ID_OPTION_ADJUSTWINDOW_11:
		case ID_OPTION_ADJUSTWINDOW_12:
		case ID_OPTION_ADJUSTWINDOW_13:
		case ID_OPTION_ADJUSTWINDOW_14:
		case ID_OPTION_ADJUSTWINDOW_15:
		case ID_OPTION_ADJUSTWINDOW_16:
		case ID_OPTION_ADJUSTWINDOW_17:
		case ID_OPTION_ADJUSTWINDOW_18:
		case ID_OPTION_ADJUSTWINDOW_19:
		case ID_OPTION_ADJUSTWINDOW_20:
		case ID_OPTION_ADJUSTWINDOW_21:
		case ID_OPTION_ADJUSTWINDOW_22:
		case ID_OPTION_ADJUSTWINDOW_23:
			{
				if(!DirectX.Windowed || GUI.PauseEmulation)
					break;
				RECT rcWindow;

					switch(LOWORD(wParam))
					{
						case ID_OPTION_ADJUSTWINDOW_0:
						{
							{
								DoubleRenderingModes16 = GUI.Scale;
								GUI.Scale = 0;
								
								if(GUI.FullScreen)
								Hires_Normal = false;
							}
							GUI.Stretch = FALSE;
							
						}
						break;

						case ID_OPTION_ADJUSTWINDOW_1:
							GUI.Stretch = FALSE;
							Hires_Normal = true;
						break;

						case ID_OPTION_ADJUSTWINDOW_2:
						case ID_OPTION_ADJUSTWINDOW_3:
						case ID_OPTION_ADJUSTWINDOW_4:
						case ID_OPTION_ADJUSTWINDOW_5:
						case ID_OPTION_ADJUSTWINDOW_6:
						case ID_OPTION_ADJUSTWINDOW_7:
						case ID_OPTION_ADJUSTWINDOW_8:
						case ID_OPTION_ADJUSTWINDOW_9:
						case ID_OPTION_ADJUSTWINDOW_10:
						case ID_OPTION_ADJUSTWINDOW_11:
						case ID_OPTION_ADJUSTWINDOW_12:
						case ID_OPTION_ADJUSTWINDOW_13:
						case ID_OPTION_ADJUSTWINDOW_14:
						case ID_OPTION_ADJUSTWINDOW_15:
						case ID_OPTION_ADJUSTWINDOW_16:
						case ID_OPTION_ADJUSTWINDOW_17:
						case ID_OPTION_ADJUSTWINDOW_18:
						case ID_OPTION_ADJUSTWINDOW_19:
						case ID_OPTION_ADJUSTWINDOW_20:
						case ID_OPTION_ADJUSTWINDOW_21:
						case ID_OPTION_ADJUSTWINDOW_22:
							GUI.Stretch = 2;
							Hires_Normal = true;
						break;

						case ID_OPTION_ADJUSTWINDOW_23:
							GUI.Stretch = 1;
							Hires_Normal = true;
						break;

						default:
						break;
					}

				{
					//2xSaI[hւ̐؂芷̏ꍇ̃XN[obt@NA΍
					ResetRenderMethod();
					GUI.Scale = (DoubleRenderingModes16);
				}
				CurFullscreenDisplayModeIndexChange();
				S9xwPauseEmulation(TRUE);
				S9xwPauseLock = TRUE;

				GetWindowRect(hWnd, &rcWindow);

					switch(LOWORD(wParam))
					{
						case ID_OPTION_ADJUSTWINDOW_0:
							Options.Adjustwindow = 0;
							rcWindow.right = DefaultWindowSizeW;
							rcWindow.bottom = DefaultWindowSizeH;
						break;

						case ID_OPTION_ADJUSTWINDOW_1:
						case ID_OPTION_ADJUSTWINDOW_2:
						case ID_OPTION_ADJUSTWINDOW_3:
						case ID_OPTION_ADJUSTWINDOW_4:
						case ID_OPTION_ADJUSTWINDOW_5:
						case ID_OPTION_ADJUSTWINDOW_6:
						case ID_OPTION_ADJUSTWINDOW_7:
						case ID_OPTION_ADJUSTWINDOW_8:
						case ID_OPTION_ADJUSTWINDOW_9:
						case ID_OPTION_ADJUSTWINDOW_10:
						case ID_OPTION_ADJUSTWINDOW_11:
						case ID_OPTION_ADJUSTWINDOW_12:
						case ID_OPTION_ADJUSTWINDOW_13:
						case ID_OPTION_ADJUSTWINDOW_14:
						case ID_OPTION_ADJUSTWINDOW_15:
						case ID_OPTION_ADJUSTWINDOW_16:
						case ID_OPTION_ADJUSTWINDOW_17:
						case ID_OPTION_ADJUSTWINDOW_18:
						case ID_OPTION_ADJUSTWINDOW_19:
						case ID_OPTION_ADJUSTWINDOW_20:
						case ID_OPTION_ADJUSTWINDOW_21:
						case ID_OPTION_ADJUSTWINDOW_22:
							Options.Adjustwindow = LOWORD(wParam) - ID_OPTION_ADJUSTWINDOW_0;
							rcWindow.right = DefaultWindowSizeWW[LOWORD(wParam) - ID_OPTION_ADJUSTWINDOW_0];
							rcWindow.bottom = DefaultWindowSizeHH[LOWORD(wParam) - ID_OPTION_ADJUSTWINDOW_0];
						break;

						case ID_OPTION_ADJUSTWINDOW_23:
							Options.Adjustwindow = STRETCH_ADJUSTWINDOW;
						break;

						default:
						break;
					}

				if(Options.Adjustwindow != STRETCH_ADJUSTWINDOW) {
				MoveWindow(hWnd, rcWindow.left, rcWindow.top, rcWindow.right, rcWindow.bottom, TRUE);
				GetClientRect(GUI.hWnd, &rc);
				hdc = GetDC(GUI.hWnd);
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				ReleaseDC(GUI.hWnd, hdc);
				//݂̃EChETCYۑ
				GetWindowRect(hWnd, &WindowRectSetting);

				S9xGraphicsDeinit();
				//؂芷s̃G[
				if(!S9xGraphicsInit())
				{
					S9xGraphicsDeinit();
					SetWindowText(GUI.hWnd, WindowTitleText);
					MessageBox(GUI.hWnd, Languages[GUI.Language].errSwitchGFX, "Snes9X - Switch GFX mode", MB_OK | MB_ICONSTOP);
					S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
					PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
					break;
				}
				S9xInitUpdate (); }

				if(DirectX.Windowed) {
					GetClientRect(GUI.hWnd, &rc);
					hdc = GetDC(GUI.hWnd);
					FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
					ReleaseDC(GUI.hWnd, hdc);
				}
				else
				UpdateBackBuffer();
				S9xwPauseLock = FALSE;
				S9xwPauseEmulation(FALSE);
			}
			break;

		case ID_OPTION_FULL_ADJUSTWINDOW_0:
		case ID_OPTION_FULL_ADJUSTWINDOW_1:
		case ID_OPTION_FULL_ADJUSTWINDOW_2:
		case ID_OPTION_FULL_ADJUSTWINDOW_3:
		case ID_OPTION_FULL_ADJUSTWINDOW_4:
		case ID_OPTION_FULL_ADJUSTWINDOW_5:
		case ID_OPTION_FULL_ADJUSTWINDOW_6:
		case ID_OPTION_FULL_ADJUSTWINDOW_7:
		case ID_OPTION_FULL_ADJUSTWINDOW_8:
		case ID_OPTION_FULL_ADJUSTWINDOW_9:
		case ID_OPTION_FULL_ADJUSTWINDOW_10:
		case ID_OPTION_FULL_ADJUSTWINDOW_11:
		case ID_OPTION_FULL_ADJUSTWINDOW_12:
		case ID_OPTION_FULL_ADJUSTWINDOW_13:
		case ID_OPTION_FULL_ADJUSTWINDOW_14:
		case ID_OPTION_FULL_ADJUSTWINDOW_15:
		case ID_OPTION_FULL_ADJUSTWINDOW_16:
		case ID_OPTION_FULL_ADJUSTWINDOW_17:
		case ID_OPTION_FULL_ADJUSTWINDOW_18:
		case ID_OPTION_FULL_ADJUSTWINDOW_19:
		case ID_OPTION_FULL_ADJUSTWINDOW_20:
		case ID_OPTION_FULL_ADJUSTWINDOW_21:
		case ID_OPTION_FULL_ADJUSTWINDOW_22:
		case ID_OPTION_FULL_ADJUSTWINDOW_23:
			{
				if(!DirectX.Windowed || GUI.PauseEmulation)
					break;
					switch(LOWORD(wParam))
					{
						case ID_OPTION_FULL_ADJUSTWINDOW_0:
						{
							{
								DoubleRenderingModes16 = GUI.Scale;
								GUI.Scale = 0;
								if(!GUI.FullScreen)
								Hires_Full = false;
							}
							GUI.FullScreen_Stretch = FALSE;
						}
						break;

						case ID_OPTION_FULL_ADJUSTWINDOW_1:
							GUI.FullScreen_Stretch = FALSE;
							Hires_Full = true;
						break;

						case ID_OPTION_FULL_ADJUSTWINDOW_2:
						case ID_OPTION_FULL_ADJUSTWINDOW_3:
						case ID_OPTION_FULL_ADJUSTWINDOW_4:
						case ID_OPTION_FULL_ADJUSTWINDOW_5:
						case ID_OPTION_FULL_ADJUSTWINDOW_6:
						case ID_OPTION_FULL_ADJUSTWINDOW_7:
						case ID_OPTION_FULL_ADJUSTWINDOW_8:
						case ID_OPTION_FULL_ADJUSTWINDOW_9:
						case ID_OPTION_FULL_ADJUSTWINDOW_10:
						case ID_OPTION_FULL_ADJUSTWINDOW_11:
						case ID_OPTION_FULL_ADJUSTWINDOW_12:
						case ID_OPTION_FULL_ADJUSTWINDOW_13:
						case ID_OPTION_FULL_ADJUSTWINDOW_14:
						case ID_OPTION_FULL_ADJUSTWINDOW_15:
						case ID_OPTION_FULL_ADJUSTWINDOW_16:
						case ID_OPTION_FULL_ADJUSTWINDOW_17:
						case ID_OPTION_FULL_ADJUSTWINDOW_18:
						case ID_OPTION_FULL_ADJUSTWINDOW_19:
						case ID_OPTION_FULL_ADJUSTWINDOW_20:
						case ID_OPTION_FULL_ADJUSTWINDOW_21:
						case ID_OPTION_FULL_ADJUSTWINDOW_22:
							GUI.FullScreen_Stretch = 2;
							Hires_Full = true;
						break;
						case ID_OPTION_FULL_ADJUSTWINDOW_23:
							GUI.FullScreen_Stretch = 1;
							Hires_Full = true;
						break;

						default:
						break;
					}

				{
					//2xSaI[hւ̐؂芷̏ꍇ̃XN[obt@NA΍
					ResetRenderMethod();
					GUI.Scale = (DoubleRenderingModes16);
				}
				CurFullscreenDisplayModeIndexChange();
				S9xwPauseEmulation(TRUE);
				S9xwPauseLock = TRUE;
//				GetWindowRect(hWnd, &rcWindow);
				Options.Full_Adjustwindow = LOWORD(wParam) - ID_OPTION_FULL_ADJUSTWINDOW_0;
//				UpdateBackBuffer();
				S9xwPauseLock = FALSE;
				S9xwPauseEmulation(FALSE);
			}
			break;

		case ID_OPTION_FULL_SCREEN_SIZE_0:
		case ID_OPTION_FULL_SCREEN_SIZE_1:
		case ID_OPTION_FULL_SCREEN_SIZE_2:
		case ID_OPTION_FULL_SCREEN_SIZE_3:
		case ID_OPTION_FULL_SCREEN_SIZE_4:
		case ID_OPTION_FULL_SCREEN_SIZE_5:
		case ID_OPTION_FULL_SCREEN_SIZE_6:
		case ID_OPTION_FULL_SCREEN_SIZE_7:
		case ID_OPTION_FULL_SCREEN_SIZE_8:
		case ID_OPTION_FULL_SCREEN_SIZE_9:
		case ID_OPTION_FULL_SCREEN_SIZE_10:
		case ID_OPTION_FULL_SCREEN_SIZE_11:
		case ID_OPTION_FULL_SCREEN_SIZE_12:
		case ID_OPTION_FULL_SCREEN_SIZE_13:
		case ID_OPTION_FULL_SCREEN_SIZE_14:
			FullscreenDisplayModeIndexDouble16 = LOWORD(wParam) - ID_OPTION_FULL_SCREEN_SIZE_0;
			CurFullscreenDisplayModeIndexChange();
			break;

		case ID_OPTION_2X_HARDWARE:
		case ID_OPTION_2X_SOFTWARE:
		case ID_OPTION_2X_SCANLINES:
		case ID_OPTION_2X_EAGLE:
		case ID_OPTION_2X_SAI:
		case ID_OPTION_SUPER_2X_SAI:
		case ID_OPTION_SCALE_2X_SAI:
		case ID_OPTION_2X_TVMODE:
		case ID_OPTION_2X_HQ2X:
		case ID_OPTION_2X_LQ2X:
		case ID_OPTION_2X_INTERLACE_SCANLINES:
		case ID_OPTION_2X_INTERLACE:
			DoubleRenderingModes16 = LOWORD(wParam) - ID_OPTION_2X_HARDWARE + 1;
			GUI.Scale = (DoubleRenderingModes16);
			S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_2X_ALT_SCREEN_EFFECT:
			if(Options.AltScreenEffect)
				Options.AltScreenEffect = false;
			else
				Options.AltScreenEffect = true;
			break;

		case ID_OPTION_MODE7INTERPOLATE:
			if(Settings.Mode7Interpolate)
				Settings.Mode7Interpolate = false;
			else
				Settings.Mode7Interpolate = true;
			break;

		case ID_OPTION_SCANLINES_SET_100:
		case ID_OPTION_SCANLINES_SET_075:
		case ID_OPTION_SCANLINES_SET_050:
		case ID_OPTION_SCANLINES_SET_025:
		case ID_OPTION_SCANLINES_SET_000:
			Options.ScanLinesEffect = LOWORD(wParam) - ID_OPTION_SCANLINES_SET_100 + 1;
			break;

		case ID_OPTION_DIRECTSCREENRENDERING:
			if(dRendering)
				dRendering = false;
			else
				dRendering = true;
				
				S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_DISABLEHARDWARESCALE:
			if(DirectX.DisableHardwareScale)
				DirectX.DisableHardwareScale = false;
			else
				DirectX.DisableHardwareScale = true;
				
				S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_FORCEWINDOWEDDIRECTDRAWCLIPPER:
			if(ForceWindowedDirectDrawClipper)
				ForceWindowedDirectDrawClipper = false;
			else
				ForceWindowedDirectDrawClipper = true;
				
				S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_DOUBLEBUFFERING:
			if(GUI.DoubleBuffered)
				GUI.DoubleBuffered = false;
			else
				GUI.DoubleBuffered = true;
				
				S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_OFFSCREENVRAM:
			if(DirectX.OffScreenVRAM)
				DirectX.OffScreenVRAM = false;
			else
				DirectX.OffScreenVRAM = true;
				
				S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_BACKBUFFERVRAM:
			if(DirectX.BackBufferVRAM)
				DirectX.BackBufferVRAM = false;
			else
				DirectX.BackBufferVRAM = true;
				
				S9XW_DISPLAY_SETTING_CHANGE_PROCESSING
			break;

		case ID_OPTION_STRETCH:
			S9XW_KEY_OPTION_STRETCH
			break;

		case ID_OPTION_CONFIG:
			S9XW_KEY_OPTION_CONFIG
			break;

		case ID_OPTION_CHEATCODE:
			break;

		case ID_OPTION_FULLSCREEN:
			S9XW_KEY_OPTION_FULLSCREEN
			break;

		case ID_OPTION_FPS:
			S9XW_KEY_OPTION_FPS
			break;

		//{[ύX
		case ID_OPTION_VLUP:
			S9XW_KEY_OPTION_VLUP
			break;

		case ID_OPTION_VLDOWN:
			S9XW_KEY_OPTION_VLDOWN
			break;

		case ID_OPTION_VL1:
		case ID_OPTION_VL2:
		case ID_OPTION_VL3:
		case ID_OPTION_VL4:
		case ID_OPTION_VL5:
			Options.VolumeLevel = LOWORD(wParam) - ID_OPTION_VL1 + 1;
			break;

		case ID_OPTION_JP:
			S9XW_KEY_OPTION_JP
			break;

		case ID_OPTION_MUTE:
			S9XW_KEY_OPTION_MUTE
			break;
		//
		//Snes9x ݒύXL[
		//
		case ID_OPTION_SETTINGS_KEY_0:
			Settings.DisableHDMA = !Settings.DisableHDMA;
			if(Settings.DisableHDMA)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "HDMA G~[V It" : "HDMA emulation off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "HDMA G~[V I" : "HDMA emulation on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_1:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 1;
			if(PPU.BG_Forced & 1)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#0 It" : "BG#0 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#0 I" : "BG#0 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_2:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 2;
			if(PPU.BG_Forced & 2)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#1 It" : "BG#1 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#1 I" : "BG#1 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_3:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 4;
			if(PPU.BG_Forced & 4)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#2 It" : "BG#2 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#2 I" : "BG#2 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_4:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 8;
			if(PPU.BG_Forced & 8)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#3 It" : "BG#3 off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "BG#3 I" : "BG#3 on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_5:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			PPU.BG_Forced ^= 16;
			if(PPU.BG_Forced & 16)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XvCg It" : "Sprites off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "XvCg I" : "Sprites on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_6:
			Settings.SwapJoypads = !Settings.SwapJoypads;
			if(Settings.SwapJoypads)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad swapping I" : "Joypad swapping on", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad swapping It" : "Joypad swapping off", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_7:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			S9xNextController ();
			if(IPPU.Controller == SNES_MULTIPLAYER5) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Multiplayer 5 I #0" : "Multiplayer 5 on #0", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_JOYPAD) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad I #0" : "Joypad on #0", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_MOUSE_SWAPPED) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #1" : "Mouse on #1", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_MOUSE) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #0" : "Mouse on #0", 2000);
				if(!GUI.ForcedPauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			else if(IPPU.Controller == SNES_SUPERSCOPE) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Superscope I #1" : "Superscope on #1", 2000);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
			}
			else if(IPPU.Controller == SNES_JUSTIFIER) {
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Justifier I #0" : "Justifier on #0", 2000);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
			}
			break;

		case ID_OPTION_SETTINGS_KEY_8:
			Settings.BGLayering = !Settings.BGLayering;
			if(Settings.BGLayering)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Backgroung layering hack I" : "Backgroung layering hack on", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Backgroung layering hack It" : "Backgroung layering hack off", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_9:
			{
				Settings.Transparency = !Settings.Transparency;
				TransparencyFlag = Settings.Transparency;
				if(Settings.Transparency)
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? " I" : "Transparency effects on", 2000);
				else
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? " It" : "Transparency effects off", 2000);
			}
			break;

		case ID_OPTION_SETTINGS_KEY_BACK:
			Settings.DisableGraphicWindows = !Settings.DisableGraphicWindows;
			if(Settings.DisableGraphicWindows)
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Graphic clip windows It" : "Graphic clip windows off", 2000);
			else
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Graphic clip windows I" : "Graphic clip windows on", 2000);
			break;

		case ID_OPTION_SETTINGS_KEY_TURBO:
			S9XW_TURBO_MODE_KEY
			break;

		case ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC:
			S9XW_KEY_OPTION_SETTINGS_KEY_TURBOFRAMESKIPINC
			break;

		case ID_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC:
			S9XW_KEY_OPTION_SETTINGS_KEY_TURBOFRAMESKIPDEC
			break;

		case ID_OPTION_SETTINGS_KEY_PAUSE:
			if(!GUI.PauseEmulation) {
				S9xwPauseEmulation(TRUE);
				GUI.PauseEmulation = GUI.PauseEmulation ^ true;
				lstrcpy(WindowTitleText, WindowTitleTextPaused);
				S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
				hMenu = GetMenu(hWnd);
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Pause I" : "Pause on", 2000);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
			}
			else {
				GUI.PauseEmulation = GUI.PauseEmulation ^ true;
				S9xwPauseEmulation(FALSE);
				lstrcpy(WindowTitleText, WindowTitleTextNormal);
				S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
				S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Pause It" : "Pause off", 2000);
				if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !GUI.PauseEmulation)
					S9xMessage2 ("EraseMouseCursor", 1000);
			}
			break;

		case ID_OPTION_SETTINGS_KEY_APPLYCHEATS:
			S9XW_KEY_OPTION_SETTINGS_KEY_APPLYCHEATS
			break;

		case ID_OPTION_SNESJOYPAD:
			if(GUI.StopEmulation || GUI.PauseEmulation)
				break;
			IPPU.Controller = SNES_JOYPAD;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Joypad I #0" : "Joypad on #0", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESMULTIPLAYER5:
			if(GUI.StopEmulation || GUI.PauseEmulation || !Settings.MultiPlayer5)
				break;
			IPPU.Controller = SNES_MULTIPLAYER5;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Multiplayer 5 I #0" : "Multiplayer 5 on #0", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESMOUSE1:
			if(GUI.StopEmulation || GUI.PauseEmulation || !Settings.Mouse)
				break;
			IPPU.Controller = SNES_MOUSE_SWAPPED;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #1" : "Mouse on #1", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESMOUSE0:
			if(GUI.StopEmulation || GUI.PauseEmulation || !Settings.Mouse)
				break;
			IPPU.Controller = SNES_MOUSE;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Mouse I #0" : "Mouse on #0", 2000);
			if(!GUI.ForcedPauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
			break;

		case ID_OPTION_SNESSUPERSCOPE:
			if(GUI.StopEmulation || GUI.PauseEmulation || !Settings.SuperScope)
				break;
			IPPU.Controller = SNES_SUPERSCOPE;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Superscope I #1" : "Superscope on #1", 2000);
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			break;

		case ID_OPTION_SNESJUSTIFIER:
			if(GUI.StopEmulation || GUI.PauseEmulation || !Settings.Justifier)
				break;
			IPPU.Controller = SNES_JUSTIFIER;
			S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "Justifier I #0" : "Justifier on #0", 2000);
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			break;

		//ԃZ[u
		case ID_FILE_SAVESLOT_1:
		case ID_FILE_SAVESLOT_2:
		case ID_FILE_SAVESLOT_3:
		case ID_FILE_SAVESLOT_4:
		case ID_FILE_SAVESLOT_5:
		case ID_FILE_SAVESLOT_6:
		case ID_FILE_SAVESLOT_7:
		case ID_FILE_SAVESLOT_8:
		case ID_FILE_SAVESLOT_9:
		 if(XppMovie.Replay_status == MOVIE_NONE)
		 {
			S9xwStateSave(LOWORD(wParam) - ID_FILE_SAVESLOT_1 + 1);
		 }
			break;

		//ԃ[h
		case ID_FILE_LOADSLOT_1:
		case ID_FILE_LOADSLOT_2:
		case ID_FILE_LOADSLOT_3:
		case ID_FILE_LOADSLOT_4:
		case ID_FILE_LOADSLOT_5:
		case ID_FILE_LOADSLOT_6:
		case ID_FILE_LOADSLOT_7:
		case ID_FILE_LOADSLOT_8:
		case ID_FILE_LOADSLOT_9:
		 if(XppMovie.Replay_status == MOVIE_NONE)
		 {
			S9xwStateLoad(LOWORD(wParam) - ID_FILE_LOADSLOT_1 + 1);
		 }
			break;

		case ID_FILE_REPLAYRECODE_TYPE_1:
		case ID_FILE_REPLAYRECODE_TYPE_2:
			XppMovie.Replay_Recode_Mode = LOWORD(wParam) - ID_FILE_REPLAYRECODE_TYPE_1;
			break;

		case ID_FILE_REPLAYTIMING_1:
		case ID_FILE_REPLAYTIMING_2:
			CPU.OldTiming = LOWORD(wParam) - ID_FILE_REPLAYRECODE_TYPE_1;
			break;

		case ID_FILE_REPLAY_SLOT_0:
		case ID_FILE_REPLAY_SLOT_1:
		case ID_FILE_REPLAY_SLOT_2:
		case ID_FILE_REPLAY_SLOT_3:
		case ID_FILE_REPLAY_SLOT_4:
		case ID_FILE_REPLAY_SLOT_5:
		case ID_FILE_REPLAY_SLOT_6:
		case ID_FILE_REPLAY_SLOT_7:
		case ID_FILE_REPLAY_SLOT_8:
		case ID_FILE_REPLAY_SLOT_9:
			XppMovie.Replay_Slot = LOWORD(wParam) - ID_FILE_REPLAY_SLOT_0;
			break;

		case ID_FILE_REPLAY_PLAY:
			S9XW_XPP_REPLAY_PLAY
			break;

		case ID_FILE_REPLAY_RECODE:
			S9XW_XPP_REPLAY_RECODE
			break;

		case ID_FILE_REPLAY_STOP:
			S9XW_XPP_REPLAY_STOP
			break;

		case ID_FILE_REPLAY_RESUME_LOAD:
			
			if(XppMovie.Replay_status == MOVIE_NONE)
			{
				S9XW_XPP_REPLAY_RESUME_LOAD
			}
			else
			{
				S9XW_XPP_REPLAY_RESUME_RELOAD
			}
			break;

		case ID_FILE_REPLAY_RESUME_SAVE:
			S9XW_XPP_REPLAY_RESUME_SAVE
			break;

		case ID_MAPFUNC:
		
		if(!WindowActiveFlag)
		{
		   if(!(LOWORD(lParam) == MF_TURBO || LOWORD(lParam) == MF_TURBOPAUSEFWD ||
		       (LOWORD(lParam) >= MF_XPP_A && LOWORD(lParam) <= MF_XPP_F)))
		   break;
		}
		
			//Slot 1-9 save
			if(LOWORD(lParam) < MF_LOAD1) {
		 if(XppMovie.Replay_status == MOVIE_NONE)
		 {
					S9xwStateSave(LOWORD(lParam) - MF_SAVE1 + 1);
		 }
			}
			//Slot 1-9 load
			else if(LOWORD(lParam) > MF_SAVE2 && LOWORD(lParam) < MF_TURBO) {
		 if(XppMovie.Replay_status == MOVIE_NONE)
		 {
				wsprintf(tmpcharbuf, ".%03d", LOWORD(lParam) - MF_LOAD1);
				if(GetFileAttributes(S9xGetFilename(tmpcharbuf)) != 0xffffffff)
					S9xwStateLoad(LOWORD(lParam) - MF_LOAD1 + 1);
		 }
			}
			//Toggle Turbo Mode
			else if(LOWORD(lParam) == MF_TURBO) {
				Settings.TurboMode = !Settings.TurboMode;
				if(Settings.TurboMode) {
					lstrcpy(WindowTitleTextNormal, WindowTitleTextTurbo);
					lstrcpy(WindowTitleText, WindowTitleTextTurbo);
					lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{[h I (XLbv " : "Turbo Mode on (Skip ");
					wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d)", Settings.TurboSkipFrames);
					S9xMessage2 (OnScreenMessageStr, 2000);
				}
				else {
					lstrcpy(WindowTitleTextNormal, WindowTitleTextNormal_bak);
					lstrcpy(WindowTitleText, WindowTitleTextNormal_bak);
					S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "^[{[h It" : "Turbo Mode off", 2000);
				}
			}
			//Press Turbo Mode
			else if(LOWORD(lParam) == MF_TURBOPAUSEFWD) {
				Settings.TurboMode = !Settings.TurboMode;
				if(Settings.TurboMode) {
				//	lstrcpy(WindowTitleTextNormal, WindowTitleTextTurbo);
				//	lstrcpy(WindowTitleText, WindowTitleTextTurbo);
				//	lstrcpy(OnScreenMessageStr, (GUI.Language && DirectX.Windowed) ? "^[{[h I (XLbv " : "Turbo Mode on (Skip ");
				//	wsprintf(&OnScreenMessageStr[lstrlen(OnScreenMessageStr)], "%d)", Settings.TurboSkipFrames);
				//	S9xMessage2 (OnScreenMessageStr, 2000);
				}
				else {
				//	lstrcpy(WindowTitleTextNormal, WindowTitleTextNormal_bak);
				//	lstrcpy(WindowTitleText, WindowTitleTextNormal_bak);
				//	S9xMessage2 ((GUI.Language && DirectX.Windowed) ? "^[{[h It" : "Turbo Mode off", 2000);
				}
			}
			//Reset
			else if(LOWORD(lParam) == MF_RESET) {
        #ifdef SNES9XPP_FULL
			S9XW_KEY_FILE_RESET_FULL
		#else
			S9XW_KEY_FILE_RESET
		#endif
			}
			//Soft Reset
			else if(LOWORD(lParam) == MF_SOFTRESET) {
        #ifdef SNES9XPP_FULL
			S9XW_KEY_FILE_SOFTRESET_FULL
		#else
			S9XW_KEY_FILE_SOFTRESET
		#endif
			}
			//SPC dump
			else if(LOWORD(lParam) == MF_SPCDUMP) {
			S9XW_KEY_FILE_SPCDUMP
			}
			//Screenshot
			else if(LOWORD(lParam) == MF_SCREENSHOT) {
			S9XW_KEY_FILE_SCREENSHOT
			}
			// Snes9xpp Original 
			else if(LOWORD(lParam) == MF_XPP01) {
#ifdef SNES9XPP_FULL
				if(Xppbsx.BsxRomCheck) BSX_WORK ();
#endif

				if(XppMovie.Replay_status != MOVIE_PLAY)
				XPP_ROMCHEAT_CODE (ROMCHEAT_SELECT);
			}
			else if(LOWORD(lParam) == MF_XPP02) {
#ifdef SNES9XPP_FULL
				if(Xppbsx.BsxRomCheck) BSX_TIMESKIP ();
#endif

				if(XppMovie.Replay_status != MOVIE_PLAY)
				XPP_ROMCHEAT_CODE (ROMCHEAT_CODE);
			}
			else if(LOWORD(lParam) == MF_XPP03) {
#ifdef SNES9XPP_FULL
				if(Xppbsx.BsxRomCheck) BSX_TIMEBACK ();
#endif

				if(XppMovie.Replay_status != MOVIE_PLAY)
				{
				   Xppcode.CheatNumBackFlag=1;
				   XPP_ROMCHEAT_CODE (ROMCHEAT_SELECT);
				   Xppcode.CheatNumBackFlag=0;
				}
			}
			else if(LOWORD(lParam) == MF_XPP04) {
#ifdef SNES9XPP_FULL
				if(Xppbsx.BsxRomCheck) BSX_WORKEXTRA ();
#endif

				if(SNESGameFix.VoicerKun){
 			               Xppcdda.VoicerCDChange = TRUE;
 			               lstrcpy(OnScreenMessageStr, "Disc Change");
 			               S9xMessage2 (OnScreenMessageStr, 2000);}

			}
			else if(LOWORD(lParam) == MF_XPP05) {

			   S9XW_XPP_KEY_05

			}
			else if(LOWORD(lParam) == MF_XPP06) {

			   S9XW_XPP_KEY_06

			}
			else if(LOWORD(lParam) == MF_XPP07) {

			   if(XppMovie.Replay_status == MOVIE_NONE)
			   {
					S9XW_XPP_REPLAY_RECODE
			   }
			   else
			   {
					S9XW_XPP_REPLAY_STOP
			   }
			}
			else if(LOWORD(lParam) == MF_XPP08) {
			   if(XppMovie.Replay_status == MOVIE_NONE)
			   {
					S9XW_XPP_REPLAY_PLAY
			   }
			   else
			   {
					S9XW_XPP_REPLAY_STOP
			   }
			}
			else if(LOWORD(lParam) == MF_XPP09) {
			   if(XppMovie.Replay_status == MOVIE_NONE)
			   {
					S9XW_XPP_REPLAY_RESUME_LOAD
			   }
			   else
			   {
					S9XW_XPP_REPLAY_RESUME_SAVE
			   }
			}
			else if(LOWORD(lParam) == MF_XPP10) {
			   if(XppMovie.Replay_status == MOVIE_NONE)
			   {
			               if(XppMovie.Replay_Slot >= 9)
			               {
			                     XppMovie.Replay_Slot=0;
			               }
			               else
			               {
			                     XppMovie.Replay_Slot++;
			               }
 			               lstrcpy(OnScreenMessageStr, "Change Movie Slot #");
 			               wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", XppMovie.Replay_Slot);
 			               S9xMessage2 (OnScreenMessageStr, 2000);
			   }
			   else
			   {
					S9XW_XPP_REPLAY_RESUME_RELOAD
			   }
			}
			else if(LOWORD(lParam) == MF_XPP11) {
			
			                 if(IPPU.Controller != SNES_SUPERSCOPE)
			                 Change_Turbo_Key(0);
			                 else
			                 superscope_turbo ^= 1;
			}
			else if(LOWORD(lParam) == MF_XPP12) {
			
			                 if(IPPU.Controller != SNES_SUPERSCOPE)
			                 Change_Turbo_Key(1);
			                 else
			                 superscope_pause = TRUE;
			}
			else if(LOWORD(lParam) == MF_XPP_A) {
			

				if(Xppsystem.XppkeyPage == 0)
				{
				}
				else
				if(Xppsystem.XppkeyPage == 1)
				{

				#ifdef SNES9XPP_FULL
								if(Xppbsx.BsxRomCheck) BSX_WORK ();
				#endif

								if(XppMovie.Replay_status != MOVIE_PLAY)
								XPP_ROMCHEAT_CODE (ROMCHEAT_SELECT);

				}
				else
				if(Xppsystem.XppkeyPage == 2)
				{

							   if(XppMovie.Replay_status == MOVIE_NONE)
							   {
									S9XW_XPP_REPLAY_RECODE
							   }
							   else
							   {
									S9XW_XPP_REPLAY_STOP
							   }

				}
				else
				if(Xppsystem.XppkeyPage == 3)
				{
				
					Xppsystem.StatePage++;
					if(Xppsystem.StatePage==9) Xppsystem.StatePage = 0;
				
				}
				else
				if(Xppsystem.XppkeyPage == 4)
				{
							S9XW_XPP_KEY_05
				}
				else
				if(Xppsystem.XppkeyPage == 5)
				{
							S9XW_KEY_FILE_SCREENSHOT
				}
				else
				if(Xppsystem.XppkeyPage == 6)
				{
							   S9XW_KEY_OPTION_FPS
				}

			}
			else if(LOWORD(lParam) == MF_XPP_B) {
			

				if(Xppsystem.XppkeyPage == 0)
				{
				}
				else
				if(Xppsystem.XppkeyPage == 1)
				{

				#ifdef SNES9XPP_FULL
								if(Xppbsx.BsxRomCheck) BSX_TIMESKIP ();
				#endif

								if(XppMovie.Replay_status != MOVIE_PLAY)
								XPP_ROMCHEAT_CODE (ROMCHEAT_CODE);

				}
				else
				if(Xppsystem.XppkeyPage == 2)
				{

							   if(XppMovie.Replay_status == MOVIE_NONE)
							   {
									S9XW_XPP_REPLAY_RESUME_LOAD
							   }
							   else
							   {
									S9XW_XPP_REPLAY_RESUME_SAVE
							   }

				}
				else
				if(Xppsystem.XppkeyPage == 3)
				{
							   S9xwStateLoad(Xppsystem.StatePage + 1);
				}
				else
				if(Xppsystem.XppkeyPage == 4)
				{
			    			   Change_Turbo_Key(0);
				}
				else
				if(Xppsystem.XppkeyPage == 5)
				{
				}
				else
				if(Xppsystem.XppkeyPage == 6)
				{

							   Options.VolumeLevel = Options.VolumeLevel+1;
							   if(Options.VolumeLevel == 6) Options.VolumeLevel = 1;

				 			   lstrcpy(OnScreenMessageStr, "Change Volume - #");
				 			   wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", Options.VolumeLevel);
				 			   S9xMessage2 (OnScreenMessageStr, 2000);

				}

			}
			else if(LOWORD(lParam) == MF_XPP_C) {
			

				if(Xppsystem.XppkeyPage == 0)
				{
				}
				else
				if(Xppsystem.XppkeyPage == 1)
				{

				#ifdef SNES9XPP_FULL
								if(Xppbsx.BsxRomCheck) BSX_TIMEBACK ();
				#endif

								if(XppMovie.Replay_status != MOVIE_PLAY)
								{
								   Xppcode.CheatNumBackFlag=1;
								   XPP_ROMCHEAT_CODE (ROMCHEAT_SELECT);
								   Xppcode.CheatNumBackFlag=0;
								}

				}
				else
				if(Xppsystem.XppkeyPage == 2)
				{

							   if(XppMovie.Replay_status == MOVIE_NONE)
							   {
									S9XW_XPP_REPLAY_PLAY
							   }
							   else
							   {
									S9XW_XPP_REPLAY_STOP
							   }

				}
				else
				if(Xppsystem.XppkeyPage == 3)
				{
				
					if(Xppsystem.StatePage==0) Xppsystem.StatePage = 9;
					Xppsystem.StatePage--;
				
				}
				else
				if(Xppsystem.XppkeyPage == 4)
				{
							S9XW_XPP_KEY_06
				}
				else
				if(Xppsystem.XppkeyPage == 5)
				{
							S9XW_KEY_FILE_SPCDUMP
				}
				else
				if(Xppsystem.XppkeyPage == 6)
				{
							   S9XW_KEY_OPTION_FULLSCREEN
				}

			}
			else if(LOWORD(lParam) == MF_XPP_D) {
			
				if(Xppsystem.XppkeyPage == 0)
				{
				}
				else
				if(Xppsystem.XppkeyPage == 1)
				{

				#ifdef SNES9XPP_FULL
								if(Xppbsx.BsxRomCheck) BSX_WORKEXTRA ();
				#endif

								if(SNESGameFix.VoicerKun){
				 			               Xppcdda.VoicerCDChange = TRUE;
				 			               lstrcpy(OnScreenMessageStr, "Disc Change");
				 			               S9xMessage2 (OnScreenMessageStr, 2000);}

				}
				else
				if(Xppsystem.XppkeyPage == 2)
				{

							   if(XppMovie.Replay_status == MOVIE_NONE)
							   {
							               if(XppMovie.Replay_Slot >= 9)
							               {
							                     XppMovie.Replay_Slot=0;
							               }
							               else
							               {
							                     XppMovie.Replay_Slot++;
							               }
				 			               lstrcpy(OnScreenMessageStr, "Change Movie Slot #");
				 			               wsprintf(OnScreenMessageStr + lstrlen(OnScreenMessageStr), "%d ", XppMovie.Replay_Slot);
				 			               S9xMessage2 (OnScreenMessageStr, 2000);
							   }
							   else
							   {
									S9XW_XPP_REPLAY_RESUME_RELOAD
							   }

				}
				else
				if(Xppsystem.XppkeyPage == 3)
				{
				
							   S9xwStateSave(Xppsystem.StatePage + 1);
				
				}
				else
				if(Xppsystem.XppkeyPage == 4)
				{
							   S9XW_TURBO_MODE_KEY
				}
				else
				if(Xppsystem.XppkeyPage == 5)
				{
				}
				else
				if(Xppsystem.XppkeyPage == 6)
				{
							   S9XW_KEY_OPTION_CONFIG
				}

			}
			else if(LOWORD(lParam) == MF_XPP_E) {
			
				if(Simultaneous_Key (0) & 0x3000)
				{
			                 Xppsystem.XppkeyHelp ^= 1;
				}
				else
				if(Simultaneous_Key (0) & 0x40 && Simultaneous_Key (0) & 0x80 && Simultaneous_Key (0) & 0x4000 && Simultaneous_Key (0) & 0x8000)
				{
				        #ifdef SNES9XPP_FULL
							S9XW_KEY_FILE_SOFTRESET_FULL
						#else
							S9XW_KEY_FILE_SOFTRESET
						#endif
				}
				else
				if(Simultaneous_Key (0) & 0x20 && Simultaneous_Key (0) & 0x10)
				{
			                 S9XW_KEY_FILE_OPEN_XPP_KEY
				}
				else
				{
 				 		Xppsystem.XppkeyPage++;
 				 		if(Xppsystem.XppkeyPage == 7) Xppsystem.XppkeyPage = 0;
 				 		
 				 		if(Xppsystem.XppkeyPage == 0)
 				 		lstrcpy(OnScreenMessageStr, "Function change [None]");
 				 		else if(Xppsystem.XppkeyPage == 1)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Code & Bsx]");
 				 		else if(Xppsystem.XppkeyPage == 2)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Movie]");
 				 		else if(Xppsystem.XppkeyPage == 3)
 				 		lstrcpy(OnScreenMessageStr, "Function change [State]");
 				 		else if(Xppsystem.XppkeyPage == 4)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Speed & Tuebo]");
 				 		else if(Xppsystem.XppkeyPage == 5)
 				 		lstrcpy(OnScreenMessageStr, "Function change [SShot & Spc]");
 				 		else if(Xppsystem.XppkeyPage == 6)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Config]");
 				 		
 				 		S9xMessage2 (OnScreenMessageStr, 2000);
				}
			}
			else if(LOWORD(lParam) == MF_XPP_F) {
			
				if(Simultaneous_Key (0) & 0x3000)
				{
			                 Xppsystem.XppkeyHelp ^= 1;
				}
				else
				if(Simultaneous_Key (0) & 0x40 && Simultaneous_Key (0) & 0x80 && Simultaneous_Key (0) & 0x4000 && Simultaneous_Key (0) & 0x8000)
				{
				        #ifdef SNES9XPP_FULL
							S9XW_KEY_FILE_RESET_FULL
						#else
							S9XW_KEY_FILE_RESET
						#endif
				}
				else
				if(Simultaneous_Key (0) & 0x20 && Simultaneous_Key (0) & 0x10)
				{
			                 PostMessage( GUI.hWnd, WM_CLOSE, 0, 0);
				}
				else
				{
 				 		if(Xppsystem.XppkeyPage == 0) Xppsystem.XppkeyPage = 7;
 				 		Xppsystem.XppkeyPage--;
 				 		
 				 		if(Xppsystem.XppkeyPage == 0)
 				 		lstrcpy(OnScreenMessageStr, "Function change [None]");
 				 		else if(Xppsystem.XppkeyPage == 1)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Code & Bsx]");
 				 		else if(Xppsystem.XppkeyPage == 2)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Movie]");
 				 		else if(Xppsystem.XppkeyPage == 3)
 				 		lstrcpy(OnScreenMessageStr, "Function change [State]");
 				 		else if(Xppsystem.XppkeyPage == 4)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Speed & Tuebo]");
 				 		else if(Xppsystem.XppkeyPage == 5)
 				 		lstrcpy(OnScreenMessageStr, "Function change [SShot & Spc]");
 				 		else if(Xppsystem.XppkeyPage == 6)
 				 		lstrcpy(OnScreenMessageStr, "Function change [Config]");
 				 		
 				 		S9xMessage2 (OnScreenMessageStr, 2000);
				}
			}
		}
		break;

	case WM_ENTERMENULOOP:
		if(!UIEnter())
			break;
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		SwitchToGDI();
		DrawMenuBar( GUI.hWnd);
		break;

	case WM_NCLBUTTONDOWN:
		S9xwKillMessageTimer();
		if(!GUI.FullScreen && DirectX.Windowed && wParam == HTCAPTION)
		{
			ncbuttondown_flag = 1;
			S9xwPauseEmulation(TRUE);
		}
		break;

	case WM_PAINT:
		if(NeedJoystickInit) {
			NeedJoystickInit = 0;
			S9xwJoystickInit();
		}
		if(NeedScreenImage) {
			NeedScreenImage = 0;
		}
		if(CmdLineROMLoadFlag) {
			CmdLineROMLoadFlag = 0;
			S9xwPauseEmulation(TRUE);
			ROMLoadProc(ROMFileName);
			if(!GUI.StopEmulation)
				SetPriorityClassAndThreadPriority(GUI.PriorityClass, GUI.ThreadPriority);
			else
				SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
			S9xwPauseEmulation(FALSE);
			if(IPPU.Controller != SNES_SUPERSCOPE && IPPU.Controller != SNES_JUSTIFIER && !GUI.StopEmulation && !GUI.PauseEmulation)
				S9xMessage2 ("EraseMouseCursor", 1000);
		}
		
//		if(GUI.FullScreen || GUI.StopEmulation)
		if(!DirectX.Windowed)
			break;
		ScreenRedraw(hWnd);
		break;

	case WM_CAPTURECHANGED:
		if(!GUI.FullScreen && DirectX.Windowed && ncbuttondown_flag)
		{
			ncbuttondown_flag = 0;
			S9xwPauseEmulation(FALSE);
		}
		break;

	// user is moving window
	case WM_ENTERSIZEMOVE:
		if(!GUI.FullScreen && DirectX.Windowed)
			S9xwPauseEmulation(TRUE);
		break;

	case WM_EXITSIZEMOVE:
		SizingFlag = FALSE;
		if(!GUI.FullScreen && DirectX.Windowed) {
			//݂̃EChETCYۑ
			GetWindowRect(hWnd, &WindowRectSetting);
			S9xwPauseEmulation(FALSE);
		}
		break;

	case WM_SIZE:
		switch(wParam)
		{
			case SIZE_MINIMIZED:
				MinimizedFlag = 1;
				break;

			case SIZE_RESTORED:
				if(MinimizedFlag == 2 && DirectX.Windowed && !GUI.FullScreen && !GUI.StopEmulation) {
					MinimizedFlag = 0;
					S9xwPauseEmulation(TRUE);
					if(!S9xwSwitchScreenMode(FALSE))
						break;
					S9xwPauseEmulation(FALSE);
				}
				//EChETCYύXɃQ[oȂ悤ɂ
				else if(!SizingFlag && !GUI.FullScreen && DirectX.Windowed && !GUI.StopEmulation)
					S9xwPauseEmulation(FALSE);
				if(SizingFlag && DirectX.Windowed)
				{
					GetClientRect(hWnd, &rc);
					RedrawDstH = ExtendHeight ? 239 : 224;
					RedrawDstW= 256;
					if(GUI.Scale > 0)
						RedrawDstH <<= 1;
					if(GUI.Scale > 0)
						RedrawDstW <<= 1;
					if(((!GUI.FullScreen && !GUI.Stretch) || (GUI.FullScreen && !GUI.FullScreen_Stretch)) && (RedrawDstW < (rc.right - rc.left) || RedrawDstH < (rc.bottom - rc.top)))
					{
						hRgn1 = CreateRectRgn(0, 0, 1, 1);
						hRgn2 = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);
						if(RedrawDstW < (rc.right - rc.left))
						{
							rc.left = ((rc.right - rc.left) - RedrawDstW) / 2;
							rc.right = rc.left + RedrawDstW;
						}
						if(RedrawDstH < (rc.bottom - rc.top))
						{
							rc.top = ((rc.bottom - rc.top) - RedrawDstH) / 2;
							rc.bottom = rc.top + RedrawDstH;
						}
						hRgn3 = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);
						CombineRgn(hRgn1, hRgn2, hRgn3, RGN_XOR);
						DeleteObject(hRgn2);
						DeleteObject(hRgn3);
						hdc = GetDC(hWnd);
						SelectClipRgn(hdc, hRgn1);
						GetClientRect(hWnd, &rc);
						FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
						DeleteObject(hRgn1);
						ReleaseDC(hWnd, hdc);
						ScreenRedraw(hWnd);
					}
					else if((rc.right - rc.left) || (rc.bottom - rc.top))
						ScreenRedraw(hWnd);
				}
				MinimizedFlag = 0;
				break;
			
			default:
				break;
		}
		break;

	case WM_SIZING:
		if(!DirectX.Windowed || MinimizedFlag)
			break;
		else if(!SizingFlag)
		{
			S9xwPauseEmulation(TRUE);
			SizingFlag = TRUE;
		}

			if(DirectX.Windowed) { 
				GetClientRect(GUI.hWnd, &rc);
				hdc = GetDC(GUI.hWnd);
				FillRect(hdc, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				ReleaseDC(GUI.hWnd, hdc); 
			}
			else
				UpdateBackBuffer();

		break;
		
	case WM_CLOSE:
		S9xSetSoundMute (TRUE);
		Sleep(500);
		SetPriorityClassAndThreadPriority(NORMAL_PRIORITY_CLASS, THREAD_PRIORITY_NORMAL);
		DragAcceptFiles(hWnd, FALSE); //hbOhbv
		//݂̃EChETCYۑ
		if(DirectX.Windowed && !MinimizedFlag)
			GetWindowRect(hWnd, &WindowRectSetting);
		S9xwKillMessageTimer();
		DestroyWindow(hWnd);
		return 0;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_SYSCOMMAND:
	
	if (!GUI.StopEmulation && (wParam == SC_SCREENSAVE || wParam == SC_MONITORPOWER))
      return (0);
	
		switch( LOWORD(wParam))
		{
		case ID_OPTION_VL1:
		case ID_OPTION_VL2:
		case ID_OPTION_VL3:
		case ID_OPTION_VL4:
		case ID_OPTION_VL5:
			Options.VolumeLevel = LOWORD(wParam) - ID_OPTION_VL1 + 1;
			return DefWindowProc( hWnd, uMsg, wParam, lParam);
		}
		switch(wParam & 0xfff0) // & to catch double-click on title bar maximize
		{
			case SC_MINIMIZE:
				if(!GUI.FullScreen && DirectX.Windowed)
					S9xwPauseEmulation(TRUE);
				MinimizedFlag = 1;
				break;

			case SC_MAXIMIZE:
				if(MinimizedFlag) {
						MinimizedFlag = 2;
					SendMessage(hWnd, WM_SYSCOMMAND, (WPARAM)SC_RESTORE, 0);
				}
				else if(DirectX.Windowed && !GUI.FullScreen && !GUI.StopEmulation && !GUI.ForcedPauseEmulation && !(DirectX.Windowed && DirectX.Depth == 8)) {
					S9xwPauseEmulation(TRUE);
					if(!S9xwSwitchScreenMode(FALSE))
						break;
					S9xwPauseEmulation(FALSE);
				}
				return 0;

			case SC_RESTORE:
				if(MinimizedFlag == 1)
					MinimizedFlag = 0;
				break;
			
			default:
				break;
		}
		break;

	default:
		break;
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam);
}

/*****************************************************************************/
/* WinInit                                                                   */
/*****************************************************************************/

static LPCTSTR snes9xppClassName = "Snes9xppW: WndClass";

#if 1 // G[\
static LPTOP_LEVEL_EXCEPTION_FILTER pass_thru_filter;
static LONG CALLBACK exception_filter(struct _EXCEPTION_POINTERS *info);

static LONG CALLBACK exception_filter(struct _EXCEPTION_POINTERS *info)
{
	// exit
	return 1;
}
#endif

BOOL WinInit( HINSTANCE hInstance)
{
WNDCLASS wndclass;
POINT p;

	wndclass.style = 0;
	wndclass.lpfnWndProc = WinProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IICON));
	wndclass.hCursor = NULL;
	wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndclass.lpszMenuName = 0;
	wndclass.lpszClassName = snes9xppClassName;

#if 1 // G[\
	pass_thru_filter = SetUnhandledExceptionFilter(exception_filter);
#endif

	GUI.hInstance = hInstance;

	if( !RegisterClass( &wndclass))
		return FALSE;
	
	if( (GUI.hMenu = LoadMenu( hInstance, MAKEINTRESOURCE( Languages[ GUI.Language].idMenu))) == NULL) {
		UnregisterClass(wndclass.lpszClassName, hInstance);
		return FALSE;
	}
	if((GUI.hVolMenu = LoadMenu( hInstance, MAKEINTRESOURCE(IDR_VOLMENU))) == NULL) {
		DestroyMenu(GUI.hMenu);
		UnregisterClass(wndclass.lpszClassName, hInstance);
		return FALSE;
	}
	if(Options.JPenvFlag)
		InsertMenu(GetSubMenu(GUI.hMenu, 3), 2, MF_BYPOSITION, ID_OPTION_JP, GUI.Language ? "{ UI(&U)\tCtrl+U" : "English &UI\tCtrl+U");

	SystemParametersInfo(SPI_GETWORKAREA, 0, &rc, 0);

	//EChETCYʒuݒǂݍ݂ĂȂꍇA܂͓ǂݍ񂾃EChETCYݒ肪sȏꍇ
	if((WindowRectSetting.left == -1 && WindowRectSetting.right == -1 && WindowRectSetting.top == -1 && WindowRectSetting.bottom == -1)
		|| (WindowRectSetting.right - WindowRectSetting.left) < DefaultWindowSizeW || (WindowRectSetting.bottom - WindowRectSetting.top) < DefaultWindowSizeH)
	{
		WindowSizeW = DefaultWindowSizeWW[1];
		WindowSizeH = DefaultWindowSizeHH[1];
		p = *GetWindowPosCenter(WindowSizeW, WindowSizeH);
		WindowRectSetting.left = p.x;
		WindowRectSetting.top = p.y;
		WindowRectSetting.right = (p.x + WindowSizeW);
		WindowRectSetting.bottom = (p.y + WindowSizeH);
	}
	//ǂݍ񂾃EChEʒuݒ肪Ɨ̈̈ʒuTCYƔrĖꍇ
	else if((rc.right - 50) < WindowRectSetting.left || (rc.bottom - 50) < WindowRectSetting.top || rc.top > WindowRectSetting.top || WindowRectSetting.right < 50)
	{
		WindowSizeW = (WindowRectSetting.right - WindowRectSetting.left);
		WindowSizeH = (WindowRectSetting.bottom - WindowRectSetting.top);
		p = *GetWindowPosCenter(WindowSizeW, WindowSizeH);
		WindowRectSetting.left = p.x;
		WindowRectSetting.top = p.y;
		WindowRectSetting.right = (p.x + WindowSizeW);
		WindowRectSetting.bottom = (p.y + WindowSizeH);
	}
	//ǂݍ񂾃EChETCYʒuݒŃEChE
	else {
		WindowSizeW = (WindowRectSetting.right - WindowRectSetting.left);
		WindowSizeH = (WindowRectSetting.bottom - WindowRectSetting.top);
		p.x = WindowRectSetting.left;
		p.y = WindowRectSetting.top;
	}

	if( (GUI.hWnd = CreateWindow(
		snes9xppClassName,
		WindowTitleText,
		GUI.dwStyleWindowed,
		p.x,
		p.y,
		WindowSizeW, WindowSizeH,
		NULL,
		NULL,
		hInstance,
		NULL)) == NULL) {
		UnregisterClass(wndclass.lpszClassName, hInstance);
		return FALSE;
	}

	//j[Zbg
	SetMenu( GUI.hWnd, GUI.hMenu);
	GUI.AppMenuConnect = TRUE;

	GUI.hSysMenu = GetSystemMenu(GUI.hWnd, FALSE);
	/* svȃVXej[폜 */
//	for (int i = 2; i < 3; i++)
//		DeleteMenu(GUI.hSysMenu, i, MF_BYPOSITION);
		InsertMenu(GUI.hSysMenu, 0, MF_BYPOSITION | MF_POPUP, (UINT)GetSubMenu(GUI.hVolMenu, 0), (GUI.Language ? "{[x(&V)" : "&Volume Level"));
		InsertMenu(GUI.hSysMenu, 1, MF_BYPOSITION | MFT_SEPARATOR, 0, 0);

	SetCursor(LoadCursor(NULL, IDC_ARROW));
	return TRUE;
}

void WinSave( void)
{
	WriteIniFile();
}

extern long _rate;
extern bool _sixteen_bit;
extern bool _stereo;
extern long _buffernos;
extern long _buffersize;
extern long _samplecount;
extern long _bytecount;
extern unsigned long _interval;

extern bool8 mmx_cpu;


/*****************
 default settings
*****************/
int GUI_SoundMode_def = 21;
int Settings_SoundBufferSize_def = 4;
int Settings_SoundMixInterval_def = 10;
int DoubleRenderingModes16_def = 2;
unsigned char ForceWindowedDirectDrawClipper_def = 0;
unsigned char dRendering_def = 0;
bool GUI_DoubleBuffered_def = FALSE;
DWORD GUI_PriorityClass_def = NORMAL_PRIORITY_CLASS;
int GUI_ThreadPriority_def = THREAD_PRIORITY_NORMAL;

bool8 Settings_Mode7Interpolate_def = FALSE;
bool8 TransparencyFlag_def = 1;
bool8 Settings_BGLayering_def = FALSE;
bool8 Settings_DisableGraphicWindows_def = FALSE;
bool8 Settings_DisableHDMA_def = FALSE;
bool8 Settings_InterpolatedSound_def = TRUE;
bool8 Settings_NextAPUEnabled_def = TRUE;
bool8 Settings_DisableSoundEcho_def = FALSE;
bool8 Settings_ReverseStereo_def = FALSE;
bool8 Settings_SoundSync_def = TRUE;
bool8 Settings_DisableMasterVolume_def = FALSE;
bool8 Settings_SoundEnvelopeHeightReading_def = TRUE;
uint8 Settings_SoundSkipMethod_def = 0;
bool8 Settings_ShutdownMaster_def = TRUE;
uint32 Settings_ControllerOption_def = SNES_JOYPAD;
bool8 Settings_MultiPlayer5_def = TRUE;
bool8 Settings_Mouse_def = TRUE;
bool8 Settings_SuperScope_def = TRUE;
bool8 Settings_Justifier_def = TRUE;
uint32 Settings_SkipFrames_def = AUTO_FRAMERATE;
uint32 Settings_AutoMaxSkipFrames_def = 10;
long Settings_CyclesPercentage_def = 100;
uint32 Settings_FrameTimePAL_def = 20;
uint32 Settings_FrameTimeNTSC_def = 16;
int32 Settings_AutoSaveDelay_def = 0;
bool8 Settings_SDD1Pack_def = TRUE;
bool8 Xppsystem_DisableIRQCycleCount_def = TRUE;
bool8 Xppsystem_OldAutoFrame_def = FALSE;
bool8 Xppsystem_OldFrameTimer_def = FALSE;
bool8 Xppsystem_FontType_def = FALSE;
bool8 Xppsystem_InactivateWork_def = FALSE;
bool8 Options_CpuSleep_def = FALSE;
bool8 CPU_DisableSpinWaitLoop_def = FALSE;

int32 Options_MaxWinJoyButtons_def = 32;

void WinLoad( void)
{
//ftHgݒ
	DoubleRenderingModes16 = DoubleRenderingModes16_def;
	ForceWindowedDirectDrawClipper = ForceWindowedDirectDrawClipper_def;
	dRendering = dRendering_def;
	TransparencyFlag = TransparencyFlag_def;

	DirectX_Initialize0();

	GUI.ScreenDepth = 16;
	GUI.Scale = 0;
	GUI.DoubleBuffered = GUI_DoubleBuffered_def;
	GUI.PauseEmulation = FALSE;
	GUI.ForcedPauseEmulation = FALSE;
	GUI.FullScreen = FALSE;
	GUI.Stretch = FALSE;
	GUI.FullScreen_Stretch = FALSE;
	Options.Adjustwindow = 1;
	Options.Full_Adjustwindow = 1;
	Options.AltScreenEffect = false;
	Options.ScanLinesEffect = 1;

	//LangID 0x0411 {
	Options.JPenvFlag = (GetSystemDefaultLangID() == 0x0411 ? 1 : 0);
	GUI.Language = (GetSystemDefaultLangID() == 0x0411 ? 1 : 0);
	Settings.DisplayFrameRate = FALSE;

	Settings.Transparency = TransparencyFlag_def;
	Settings.SkipFrames = Settings_SkipFrames_def;


    // CPU options 
    Settings.NextAPUEnabled = Settings_NextAPUEnabled_def;
	Settings.ShutdownMaster = Settings_ShutdownMaster_def;
    Settings.SoundSkipMethod = Settings_SoundSkipMethod_def;
    Settings.CyclesPercentage = Settings_CyclesPercentage_def;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;

//    Settings.SPCTo65c816Ratio = 2;
    Settings.DisableIRQ = FALSE;
    Settings.Paused = FALSE;

    // Tracing options
    Settings.TraceDMA = FALSE;
    Settings.TraceHDMA = FALSE;
    Settings.TraceVRAM = FALSE;
    Settings.TraceUnknownRegisters = FALSE;
    Settings.TraceDSP = FALSE;

    // Joystick options
    Settings.SwapJoypads = FALSE;
    Settings.JoystickEnabled = TRUE;

    // ROM timing options (see also H_Max above)
    Settings.PAL = FALSE;
    Settings.FrameTimePAL = Settings_FrameTimePAL_def;
    Settings.FrameTimeNTSC = Settings_FrameTimeNTSC_def;
    Settings.FrameTime = Settings_FrameTimeNTSC_def;

    // ROM image and peripheral options
	Settings.ForceHiROM = FALSE;
	Settings.ForceLoROM = FALSE;
	Settings.ForceInterleaved = FALSE;
	Settings.ForceNotInterleaved = FALSE;
	Settings.ForceInterleaved2 = FALSE;
	Settings.ForcePAL = FALSE;
	Settings.ForceNTSC = FALSE;
	Settings.ForceHeader = FALSE;
	Settings.ForceNoHeader = FALSE;
    Settings.ForceSuperFX = FALSE;
    Settings.ForceNoSuperFX = FALSE;
	Settings.ForceDSP1 = FALSE;
	Settings.ForceNoDSP1 = FALSE;

    Settings.Mouse = Settings_Mouse_def;
    Settings.SuperScope = Settings_SuperScope_def;
    Settings.MultiPlayer5 = Settings_MultiPlayer5_def;
    Settings.ControllerOption = Settings_ControllerOption_def;
    Settings.Justifier = Settings_Justifier_def;

    // Sound options
    Settings.TraceSoundDSP = FALSE;
    Settings.SoundPlaybackRate = 32000;
	GUI.SoundMode = GUI_SoundMode_def;
	Settings.Mute = FALSE;

	Settings.ReverseStereo = Settings_ReverseStereo_def;
//    Settings.Stereo = _stereo;
//    Settings.SoundBufferSize = _bytecount;
    Settings.SoundEnvelopeHeightReading = Settings_SoundEnvelopeHeightReading_def;
    Settings.DisableSoundEcho = Settings_DisableSoundEcho_def;
	Settings.DisableMasterVolume = Settings_DisableMasterVolume_def;
    Settings.InterpolatedSound = Settings_InterpolatedSound_def;
	Settings.SoundMixInterval = Settings_SoundMixInterval_def;
    Settings.SoundBufferSize = Settings_SoundBufferSize_def;
    Settings.SoundSync = Settings_SoundSync_def;
	Settings.ThreadSound = FALSE;

    // SNES graphics options
    Settings.BGLayering = Settings_BGLayering_def;
    Settings.DisableGraphicWindows = Settings_DisableGraphicWindows_def;
    Settings.ForceTransparency = FALSE;
    Settings.ForceNoTransparency = FALSE;
    Settings.DisableHDMA = Settings_DisableHDMA_def;
    Settings.Mode7Interpolate = Settings_Mode7Interpolate_def;

//    Settings.AutoSaveDelay = 0;
    Settings.AutoSaveDelay = Settings_AutoSaveDelay_def;

    Settings.ApplyCheats = FALSE;
    Settings.TurboMode = FALSE;
    Settings.TurboSkipFrames = 15;
    Settings.AutoMaxSkipFrames = Settings_AutoMaxSkipFrames_def;

    Settings.SDD1Pack = Settings_SDD1Pack_def;
    Xppsystem.DisableIRQCycleCount = Xppsystem_DisableIRQCycleCount_def;
    Xppsystem.OldAutoFrame = Xppsystem_OldAutoFrame_def;

    Xppsystem.DisableOutputSram = FALSE;
    
    Xppsystem.SpeedEnable = 0;
    Xppsystem.Speedflag = 0;

    Xppsystem.XppkeyPage = 0;
    Xppsystem.XppkeyHelp = 0;
    Xppsystem.StatePage = 0;
    
    Xppsystem.OldFrameTimer = Xppsystem_OldFrameTimer_def;
    Xppsystem.FontType = Xppsystem_FontType_def;
    Xppsystem.InactivateWork = Xppsystem_InactivateWork_def;

    CPU.OldTiming = FALSE;

	XppMovie.Replay_status = MOVIE_NONE;
    XppMovie.Replay_Recode_Mode = 0;
    XppMovie.Replay_Slot = 0;
    XPP_REPLAY_EXT_SET ();

    Settings.NetPlay = FALSE;
    Settings.ServerName [0] = 0;

	GUI.PriorityClass = GUI_PriorityClass_def;
	GUI.ThreadPriority = GUI_ThreadPriority_def;

    Options.MaxWinJoyButtons = Options_MaxWinJoyButtons_def;

    Options.CpuSleep = Options_CpuSleep_def;
    CPU.DisableSpinWaitLoop = CPU_DisableSpinWaitLoop_def;

	//ݒt@Cǂݍ
	ReadIniFile();
	if(!Options.JPenvFlag)
		GUI.Language = 0;
		Settings.Transparency = TransparencyFlag;

	if(!dRendering)
		DirectX.ForceWindowedDirectDrawClipper = ForceWindowedDirectDrawClipper;
	else
		DirectX.ForceWindowedDirectDrawClipper = FALSE;

	CurFullscreenDisplayModeIndexChange();

	//Check MMX CPU
	mmx_cpu = IsMMXEnabled();
	SelectRenderingCodes();
	MakeTurboStatus();

	//Switch GFXengine
	S9xSwitchGFXengine(Options.GFXengine2);
}

/* ROMLoadProc */
static bool ROMLoadProc(char *FileName)
{
	extern void RemoveFileName(char *PathStr);
	char *eext;

	//GetOpenFileNamê߂̃t@Cݒ
	lstrcpy(InitialROMFileDirectory, FileName);
	RemoveFileName(InitialROMFileDirectory);
	lstrcpy(FileTitle, S9xBasename((const char *)FileName));
	if(FileName != ROMFileName)
		lstrcpy(ROMFileName, FileName);

	if( !GUI.StopEmulation && EmuExecLoop == S9xMainLoop) {
		Memory.SaveSRAM( S9xGetFilename(".srm"));
		S9xSaveCheatFile(S9xGetFilename(".cht"));
              if(Xppcdda.Enable) cdda_exit(); // Snes9xpp Original
              XPP_REPLAY_END ();

#ifdef SNES9XPP_FULL
if(Xppbsx.BsxRomCheck) {
BSX_CLEAR ();
}
#endif

	}
	eext = GetFilenameExt(FileName);

/*
	Memory.Deinit ();
	S9xDeinitAPU ();
	if(!Memory.Init () || !S9xInitAPU ())
		DirectX.ForceClipper = FALSE;
		return FALSE;
*/
	GUI.StopEmulation = !Memory.LoadROM( FileName);

	//[W^CvwNA
	Settings.ForceLoROM = Settings.ForceHiROM = 0;
	Settings.ForceInterleaved = Settings.ForceInterleaved2 = Settings.ForceNotInterleaved = 0;
	Settings.ForcePAL = Settings.ForceNTSC = 0;
	Settings.ForceHeader = Settings.ForceNoHeader = 0;

	if( !GUI.StopEmulation) {
		Memory.LoadSRAM(S9xGetFilename(".srm"));

	ResetFrameTimer ();

 // Snes9xpp Original
if(Xppcdda.Enable)
{
		cdda_open();
		cdda_stop();
}

#ifdef SNES9XPP_FULL
if(Xppbsx.BsxRomCheck) {
BSX_CLEAR ();
BSX_SRAMFIRST ();
}
#endif

XPP_ROMCHEAT_CODE (ROMCHEAT_CLEAR); // Snes9xpp Original
		EmuExecLoop = S9xMainLoop;
	}
	else {
		S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
		DirectX.ForceClipper = FALSE;
		return FALSE;
	}
	//256FfXNgbv̂Ƃ͋IɃtXN[
	if(DirectX.Windowed && DirectX.Depth == 8)
		GUI.FullScreen = TRUE;
	//XN[obt@NA
	ScreenBufferClear();
	//tXN[[hŃǂݍ񂾂Ƃ̏
	if(GUI.FullScreen && DirectX.Windowed)
	{
		if(!S9xwSwitchScreenMode(FALSE)) {
			DirectX.ForceClipper = FALSE;
			return FALSE;
		}
	}
// wp`R̕sC
        else
        {
		if(!GUI.StopEmulation) {
			for (int c = 0; c < 256; c++)
			{
				IPPU.ScreenColors [c] = c;
			}
			S9xFixColourBrightness ();
			IPPU.ColorsChanged = TRUE;
			IPPU.RenderThisFrame = FALSE;
		}
        }

	S9xwSetMenuStatus(GUI.hMenu, GUI.hSysMenu);
	DirectX.ForceClipper = FALSE;
	return TRUE;
}

void S9xSetWindowPos()
{
	SetWindowPos(GUI.hWnd, HWND_TOP, WindowRectSetting.left, WindowRectSetting.top, 
		WindowRectSetting.right - WindowRectSetting.left, WindowRectSetting.bottom - WindowRectSetting.top, SWP_DRAWFRAME|SWP_FRAMECHANGED);
}

void Draw1frame()
{
	if(GUI.StopEmulation)
		return;
	int Width = 256;
	int Height = ExtendHeight ? 239 : 224;
	if(DoubleWidth)
		Width <<= 1;
	if(DoubleHeight)
		Height <<= 1;
	S9xDeinitUpdate(Width, Height, TRUE);
}

void ScreenRedraw(HWND hWnd)
{
	RECT srcRect, dstRect;
	POINT p;
	long SrcHeight = ExtendHeight ? 239 : 224;
	long SrcWidth = 256;
	long DstHeight = ExtendHeight ? 239 : 224;
	long DstWidth = 256;

	hdc=BeginPaint(hWnd,&ps);
	EndPaint(hWnd,&ps);

	if(DoubleHeight || (GUI.Scale > 1 && !DoubleWidth && !DoubleHeight) || (GUI.Scale > 1 && DoubleWidth && !DoubleHeight && DirectX.DisableHardwareScale) ||
	   (SOFT_SCREEN_EFFECT_EXTRA && DoubleWidth && !DoubleHeight) )
		SrcHeight <<= 1;
	if(DoubleWidth || (GUI.Scale > 1 && !DoubleWidth && !DoubleHeight) || (GUI.Scale > 1 && !DoubleWidth && DoubleHeight && DirectX.DisableHardwareScale))
		SrcWidth <<= 1;
	if(GUI.Scale > 0)
		DstHeight <<= 1;
	if(GUI.Scale > 0)
		DstWidth <<= 1;
	if(locked_surface)
	{
		srcRect.top    = 0;
		srcRect.left   = 0;
	}
	else
	{
		srcRect.top    = (478 - SrcHeight) / 2;
		srcRect.left   = (512 - SrcWidth) / 2;
	}
	srcRect.right  = srcRect.left + SrcWidth;
	srcRect.bottom = srcRect.top  + SrcHeight;
	
	GetClientRect(hWnd, &dstRect);
	if((!GUI.FullScreen && GUI.Stretch) || (GUI.FullScreen && GUI.FullScreen_Stretch))
	{
                        if (((!GUI.FullScreen && GUI.Stretch == 1) || (GUI.FullScreen && GUI.FullScreen_Stretch == 1))  || (GUI.FullScreen && (DirectX.Windowed || GUI.FullScreen_X < GUI.Res_X[Options.Full_Adjustwindow] || GUI.FullScreen_Y < GUI.Res_Y_EX[Options.Full_Adjustwindow])))
                        {
                                        p.x = p.y = 0;
                                        ClientToScreen (hWnd, &p);
                                        DstWidth = dstRect.right - dstRect.left;
                                        DstHeight = dstRect.bottom - dstRect.top;
                                        dstRect.top = p.y;
                                        dstRect.left = p.x;
                                        dstRect.bottom = dstRect.top + DstHeight;
                                        dstRect.right  = dstRect.left + DstWidth;
                        }
                        else
                        {
                                        if(!GUI.FullScreen)
                                        {
                                           int width = GUI.Res_X[Options.Adjustwindow];
                                           int height = GUI.Res_Y[Options.Adjustwindow];

                                           if (ExtendHeight)
                                           height = GUI.Res_Y_EX[Options.Adjustwindow];

                                           p.x = ((dstRect.right - dstRect.left) - width) / 2;
                                           p.y = ((dstRect.bottom - dstRect.top) - height) / 2;
                                           ClientToScreen (GUI.hWnd, &p);

                                           dstRect.top = p.y;
                                           dstRect.left = p.x;
                                           dstRect.bottom = dstRect.top + height;
                                           dstRect.right  = dstRect.left + width;
                                        
                                        }
                                        else
                                        {
                                           int width = GUI.Res_X[Options.Full_Adjustwindow];
                                           int height = GUI.Res_Y[Options.Full_Adjustwindow];

                                           if (ExtendHeight)
                                           height = GUI.Res_Y_EX[Options.Full_Adjustwindow];

                                           p.x = ((dstRect.right - dstRect.left) - width) / 2;
                                           p.y = ((dstRect.bottom - dstRect.top) - height) / 2;
                                           ClientToScreen (GUI.hWnd, &p);

                                           dstRect.top = p.y;
                                           dstRect.left = p.x;
                                           dstRect.bottom = dstRect.top + height;
                                           dstRect.right  = dstRect.left + width;
                                        }
                        }
	}
	else
	{
		p.x = ((dstRect.right - dstRect.left) - DstWidth) / 2;
		p.y = ((dstRect.bottom - dstRect.top) - DstHeight) / 2;
		ClientToScreen (hWnd, &p);
		dstRect.top = p.y;
		dstRect.left = p.x;
		dstRect.bottom = dstRect.top + DstHeight;
		dstRect.right  = dstRect.left + DstWidth;
	}
	if(!DirectX.lpDDSPrimary2 && DirectX.lpDDSPrimary) {
		if(DirectX.wait_for_vsync)
			DirectX.lpDD->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);
		DirectX.lpDDSPrimary -> Blt( &dstRect, DirectX.lpDDSOffScreen, &srcRect, DDBLT_WAIT, NULL);
	}
	else if(DirectX.lpDDSPrimary2 && !DirectX.lpDDSPrimary) {
		if(DirectX.wait_for_vsync)
			DirectX.lpDD->WaitForVerticalBlank(DDWAITVB_BLOCKBEGIN,0);
		DirectX.lpDDSPrimary2 -> Blt( &dstRect, DirectX.lpDDSOffScreen2, &srcRect, DDBLT_WAIT, NULL);
	}
}

void SetPriorityClassAndThreadPriority(DWORD priocl, int threadprio)
{
	SetPriorityClass(GetCurrentProcess(), priocl);
	SetThreadPriority(GetCurrentThread(), threadprio);
}

static HANDLE hFrameTimerSemaphore;
volatile unsigned long LastSound = 0;

VOID CALLBACK SoundTimer (UINT idEvent, UINT uMsg, DWORD dwUser, 
                          DWORD dw1, DWORD dw2)
{
	if(!Xppsystem.OldFrameTimer)
	{
	    void ProcessSound (void);
	
	        S9xSpinWaitLoop();
	        ProcessSound ();
	}
	else
	{
		while( (timeGetTime() - LastSound) >= _interval)
		{
			LastSound += _interval;

			void ProcessSound( void);
			ProcessSound();
			S9xSpinWaitLoop();
		}
	}
}

VOID CALLBACK FrameTimer( UINT idEvent, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{

	if(!Xppsystem.OldFrameTimer)
	{
		if( GUI.hFrameTimer != idEvent)
		{	return;	}

	    QueryPerformanceCounter((LARGE_INTEGER*)&PCEnd);
	    while ((PCEnd - PCStart) >= PCFrameTime)
	    {
			if( GUI.PauseEmulation || GUI.StopEmulation || GUI.ForcedPauseEmulation) {
				WaitForSingleObject (GUI.FrameTimerSemaphore, 0);
			}
			else {
				ReleaseSemaphore (GUI.FrameTimerSemaphore, 1, NULL);
			}
			
			S9xSpinWaitLoop();
		    PCStart += PCFrameTime;
	    }
	}
	else
	{
		static unsigned long Xpp_NtscCount = 0;
		int temp_timer;
		int Xpp_NtscCycle [6] = {16, 17, 17, 16, 17, 17};

		if( GUI.hFrameTimer != idEvent)
		{	return;	}
	
		if( timeGetTime() < GUI.FrameTimerStart);
		else {
			if(Settings.FrameTime == 16) {
				temp_timer = Settings.FrameTime;
				if(Xpp_NtscCount >= 6) Xpp_NtscCount = 0;
				Settings.FrameTime = Xpp_NtscCycle [Xpp_NtscCount];
				GUI.FrameTimerStart = GUI.FrameTimerStart + Settings.FrameTime;
				++Xpp_NtscCount;
				Settings.FrameTime = temp_timer;
			}
			else
				GUI.FrameTimerStart = GUI.FrameTimerStart + Settings.FrameTime;

			if( GUI.PauseEmulation || GUI.StopEmulation || GUI.ForcedPauseEmulation) {
				WaitForSingleObject (hFrameTimerSemaphore, 0);
			}
			else {
				ReleaseSemaphore (hFrameTimerSemaphore, 1, NULL);
			}
		}
	}
	return;
	
}

void ResetFrameTimer ()
{
    if (Settings.FrameTime == Settings.FrameTimeNTSC) PCFrameTime = PCFrameTimeNTSC;
    else if (Settings.FrameTime == Settings.FrameTimePAL) PCFrameTime = PCFrameTimePAL;
    else PCFrameTime = (__int64)((float)(PCBase * Settings.FrameTime) * .001f);

/*
    if (GUI.hFrameTimer)
        timeKillEvent (GUI.hFrameTimer);
	
    GUI.hFrameTimer = timeSetEvent (Settings.FrameTime, 0, FrameTimer,
		0, TIME_PERIODIC);
*/
}

/*****************************************************************************/
/* WinMain                                                                   */
/*****************************************************************************/


int WINAPI WinMain( 
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR lpCmdLine,
	int nCmdShow)
{
	MSG msg;
	HACCEL hAccel;
	DWORD wSoundTimerRes = 0;
	EmuExecLoop = S9xMainLoop;

    FillMemory ((PVOID)&Settings, sizeof (Settings), 0);
    FillMemory ((PVOID)&GUI, sizeof (GUI), 0);

//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);

	GUI.StopEmulation = true;

	GUI.dwStyleWindowed = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_VISIBLE | WS_THICKFRAME;
	GUI.dwStyleFullScreen = WS_POPUP|WS_VISIBLE;

	//256x239̃EChETCYvZ
	SetRect(&rc, 0, 0, 256, 239);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeW = rc.right - rc.left;
	DefaultWindowSizeH = rc.bottom - rc.top;
	DefaultWindowSizeWW[0] = rc.right - rc.left;
	DefaultWindowSizeHH[0] = rc.bottom - rc.top;
	GUI.Res_X[0] = 256;
	GUI.Res_Y[0] = 224;
	GUI.Res_Y_EX[0] = 239;

	//512x478̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(1,512,448,478)

	//768x717̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(2,768,672,717)

	//1024x956̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(3,1024,896,956)

	//1280x1195̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(4,1280,1130,1195)

	//1536x1434̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(5,1536,1344,1434)

	//637x478̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(6,637,448,478)

	//956x717̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(7,956,672,717)

	//1275x956̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(8,1275,896,956)

	//1593x1195̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(9,1593,1130,1195)

	//1912x1434̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(10,1912,1344,1434)

	//512x384̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(11,512,360,384)

	//768x576̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(12,768,540,576)

	//1024x768̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(13,1024,720,768)

	//1280x960̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(14,1280,900,960)

	//1536x1152̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(15,1536,1080,1152)

	//2048x1536̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(16,2048,1440,1536)

	//1024x717̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(17,1024,672,717)

	//1280x956̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(18,1280,896,956)

	//1536x1195̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(19,1536,1130,1195)

	//1792x1195̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(20,1792,1130,1195)

	//2048x1434̃EChETCYvZ
	DEFAULT_SCREEN_SIZE_SET(21,2048,1344,1434)

	//256x239̃EChETCYvZ
	SetRect(&rc, 0, 0, 275, 258);
	AdjustWindowRect(&rc, GUI.dwStyleWindowed, TRUE);
	DefaultWindowSizeWW[22] = rc.right - rc.left;
	DefaultWindowSizeHH[22] = rc.bottom - rc.top;
	GUI.Res_X[22] = 256;
	GUI.Res_Y[22] = 224;
	GUI.Res_Y_EX[22] = 239;

	WinLoad();
	WinInit( hInstance);

	if( !DirectX_Initialize(GUI.hWnd, GUI.dwStyleWindowed, GUI.dwStyleFullScreen))
	{
		MessageBox( GUI.hWnd, Languages[ GUI.Language].errInitDD, "Snes9X - DirectX", MB_OK | MB_ICONSTOP);
		return false; 
	}
	
	if( !DirectX_SetDisplayMode(DisplayMode[CurFullscreenDisplayModeIndex].Width, DisplayMode[CurFullscreenDisplayModeIndex].Height, DisplayMode[CurFullscreenDisplayModeIndex].Depth, TRUE, GUI.DoubleBuffered))
	{
		MessageBox( GUI.hWnd, Languages[ GUI.Language].errModeDD, "Snes9X - DirectDraw", MB_OK | MB_ICONSTOP);
		DirectX_DeInitialize();
		return false; 
	}
	GUI.ScreenDepth = (DWORD)DirectX.Depth;

	if( GUI.SoundMode == -1)
	{	SetupSound( 0, false, false);	}
	else
	if( !SetupSound( SoundRates[GUI.SoundMode].rate, SoundRates[GUI.SoundMode].sixteen_bit, SoundRates[GUI.SoundMode].stereo))
	{	MessageBox( GUI.hWnd, Languages[ GUI.Language].errInitDS, "Snes9X - DirectSound", MB_OK | MB_ICONINFORMATION);	}

//	GUI.StopEmulation = true;
	
	TIMECAPS tc;
	if( timeGetDevCaps(&tc, sizeof(TIMECAPS))== TIMERR_NOERROR)
	{
		wSoundTimerRes = tc.wPeriodMin;
		timeBeginPeriod( wSoundTimerRes);
	}

    DWORD process;
    DWORD system;
    DWORD newaffinitymask;

    if(GetProcessAffinityMask(GetCurrentProcess(), &process, &system) != 0) {
        newaffinitymask = 1;
        while((process & newaffinitymask) == 0)
            newaffinitymask <<= 1;
        SetProcessAffinityMask(GetCurrentProcess(), newaffinitymask);
    }

	LastSound = GUI.FrameTimerStart = timeGetTime();
	GUI.FrameTimerStart += Settings.FrameTime;

    QueryPerformanceFrequency((LARGE_INTEGER*)&PCBase);
    QueryPerformanceCounter((LARGE_INTEGER*)&PCStart);
    PCFrameTime = PCFrameTimeNTSC = (__int64)((float)PCBase / 59.948743718592964824120603015098f);
    PCFrameTimePAL = PCBase / 50;

	hFrameTimerSemaphore = GUI.FrameTimerSemaphore = CreateSemaphore(NULL, 0, 10, "Snes9xppW - FrameTimerSemaphore");
	if( GUI.FrameTimerSemaphore)
	{
		GUI.hFrameTimer = timeSetEvent(wSoundTimerRes, 0, &FrameTimer, 0, TIME_PERIODIC);
        GUI.hSoundTimer = timeSetEvent (5, 0, &SoundTimer, 0, TIME_PERIODIC);
		if(!GUI.hFrameTimer)
		{
			CloseHandle( GUI.FrameTimerSemaphore);
			GUI.FrameTimerSemaphore = 0;
		}
	}

	if( !GUI.hFrameTimer || !GUI.FrameTimerSemaphore)
	{
		MessageBox( GUI.hWnd, Languages[ GUI.Language].errFrameTimer, "Snes9X - Frame Timer", MB_OK | MB_ICONINFORMATION);
	}

	if(!InitSnes9X())
		S9xExitFlag = 1;

	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(AACCEL));

	while( TRUE)
	{
		S9xSpinWaitLoop();
              while (GUI.StopEmulation || GUI.PauseEmulation ||
                     GUI.ForcedPauseEmulation ||
                PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE))
		{
			S9xSpinWaitLoop();
		
			if( !GetMessage( &msg, NULL, 0, 0))
                    goto loop_exit;
			if (!TranslateAccelerator(GUI.hWnd, hAccel, &msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		if( !GUI.StopEmulation && !GUI.PauseEmulation && !GUI.ForcedPauseEmulation)
			EmuExecLoop();
	}

loop_exit:

    if (GUI.hSoundTimer)
        timeKillEvent (GUI.hSoundTimer);
	if( GUI.hFrameTimer)
		timeKillEvent( GUI.hFrameTimer);
	if( GUI.FrameTimerSemaphore)
		CloseHandle( GUI.FrameTimerSemaphore);
	if(wSoundTimerRes)
		timeEndPeriod( wSoundTimerRes);

	if( !GUI.StopEmulation && EmuExecLoop == S9xMainLoop) {
		Memory.SaveSRAM( S9xGetFilename(".srm"));
		S9xSaveCheatFile(S9xGetFilename(".cht"));
              if(Xppcdda.Enable) cdda_exit(); // Snes9xpp Original
              XPP_REPLAY_END ();
	}
	WinSave();

/* Ǐn */
	DeinitSnes9X();

//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);

	return msg.wParam;
}

/*****************************************************************************/
