/*****************************************************************************/
/*  Snes9X: Win32                                                            */
/*****************************************************************************/
#if !defined(SNES9X_H_INCLUDED)
#define SNES9X_H_INCLUDED
/*****************************************************************************/

#include <stdlib.h>
#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>
#include "mmjoyfix.h"
#include "resource.h"

/*****************************************************************************/

struct sGUI {
	HWND hWnd;
	HMENU hMenu;
	bool AppMenuConnect;
	HMENU hVolMenu;
	HMENU hSysMenu;
	HMENU hRecentGamesMenu;
	HINSTANCE hInstance;
	DWORD dwStyleWindowed;
	DWORD dwStyleFullScreen;

	DWORD hFrameTimer;
	HANDLE FrameTimerSemaphore;
	DWORD FrameTimerStart;

	DWORD hSoundTimer;

	BYTE Language;

	int SoundMode;
	bool Stereo;

	volatile bool ForcedPauseEmulation;
	volatile bool PauseEmulation;
	volatile bool StopEmulation;

	int Scale;
	bool DoubleBuffered;
	bool NeedDepthConvert;
	DWORD ScreenDepth;
	bool ScreenCleared;
	int RedShift;
	int GreenShift;
	int BlueShift;

	char FreezeFileDir[_MAX_PATH];
	int MouseX;
	int MouseY;
	bool IgnoreNextMouseMove;
	unsigned long MouseButtons;

	int Stretch;
	int FullScreen_Stretch;
	bool FullScreen;
	DWORD PriorityClass;
	int ThreadPriority;

	int Res_X[23];
	int Res_Y[23];
	int Res_Y_EX[23];

	int FullScreen_X;
	int FullScreen_Y;

};

struct sLanguages {
	int idMenu;
	char *errInitDD;
	char *errModeDD;
	char *errInitDS;
	char *ApplyNeedRestart;
	char *errFrameTimer;
	char *S9xExitMessage;
	char *errMemoryInit;
	char *errSwitchGFX;
	char *errInitDI;
};

struct SSoundRates
{
	long rate;
	unsigned char stereo;
	unsigned char sixteen_bit;
//	int ident;
};

/*****************************************************************************/

extern "C" struct sGUI GUI;
extern struct sLanguages Languages[];
extern void S9xSetWindowPos();
/*****************************************************************************/

#endif // !defined(SNES9X_H_INCLUDED)
