#include "../snes9x/snes9x.h"

extern "C" void S9xSpinWaitLoop(void);

extern "C" {
unsigned char InterlaceFlag = FALSE;
unsigned char ScanlinesFlag = FALSE;
unsigned char ScanlinesFlag_Def = FALSE;
}

#define SCANLINES_COLOR(v,s) \
{ \
		       int Xb,Xg,Xr; \
		       int Scan = s; \
		       \
		       Xb = (v & 0x1F); \
		       Xg = (v & 0x7E0) >> 5; \
		       Xr = (v & 0xf800) >> 11; \
		       \
		       Xb = (Xb*(100-Scan))/100; \
		       Xg = (Xg*(100-Scan))/100; \
		       Xr = (Xr*(100-Scan))/100; \
		       darkened = Xb + (Xg << 5) + (Xr << 11); \
}		       

#define SCANLINES_COLOR_2(s) \
{ \
		       int Xb,Xg,Xr; \
		       int Scan = s; \
		       \
		       Xb = (currentPixel & 0x1F); \
		       Xg = (currentPixel & 0x7E0) >> 5; \
		       Xr = (currentPixel & 0xf800) >> 11; \
		       \
		       Xb = (Xb*(100-Scan))/100; \
		       Xg = (Xg*(100-Scan))/100; \
		       Xr = (Xr*(100-Scan))/100; \
		       darkened = Xb + (Xg << 5) + (Xr << 11); \
		       \
		       Xb = (currentPixel & 0x1F0000) >> 16; \
		       Xg = (currentPixel & 0x7E00000) >> 21; \
		       Xr = (currentPixel & 0xf8000000) >> 27; \
		       Xb = (Xb*(100-Scan))/100; \
		       Xg = (Xg*(100-Scan))/100; \
		       Xr = (Xr*(100-Scan))/100; \
		       darkened = darkened + (Xb << 16) + (Xg << 21) + (Xr << 27); \
}

#define INTERLACE_COLOR_SET \
		    uint32 product, darkened_a_1,darkened_a_2,darkened_a_3,darkened_b_1,darkened_b_2,darkened_b_3; \
			uint32 colorA, colorB; \
			colorA = currentPixel & 0xffff; \
		    colorB = (currentPixel & 0xffff0000) >> 16; \
\
		    *(xP - 1) = currentPixel; \
		    darkened_a_1 = (product = ((colorA & colorMask) >> 1)); \
\
		    darkened_a_2 = (product = ((colorA & colorMask) >> 1)); \
		    darkened_a_2 += (product = ((product & colorMask) >> 1)); \
\
		    darkened_a_3 = (product = ((colorA & colorMask) >> 1)); \
		    darkened_a_3 += (product = ((product & colorMask) >> 1)); \
		    darkened_a_3 += (product & colorMask) >> 1; \
\
		    darkened_b_1 = (product = ((colorB & colorMask) >> 1)); \
\
		    darkened_b_2 = (product = ((colorB & colorMask) >> 1)); \
		    darkened_b_2 += (product = ((product & colorMask) >> 1)); \
\
		    darkened_b_3 = (product = ((colorB & colorMask) >> 1)); \
		    darkened_b_3 += (product = ((product & colorMask) >> 1)); \
		    darkened_b_3 += (product & colorMask) >> 1; \



void TVMode (uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height)
{
    uint8 *nextLine, *finish;
    uint32 colorMask = ~(RGB_LOW_BITS_MASK | (RGB_LOW_BITS_MASK << 16));
    uint32 lowPixelMask = RGB_LOW_BITS_MASK;

    ScanlinesFlag = 0;
    nextLine = dstPtr + dstPitch;

    if (width == 256)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 *nL = (uint32 *) nextLine;
	    uint32 currentPixel;
	    uint32 nextPixel;
	    uint32 currentDelta;
	    uint32 nextDelta;

	    finish = (uint8 *) bP + (width << 1);
	    nextPixel = *bP++;
	    nextDelta = *xP++;

	    do
	    {
		currentPixel = nextPixel;
		currentDelta = nextDelta;
		nextPixel = *bP++;
		nextDelta = *xP++;

		if ((nextPixel != nextDelta) || (currentPixel != currentDelta))
		{
		    uint32 colorA, colorB, product, darkened;

		    *(xP - 2) = currentPixel;
#ifdef LSB_FIRST
		    colorA = currentPixel & 0xffff;
#else
		    colorA = (currentPixel & 0xffff0000) >> 16;
#endif

#ifdef LSB_FIRST
		    colorB = (currentPixel & 0xffff0000) >> 16;
		    *(dP) = product = colorA |
				      ((((colorA & colorMask) >> 1) +
					((colorB & colorMask) >> 1) +
					(colorA & colorB & lowPixelMask)) << 16);
#else
		    colorB = currentPixel & 0xffff;
		    *(dP) = product = (colorA << 16) | 
				      (((colorA & colorMask) >> 1) +
				       ((colorB & colorMask) >> 1) +
				       (colorA & colorB & lowPixelMask));
#endif
		    darkened = (product = ((product & colorMask) >> 1));
		    darkened += (product = ((product & colorMask) >> 1));
		    darkened += (product & colorMask) >> 1;
		    *(nL) = darkened;

#ifdef LSB_FIRST
		    colorA = nextPixel & 0xffff;
		    *(dP + 1) = product = colorB |
					  ((((colorA & colorMask) >> 1) +
					    ((colorB & colorMask) >> 1) +
					    (colorA & colorB & lowPixelMask)) << 16);
#else
		    colorA = (nextPixel & 0xffff0000) >> 16;
		    *(dP + 1) = product = (colorB << 16) | 
					   (((colorA & colorMask) >> 1) +
					    ((colorB & colorMask) >> 1) + 
					    (colorA & colorB & lowPixelMask));
#endif
		    darkened = (product = ((product & colorMask) >> 1));
		    darkened += (product = ((product & colorMask) >> 1));
		    darkened += (product & colorMask) >> 1;
		    *(nL + 1) = darkened;
		}

		dP += 2;
		nL += 2;
	    }
	    while ((uint8 *) bP < finish);

	    {
		currentPixel = nextPixel;
		currentDelta = nextDelta;
		nextPixel = *bP++;
		nextDelta = *xP++;

		if ((nextPixel != nextDelta) || (currentPixel != currentDelta))
		{
		    uint32 colorA, colorB, product, darkened;

		    *(xP - 2) = currentPixel;
#ifdef LSB_FIRST
		    colorA = currentPixel & 0xffff;
#else
		    colorA = (currentPixel & 0xffff0000) >> 16;
#endif

#ifdef LSB_FIRST
		    colorB = (currentPixel & 0xffff0000) >> 16;
		    *(dP) = product = colorA |
				      ((((colorA & colorMask) >> 1) +
					((colorB & colorMask) >> 1) +
					(colorA & colorB & lowPixelMask)) << 16);
#else
		    colorB = currentPixel & 0xffff;
		    *(dP) = product = (colorA << 16) | 
				      (((colorA & colorMask) >> 1) +
				       ((colorB & colorMask) >> 1) +
				       (colorA & colorB & lowPixelMask));
#endif
		    darkened = (product = ((product & colorMask) >> 1));
		    darkened += (product = ((product & colorMask) >> 1));
		    darkened += (product & colorMask) >> 1;
		    *(nL) = darkened;
		    *(dP + 1) = 0;
		    *(nL + 1) = 0;
		}

		dP += 2;
		nL += 2;
	    }

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	    nextLine += dstPitch * 2;
	}
	while (--height);
    }
    else if(width == 512 && height <= 239)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{
		    uint32 product, darkened;

		    *(xP - 1) = currentPixel;
		    *dP = currentPixel;
		    darkened = (product = ((currentPixel & colorMask) >> 1));
		    darkened += (product = ((product & colorMask) >> 1));
		    darkened += (product & colorMask) >> 1;
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened;
		}

		dP++;
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	}
	while (--height);
    }
    else
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{
		    uint32 product, darkened;

		    *(xP - 1) = currentPixel;
		    
		    darkened = (product = ((currentPixel & colorMask) >> 1));
		    darkened += (product = ((product & colorMask) >> 1));
		    darkened += (product & colorMask) >> 1;

		    if(ScanlinesFlag)
		    {
		       *dP = currentPixel;
		    }
		    else
		    {
		    
		       *dP = darkened;
		    }
		}

		dP++;
		
	    }
	    while ((uint8 *) bP < finish);
	    ScanlinesFlag ^= 1;
	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch;
	}
	while (--height);
    }
}

void FakeTV (uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height)
{
    uint8 *nextLine, *finish;
    nextLine = dstPtr + dstPitch;
    ScanlinesFlag = 0;
    int Scan_Color = 0;

    switch (Options.ScanLinesEffect)
	{
	 case 1:
	 Scan_Color = 100;
	 break;
	 
	 case 2:
	 Scan_Color = 75;
	 break;
	 
	 case 3:
	 Scan_Color = 50;
	 break;
	 
	 case 4:
	 Scan_Color = 25;
	 break;
	 
	 case 5:
	 Scan_Color = 0;
	 break;
	 
	 default:
	 Scan_Color = 100;
	 break;
	}
    
    if (width == 256)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 *nL = (uint32 *) nextLine;
	    uint32 currentPixel;
	    uint32 nextPixel;
	    uint32 currentDelta;
	    uint32 nextDelta;

	    finish = (uint8 *) bP + (width +1<< 1);
	    nextPixel = *bP++;
	    nextDelta = *xP++;

	    do
	    {
		currentPixel = nextPixel;
		currentDelta = nextDelta;
		nextPixel = *bP++;
		nextDelta = *xP++;

		if ((nextPixel != nextDelta) || (currentPixel != currentDelta))
		{
		    uint32 colorA, colorB;
		    uint32 darkened;

		    *(xP - 2) = currentPixel;
		    colorA = currentPixel & 0xffff;
		    colorB = (currentPixel & 0xffff0000) >> 16;
		    *(dP) = colorA + (colorA << 16);

		    SCANLINES_COLOR(colorA,Scan_Color)
		    *(nL) = darkened + (darkened << 16);

		    *(dP + 1) = colorB + (colorB << 16);

		    SCANLINES_COLOR(colorB,Scan_Color)
		    *(nL + 1) = darkened + (darkened << 16);
		}

		dP += 2;
		nL += 2;
		
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	    nextLine += dstPitch * 2;
	}
	while (--height);
    }
    else if(width == 512 && height <= 239)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{
		    *(xP - 1) = currentPixel;
		    *dP = currentPixel;
		    uint32 darkened;
		    SCANLINES_COLOR_2(Scan_Color)
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened;
		    
		}
		dP++;
		
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	}
	while (--height);
    }
    else
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{
		    *(xP - 1) = currentPixel;
		    if(ScanlinesFlag)
		    {
		       *dP = currentPixel;
		    }
		    else
		    {
		    
		       uint32 darkened;

		       SCANLINES_COLOR_2(Scan_Color)
		       *dP = darkened;
		    }
		}
		dP++;
		
	    }
	    while ((uint8 *) bP < finish);
	    ScanlinesFlag ^= 1;
	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch;
	}
	while (--height);
    }
}

// New ScanLine (Interlace Base)

void InterlaceScanLines (uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height)
{
    uint8 *nextLine, *finish;
    uint32 colorMask = ~(RGB_LOW_BITS_MASK | (RGB_LOW_BITS_MASK << 16));

    ScanlinesFlag = ScanlinesFlag_Def;
    ScanlinesFlag_Def ^= 1;
    InterlaceFlag++;
    if(InterlaceFlag>3)InterlaceFlag=0;
    nextLine = dstPtr + dstPitch;

    if (width == 256)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{

		  if(InterlaceFlag == 0)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_a_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (darkened_a_1 << 16);

		    *(dP + 1) = colorB + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) = darkened_b_1 + (darkened_b_1 << 16);
		  }
		  else if(InterlaceFlag == 1)
		  {
		    INTERLACE_COLOR_SET

		    *dP = darkened_a_3 + (colorA << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (!Options.AltScreenEffect ? (darkened_a_1  << 16): (((rand () & 0x3) != 0) ? (darkened_a_1 << 16) : (darkened_b_1 << 16)));

		    *(dP + 1) = darkened_b_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) = darkened_b_1 + (darkened_b_1 << 16);
		  }
		  else if(InterlaceFlag == 2)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_a_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (darkened_a_1 << 16);

		    *(dP + 1) = colorB + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) = darkened_b_1 + (darkened_b_1 << 16);
		  }
		  else if(InterlaceFlag == 3)
		  {
		    INTERLACE_COLOR_SET

		    *dP = darkened_a_3 + (colorA << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (darkened_a_1 << 16);

		    *(dP + 1) = darkened_b_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) =  (!Options.AltScreenEffect ? (darkened_b_1): (((rand () & 0x3) != 0) ? (darkened_b_1) : (darkened_a_1))) + (darkened_b_1 << 16);
		  }
		}

		dP+=2;
		
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	}
	while (--height);
    }
    else if(width == 512 && height <= 239)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{
		
		  if(InterlaceFlag == 0)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (darkened_b_1 << 16);
		  }
		  else if(InterlaceFlag == 1)
		  {
		    INTERLACE_COLOR_SET
		    *dP = darkened_a_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = (!Options.AltScreenEffect ? (darkened_a_1) : (((rand () & 0x3) != 0) ? (darkened_a_1) : (darkened_b_1))) + (darkened_b_1 << 16);
		  }
		  else if(InterlaceFlag == 2)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (darkened_b_1 << 16);
		  }
		  else if(InterlaceFlag == 3)
		  {
		    INTERLACE_COLOR_SET

		    *dP = darkened_a_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_1 + (!Options.AltScreenEffect ? (darkened_b_1  << 16): (((rand () & 0x3) != 0) ? (darkened_b_1 << 16) : (darkened_a_1 << 16)));
		  }
		}

		dP++;
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	}
	while (--height);
	}
    else
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;
//		if (currentPixel != *xP++)
		{
		
		  if(InterlaceFlag == 0)
		  {
		    INTERLACE_COLOR_SET
		    
		    if(ScanlinesFlag)
		    {
		      *dP = colorA + (darkened_b_3 << 16);
		    }
		    else
		    {
		      *dP = darkened_a_1 + (darkened_b_1 << 16);
		    }
		  }
		  else if(InterlaceFlag == 1)
		  {
		    INTERLACE_COLOR_SET

		    if(ScanlinesFlag)
		    {
		      *dP = darkened_a_3 + (colorB << 16);
		    }
		    else
		    {
		      *dP = (!Options.AltScreenEffect ? (darkened_a_1): (((rand () & 0x3) != 0) ? (darkened_a_1) : (darkened_b_1))) + (darkened_b_1 << 16);
		    }
		  }
		  else if(InterlaceFlag == 2)
		  {
		    INTERLACE_COLOR_SET

		    if(ScanlinesFlag)
		    {
		      *dP = colorA + (darkened_b_3 << 16);
		    }
		    else
		    {
		      *dP = darkened_a_1 + (darkened_b_1 << 16);
		    }
		  }
		  else if(InterlaceFlag == 3)
		  {
		    INTERLACE_COLOR_SET

		    if(ScanlinesFlag)
		    {
		      *dP = darkened_a_3 + (colorB << 16);
		    }
		    else
		    {
		      *dP = darkened_a_1 + (!Options.AltScreenEffect ? (darkened_b_1  << 16): (((rand () & 0x3) != 0) ? (darkened_b_1 << 16) : (darkened_a_1 << 16)));
		    }
		  }
		}

		dP++;
	    }
	    while ((uint8 *) bP < finish);

	    ScanlinesFlag ^= 1;
	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch;
	}
	while (--height);
    }
}

void Interlace (uint8 *srcPtr, uint32 srcPitch, uint8 *deltaPtr,
	     uint8 *dstPtr, uint32 dstPitch, int width, int height)
{
    uint8 *nextLine, *finish;
    uint32 colorMask = ~(RGB_LOW_BITS_MASK | (RGB_LOW_BITS_MASK << 16));

    ScanlinesFlag = ScanlinesFlag_Def;
    ScanlinesFlag_Def ^= 1;
    InterlaceFlag++;
    if(InterlaceFlag>3)InterlaceFlag=0;
    nextLine = dstPtr + dstPitch;

    if (width == 256)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{

		  if(InterlaceFlag == 0)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_a_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (darkened_a_2 << 16);

		    *(dP + 1) = colorB + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) = darkened_b_2 + (darkened_b_2 << 16);
		  }
		  else if(InterlaceFlag == 1)
		  {
		    INTERLACE_COLOR_SET

		    *dP = darkened_a_3 + (colorA << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (!Options.AltScreenEffect ? (darkened_a_2  << 16): (((rand () & 0x3) != 0) ? (darkened_a_2 << 16) : (darkened_b_2 << 16)));

		    *(dP + 1) = darkened_b_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) = darkened_b_2 + (darkened_b_2 << 16);
		  }
		  else if(InterlaceFlag == 2)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_a_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (darkened_a_2 << 16);

		    *(dP + 1) = colorB + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) = darkened_b_2 + (darkened_b_2 << 16);
		  }
		  else if(InterlaceFlag == 3)
		  {
		    INTERLACE_COLOR_SET

		    *dP = darkened_a_3 + (colorA << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (darkened_a_2 << 16);

		    *(dP + 1) = darkened_b_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) (dP + 1) + dstPitch) =  (!Options.AltScreenEffect ? (darkened_b_2): (((rand () & 0x3) != 0) ? (darkened_b_2) : (darkened_a_2))) + (darkened_b_2 << 16);
		  }
		}

		dP+=2;
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	}
	while (--height);
    }
    else if(width == 512 && height <= 239)
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;

//		if (currentPixel != *xP++)
		{
		
		  if(InterlaceFlag == 0)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (darkened_b_2 << 16);
		  }
		  else if(InterlaceFlag == 1)
		  {
		    INTERLACE_COLOR_SET
		    *dP = darkened_a_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = (!Options.AltScreenEffect ? (darkened_a_2) : (((rand () & 0x3) != 0) ? (darkened_a_2) : (darkened_b_2))) + (darkened_b_2 << 16);
		  }
		  else if(InterlaceFlag == 2)
		  {
		    INTERLACE_COLOR_SET

		    *dP = colorA + (darkened_b_3 << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (darkened_b_2 << 16);
		  }
		  else if(InterlaceFlag == 3)
		  {
		    INTERLACE_COLOR_SET

		    *dP = darkened_a_3 + (colorB << 16);
		    *(uint32 *) ((uint8 *) dP + dstPitch) = darkened_a_2 + (!Options.AltScreenEffect ? (darkened_b_2  << 16): (((rand () & 0x3) != 0) ? (darkened_b_2 << 16) : (darkened_a_2 << 16)));
		  }
		}

		dP++;
	    }
	    while ((uint8 *) bP < finish);

	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch * 2;
	}
	while (--height);
	}
    else
    {
	do
	{
	    uint32 *bP = (uint32 *) srcPtr;
	    uint32 *xP = (uint32 *) deltaPtr;
	    uint32 *dP = (uint32 *) dstPtr;
	    uint32 currentPixel;

	    finish = (uint8 *) bP + (width << 1);

	    do
	    {
		currentPixel = *bP++;
//		if (currentPixel != *xP++)
		{
		
		  if(InterlaceFlag == 0)
		  {
		    INTERLACE_COLOR_SET
		    
		    if(ScanlinesFlag)
		    {
		      *dP = colorA + (darkened_b_3 << 16);
		    }
		    else
		    {
		      *dP = darkened_a_2 + (darkened_b_2 << 16);
		    }
		  }
		  else if(InterlaceFlag == 1)
		  {
		    INTERLACE_COLOR_SET

		    if(ScanlinesFlag)
		    {
		      *dP = darkened_a_3 + (colorB << 16);
		    }
		    else
		    {
		      *dP = (!Options.AltScreenEffect ? (darkened_a_2): (((rand () & 0x3) != 0) ? (darkened_a_2) : (darkened_b_2))) + (darkened_b_2 << 16);
		    }
		  }
		  else if(InterlaceFlag == 2)
		  {
		    INTERLACE_COLOR_SET

		    if(ScanlinesFlag)
		    {
		      *dP = colorA + (darkened_b_3 << 16);
		    }
		    else
		    {
		      *dP = darkened_a_2 + (darkened_b_2 << 16);
		    }
		  }
		  else if(InterlaceFlag == 3)
		  {
		    INTERLACE_COLOR_SET

		    if(ScanlinesFlag)
		    {
		      *dP = darkened_a_3 + (colorB << 16);
		    }
		    else
		    {
		      *dP = darkened_a_2 + (!Options.AltScreenEffect ? (darkened_b_2  << 16): (((rand () & 0x3) != 0) ? (darkened_b_2 << 16) : (darkened_a_2 << 16)));
		    }
		  }
		}

		dP++;
	    }
	    while ((uint8 *) bP < finish);

	    ScanlinesFlag ^= 1;
	    deltaPtr += srcPitch;
	    srcPtr += srcPitch;
	    dstPtr += dstPitch;
	}
	while (--height);
    }
}

